<?php

namespace FoodSearch\Dashboard_Settings;
use FoodSearch\Dashboard_Settings\Restaurant_Builder as Restaurant_Builder;
use FoodSearch\Dashboard_Settings\Customer_Builder as Customer_Builder;
use FoodSearch\Dashboard_Settings\Menu_Section_Elements as Section_Elements;

class Common_Functions {
    
    public $dashboard_menu_data;

    public function __construct() {
        
    }
    
    public function switch_button($id, $name, $value, $label) {
        ?>
        <div class="label_wrap"><label class="fds-input-label"><?php echo ($label) ?></label></div>
        <label for="<?php echo ($id) ?>" class="fds-switch fds-input-label">
            <input id="<?php echo ($id) ?>" type="checkbox" class="fds-settings-switch"<?php echo ($value == 'on' ? ' checked' : '') ?>>
            <strong class="fds-switch-inn">
                <span class="fds-off-switch"><?php echo esc_html_e('off', 'wp-foodsearch') ?></span>
                <span class="fds-on-switch"><?php echo esc_html_e('on', 'wp-foodsearch') ?></span>
            </strong>
            <input type="hidden" name="<?php echo ($name) ?>" value="<?php echo ($value) ?>">
        </label>
        <?php
    }
    
    public function dashboard_builder($type) {
        wp_enqueue_script('jquery-ui-draggable');
        wp_enqueue_script('foodsearch-dashboard-builder');
        
        $menus_list = get_option("foodsearch_dashboard_{$type}_menus_list");
        $this->dashboard_menu_data = $menus_list;
        ?>
        <div class="dashboard-builder-mainholdr" data-btype="<?php echo ($type) ?>">
            <div class="dashboard-builder-inercon">
                <div class="no-dashmenu-found"<?php echo (!empty($menus_list) ? ' style="display:none;"' : '') ?>>
                    <p><?php echo esc_html_e('no dashboard menu added.', 'wp-foodsearch') ?></p>
                </div>
                <div class="builder-menu-mainholdr">
                    <?php
                    if (!empty($menus_list)) {
                        uasort($menus_list, function ($a, $b) {
                            if ($a['sort'] == $b['sort']) {
                                $ret_val = 0;
                            }
                            $ret_val = ($a['sort'] < $b['sort']) ? -1 : 1;
                            return $ret_val;
                        });
                        foreach ($menus_list as $menu_id => $menu_data) {
                            echo ($this->menu_item_html($type, $menu_id, $menu_data));
                        }
                    }
                    ?>
                </div>
                <div class="builder-menu-addbtn fds-btn fds-medium-btn">
                    <a href="javascript:void(0);" class="fds-link" onclick="foodsearch_dashboard_builder.add_new_manu(this);" data-type="<?php echo ($type) ?>"><?php esc_html_e('add new menu', 'wp-foodsearch') ?></a>
                </div>
            </div>
        </div>
        <?php
    }

    public function menu_item_html($builder_type = 'restaurant', $id = 0, $menu_data = array()) {
        $rand_num = rand(1000000, 9999999);
        
        $menu_id = $rand_num;
        if ($id > 0) {
            $menu_id = $id;
        }
        
        $menu_label = 'Menu ' . $menu_id;
        $menu_slug = 'menu-' . $menu_id;
        $menu_icon = '';
        $menu_pos = 0;
        $addin_menu = true;
        if (isset($menu_data['label'])) {
            $addin_menu = false;
            $menu_label = $menu_data['label'];
            $menu_slug = isset($menu_data['slug']) ? $menu_data['slug'] : '';
            $menu_icon = isset($menu_data['icon']) ? $menu_data['icon'] : '';
            $menu_pos = isset($menu_data['sort']) ? $menu_data['sort'] : '';
        }

        $sects_list = isset($menu_data['sections']) ? $menu_data['sections'] : '';

        ob_start();
        ?>
        <div id="dashb-menu-itm<?php echo ($menu_id) ?>" data-id="<?php echo ($menu_id) ?>" class="dashb-menu-conitm">
            <div class="menu-conitm-hder">
                <div class="menu-itm-label">
                    <a class="menu-itm-sorter fds-link"><i class="fds-icon fds-move-drager"></i></a>
                    <a href="javascript:void(0);" class="menu-itm-lablholdr" onclick="foodsearch_dashboard_builder.open_menu_content(this);"><strong><?php echo ($menu_label) ?></strong></a>
                </div>
                <div class="menu-hdr-btns">
                    <a href="javascript:void(0);" class="dashb-menu-updatebtn fds-link" onclick="foodsearch_dashboard_builder.open_manu_settings(this);"><i class="dashicons-before dashicons-arrow-down-alt2"></i></a>
                    <a href="javascript:void(0);" class="dashb-show-secsetins fds-link" onclick="foodsearch_dashboard_builder.open_menuitem_contsetin_trigr(this);"><i class="dashicons-before dashicons-admin-generic"></i></a>
                    <a href="javascript:void(0);" class="dashb-menu-remvebtn fds-link" onclick="foodsearch_dashboard_builder.remove_menu_by_id(this, '<?php echo ($builder_type) ?>');"><i class="dashicons-before dashicons-trash"></i></a>
                </div>
                <input type="hidden" name="dashboard_menu_items[<?php echo ($menu_id) ?>][sort]" value="<?php echo ($menu_pos) ?>">
            </div>
            <div class="menu-conitm-contnt" style="display: none;">
                <div class="menu-elmsects-holdr">
                    <div class="menu-elments-list"<?php echo (empty($sects_list) ? ' style="display:none;"' : '') ?>>
                        <?php
                        $this->menu_elements($builder_type, $menu_id, $menu_data);
                        ?>
                    </div>
                    <div class="menu-all-sectscon">
                        <?php
                        if (!empty($sects_list)) {
                            uasort($sects_list, function ($a, $b) {
                                if ($a['sort'] == $b['sort']) {
                                    $ret_val = 0;
                                }
                                $ret_val = ($a['sort'] < $b['sort']) ? -1 : 1;
                                return $ret_val;
                            });
                            foreach ($sects_list as $sect_id => $sect_data) {
                                echo ($this->menu_item_section($builder_type, $sect_id, $sect_data));
                            }
                        }
                        ?>
                    </div>
                </div>
                <div class="menu-add-sectbtncon fds-btn fds-medium-btn">
                    <a href="javascript:void(0);" class="dashb-menu-insectbtn fds-link" onclick="foodsearch_dashboard_builder.addin_menu_section(this, '<?php echo ($builder_type) ?>');"><?php esc_html_e('add section', 'wp-foodsearch') ?></a>
                </div>
                <div class="menu-setinns" style="display: none;">
                    <div class="fds-form-field">
                        <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('menu label', 'wp-foodsearch') ?></label></div>
                        <input type="text" name="dashboard_menu_items[<?php echo ($menu_id) ?>][label]" class="fds-input-style" data-id="<?php echo ($menu_id) ?>" onkeyup="foodsearch_dashboard_builder.create_menu_slug(this)" value="<?php echo ($menu_label) ?>">
                    </div>
                    <div class="fds-form-field">
                        <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('slug', 'wp-foodsearch') ?></label></div>
                        <input type="text" name="dashboard_menu_items[<?php echo ($menu_id) ?>][slug]" class="fds-input-style" data-id="<?php echo ($menu_id) ?>" onchange="foodsearch_dashboard_builder.create_menu_slug(this)" value="<?php echo ($menu_slug) ?>">
                    </div>
                    <div class="fds-form-field">
                        <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('icon', 'wp-foodsearch') ?></label></div>
                        <input type="text" name="dashboard_menu_items[<?php echo ($menu_id) ?>][icon]" class="fds-input-style fds-fonticon-pickr" value="<?php echo ($menu_icon) ?>">
                    </div>
                </div>
            </div>
        </div>
        <?php
        $html = ob_get_clean();
        
        if ($addin_menu === false) {
            add_action('admin_footer', function() use($menu_id) {
                ?>
                <script>
                jQuery(document).ready(function() {foodsearch_dashboard_builder.init_sortable('<?php echo ($menu_id) ?>');});
                </script>
                <?php
            }, 40);
        }
        
        return $html;
    }
    
    public function save_menu_byid($menu_id, $builder_type, $post_data) {
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            $menus_list = !empty($menus_list) ? $menus_list : array();
            
            $savin_arr = isset($menus_list[$menu_id]) ? $menus_list[$menu_id] : array();
            if (isset($post_data['dashboard_menu_items'][$menu_id]) && !empty($post_data['dashboard_menu_items'][$menu_id])) {
                $menu_data = $post_data['dashboard_menu_items'][$menu_id];
                
                foreach ($menu_data as $menu_data_key => $menu_data_val) {
                    $savin_arr[$menu_data_key] = $menu_data_val;
                }
            }
            if (!empty($savin_arr)) {
                $menus_list[$menu_id] = $savin_arr;
                update_option("foodsearch_dashboard_{$builder_type}_menus_list", $menus_list);
            }
        }
    }
    
    public function remove_menu_byid($menu_id, $builder_type) {
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            
            if (!empty($menus_list) && isset($menus_list[$menu_id])) {
                unset($menus_list[$menu_id]);
                update_option("foodsearch_dashboard_{$builder_type}_menus_list", $menus_list);
            }
        }
    }
    
    public function menu_elements($builder_type, $menu_id, $menu_data) {
        if ($builder_type == 'restaurant') {
            $dashb_builder = new Restaurant_Builder;
        } else {
            $dashb_builder = new Customer_Builder;
        }
        
        $used_elems_list = $this->menu_elements_list($menu_id);
        
        $menu_elements = $dashb_builder->dashboard_menu_elements_list();
        
        foreach ($menu_elements as $menu_element_key => $element_data) {
            $removeable_elem = 'true';
            if (isset($element_data['removeable']) && $element_data['removeable'] == '0') {
                $removeable_elem = 'false';
            }
            ?>
            <div id="elemitm-<?php echo ($menu_element_key) ?>-<?php echo ($menu_id) ?>" data-rem="<?php echo ($removeable_elem) ?>" class="menu-elment-item"<?php echo (in_array($menu_element_key, $used_elems_list) && $removeable_elem == 'true' ? ' style="display:none;"' : '') ?>>
                <a class="menu-elment-drager fds-link button" data-key="<?php echo ($menu_element_key) ?>" data-label="<?php echo ($element_data['label']) ?>"><i class="fds-icon fds-move-drager"></i> <?php echo ($element_data['label']) ?></a>
            </div>
            <?php
        }
    }
    
    public function menu_elements_list($menu_id) {
        $used_elems_list = array();
        $dashb_menu_data = $this->dashboard_menu_data;
        if (isset($dashb_menu_data[$menu_id]['sections']) && !empty($dashb_menu_data[$menu_id]['sections'])) {
            $menu_sections = $dashb_menu_data[$menu_id]['sections'];
            foreach ($menu_sections as $menu_section) {
                if (isset($menu_section['elements']) && !empty($menu_section['elements'])) {
                    $sec_elements = $menu_section['elements'];
                    foreach ($sec_elements as $element_itm) {
                        if (isset($element_itm['type'])) {
                            $used_elems_list[] = $element_itm['type'];
                        }
                    }
                }
            }
        }
        
        return $used_elems_list;
    }
    
    public function section_elements_list($type, $menu_id, $section_id) {
        $dashb_menu_data = get_option("foodsearch_dashboard_{$type}_menus_list");

        $used_elems_list = array();
        if (isset($dashb_menu_data[$menu_id]['sections'][$section_id]['elements']) && !empty($dashb_menu_data[$menu_id]['sections'][$section_id]['elements'])) {
            $sec_elements = $dashb_menu_data[$menu_id]['sections'][$section_id]['elements'];
            foreach ($sec_elements as $element_itm) {
                if (isset($element_itm['type'])) {
                    $used_elems_list[] = $element_itm['type'];
                }
            }
        }
        
        return $used_elems_list;
    }
    
    public function menu_item_section($builder_type = 'restaurant', $section_id = 0, $sec_data = array()) {
        
        global $foodsearch_form_fields;
        
        $rand_num = rand(1000000, 9999999);
        
        $sec_id = $rand_num;
        if ($section_id > 0) {
            $sec_id = $section_id;
        }
        
        $padding_top = $padding_right = $padding_bottom = $padding_left = $sec_box_shadow_color = $sec_bg_color = '';
        $margin_top = $margin_right = $margin_bottom = $margin_left = '';
        
        $sec_label = 'Section ' . $sec_id;
        $sec_label_switch = 'on';
        $sec_pos = 0;
        $addin_section = true;
        if (isset($sec_data['label'])) {
            $addin_section = false;
            $sec_label = $sec_data['label'];
            $sec_label_switch = isset($sec_data['sect_label_switch']) ? $sec_data['sect_label_switch'] : 'on';
            //$sec_wrapper_switch = isset($sec_data['sect_wrapper_switch']) ? $sec_data['sect_wrapper_switch'] : 'on';
            $sec_pos = isset($sec_data['sort']) ? $sec_data['sort'] : '';
            
            $padding_top = isset($sec_data['padding_top']) ? $sec_data['padding_top'] : '';
            $padding_right = isset($sec_data['padding_right']) ? $sec_data['padding_right'] : '';
            $padding_bottom = isset($sec_data['padding_bottom']) ? $sec_data['padding_bottom'] : '';
            $padding_left = isset($sec_data['padding_left']) ? $sec_data['padding_left'] : '';
            
            $margin_top = isset($sec_data['margin_top']) ? $sec_data['margin_top'] : '';
            $margin_right = isset($sec_data['margin_right']) ? $sec_data['margin_right'] : '';
            $margin_bottom = isset($sec_data['margin_bottom']) ? $sec_data['margin_bottom'] : '';
            $margin_left = isset($sec_data['margin_left']) ? $sec_data['margin_left'] : '';
            
            $sec_box_shadow_color = isset($sec_data['box_shadow_color']) ? $sec_data['box_shadow_color'] : '';
            $sec_bg_color = isset($sec_data['box_bg_color']) ? $sec_data['box_bg_color'] : '';
        }
        ob_start();
        ?>
        <div id="dashb-sect-itm<?php echo ($sec_id) ?>" data-id="<?php echo ($sec_id) ?>" class="menu-secton-holder">
            <div class="sec-conitm-hder">
                <div class="sec-itm-label">
                    <a class="msect-itm-sorter fds-link"><i class="fds-icon fds-move-drager"></i></a>
                    <strong><?php printf(esc_html__('section: %s', 'wp-foodsearch'), $sec_label) ?></strong>
                </div>
                <div class="sec-hdr-btns">
                    <a href="javascript:void(0);" class="dashb-sec-updatebtn fds-link" onclick="foodsearch_dashboard_builder.open_sect_settins(this);"><i class="dashicons-before dashicons-admin-generic"></i></a>
                    <a href="javascript:void(0);" class="dashb-sec-remvebtn fds-link" onclick="foodsearch_dashboard_builder.remove_sec_by_id(this);"><i class="dashicons-before dashicons-trash"></i></a>
                </div>
                <input type="hidden" name="menu_sect_items[<?php echo ($sec_id) ?>][sort]" value="<?php echo ($sec_pos) ?>">
            </div>
            <div class="sec-conitm-contnt">
                <div class="sect-elments-hldrcon">
                    <?php
                    $have_elements = false;
                    $elmnts_list = isset($sec_data['elements']) ? $sec_data['elements'] : '';
                    
                    if (!empty($elmnts_list)) {
                        //
                        uasort($elmnts_list, function ($a, $b) {
                            if ($a['sort'] == $b['sort']) {
                                $ret_val = 0;
                            }
                            $ret_val = ($a['sort'] < $b['sort']) ? -1 : 1;
                            return $ret_val;
                        });

                        $have_elements = true;
                        $elemts_obj = new Section_Elements;
                        foreach ($elmnts_list as $elemnt_id => $elem_data) {
                            $elemnt_type = $elem_data['type'];
                            echo ($elemts_obj->element($builder_type, $elemnt_type, $elemnt_id, $elem_data));
                        }
                    }
                    ?>
                    <div class="no-secelemnt-con"<?php echo ($have_elements ? ' style="display:none;"' : '') ?>><p><?php esc_html_e('drag and drop elements to add here.', 'wp-foodsearch') ?></p></div>
                </div>
                <div class="sect-setins-con" style="display:none;">
                    <div class="fds-form-field">
                        <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('section title', 'wp-foodsearch') ?></label></div>
                        <input type="text" name="menu_sect_items[<?php echo ($sec_id) ?>][label]" class="fds-input-style" value="<?php echo ($sec_label) ?>">
                    </div>
                    <div class="fds-form-field">
                        <?php
                        $switch_label = esc_html__('secion title at frontend', 'wp-foodsearch');
                        $switch_id = 'sect-label-' . $sec_id;
                        $switch_name = 'menu_sect_items[' . $sec_id . '][sect_label_switch]';
                        $switch_value = $sec_label_switch;
                        $this->switch_button($switch_id, $switch_name, $switch_value, $switch_label);
                        ?>
                    </div>
                    <?php
                    $field_args = array(
                        'name' => 'menu_sect_items[' . $sec_id . ']',
                        'values' => array(
                            'padding' => array(
                                'top' => $padding_top,
                                'right' => $padding_right,
                                'bottom' => $padding_bottom,
                                'left' => $padding_left,
                            ),
                            'margin' => array(
                                'top' => $margin_top,
                                'right' => $margin_right,
                                'bottom' => $margin_bottom,
                                'left' => $margin_left,
                            ),
                        ),
                    );
                    $foodsearch_form_fields->padding_margin($field_args);
                    
                    //
                    ?>
                    <div class="fds-form-field">
                        <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('box shadow color', 'wp-foodsearch') ?></label></div>
                        <?php
                        $field_args = array(
                            'name' => 'menu_sect_items[' . $sec_id . '][box_shadow_color]',
                            'value' => $sec_box_shadow_color
                        );
                        $foodsearch_form_fields->color_pickr($field_args);
                        ?>
                    </div>
                    <div class="fds-form-field">
                        <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('background color', 'wp-foodsearch') ?></label></div>
                        <?php
                        $field_args = array(
                            'name' => 'menu_sect_items[' . $sec_id . '][box_bg_color]',
                            'value' => $sec_bg_color
                        );
                        $foodsearch_form_fields->color_pickr($field_args);
                        ?>
                    </div>
                </div>
            </div>
        </div>
        <?php
        $html = ob_get_clean();
        
        return $html;
    }
    
    public function save_menu_sec_byid($menu_id, $section_id, $builder_type, $post_data) {
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            $menus_list = !empty($menus_list) ? $menus_list : array();
            
            $savin_arr = isset($menus_list[$menu_id]['sections'][$section_id]) ? $menus_list[$menu_id]['sections'][$section_id] : array();
            if (isset($post_data['menu_sect_items'][$section_id]) && !empty($post_data['menu_sect_items'][$section_id])) {
                $sect_data = $post_data['menu_sect_items'][$section_id];
                
                foreach ($sect_data as $sect_data_key => $sect_data_val) {
                    $savin_arr[$sect_data_key] = $sect_data_val;
                }
            }
            if (!empty($savin_arr)) {
                $menus_list[$menu_id]['sections'][$section_id] = $savin_arr;
                update_option("foodsearch_dashboard_{$builder_type}_menus_list", $menus_list);
                $this->generate_styles($builder_type);
            }
        }
    }
    
    public function remove_menu_sec_byid($menu_id, $section_id, $builder_type) {
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            
            if (!empty($menus_list) && isset($menus_list[$menu_id]['sections'][$section_id])) {
                unset($menus_list[$menu_id]['sections'][$section_id]);
                update_option("foodsearch_dashboard_{$builder_type}_menus_list", $menus_list);
                $this->generate_styles($builder_type);
            }
        }
    }
    
    public function save_sec_elem_byid($menu_id, $element_id, $section_id, $builder_type, $post_data) {
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            $menus_list = !empty($menus_list) ? $menus_list : array();
            
            $savin_arr = isset($menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id]) ? $menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id] : array();
            if (isset($post_data['menu_sectelem_items'][$element_id]) && !empty($post_data['menu_sectelem_items'][$element_id])) {
                $elmnt_data = $post_data['menu_sectelem_items'][$element_id];
                
                foreach ($elmnt_data as $elmnt_data_key => $elmnt_data_val) {
                    $savin_arr[$elmnt_data_key] = $elmnt_data_val;
                }
            }
            if (isset($post_data['sectelem_item_setins'][$element_id]) && !empty($post_data['sectelem_item_setins'][$element_id])) {
                $savin_arr['item_fields'] = $post_data['sectelem_item_setins'][$element_id];
            }
            if (!empty($savin_arr)) {
                $menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id] = $savin_arr;
                update_option("foodsearch_dashboard_{$builder_type}_menus_list", $menus_list);
                $this->generate_styles($builder_type);
            }
        }
    }
    
    public function save_sec_onlyelem_byid($menu_id, $element_id, $section_id, $builder_type, $post_data) {
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            $menus_list = !empty($menus_list) ? $menus_list : array();
            
            $savin_arr = isset($menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id]) ? $menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id] : array();
            if (isset($post_data['menu_sectelem_items'][$element_id]) && !empty($post_data['menu_sectelem_items'][$element_id])) {
                $elmnt_data = $post_data['menu_sectelem_items'][$element_id];
                
                foreach ($elmnt_data as $elmnt_data_key => $elmnt_data_val) {
                    $savin_arr[$elmnt_data_key] = $elmnt_data_val;
                }
            }
            if (!empty($savin_arr)) {
                $menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id] = $savin_arr;
                update_option("foodsearch_dashboard_{$builder_type}_menus_list", $menus_list);
                
                $this->generate_styles($builder_type);
            }
        }
    }
    
    public function save_elem_field_setins($menu_id, $section_id, $element_id, $field_key, $builder_type, $post_data) {
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            $menus_list = !empty($menus_list) ? $menus_list : array();
            
            $savin_arr = isset($menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id]['item_fields'][$field_key]) ? $menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id]['item_fields'][$field_key] : array();
            if (isset($post_data['sectelem_item_setins'][$element_id][$field_key]) && !empty($post_data['sectelem_item_setins'][$element_id][$field_key])) {
                $elmnt_data = $post_data['sectelem_item_setins'][$element_id][$field_key];
                
                foreach ($elmnt_data as $elmnt_data_key => $elmnt_data_val) {
                    $savin_arr[$elmnt_data_key] = $elmnt_data_val;
                }
            }
            if (!empty($savin_arr)) {
                $menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id]['item_fields'][$field_key] = $savin_arr;
                update_option("foodsearch_dashboard_{$builder_type}_menus_list", $menus_list);
                
                $this->generate_styles($builder_type);
            }
        }
    }
    
    public function remove_sect_elem_byid($menu_id, $section_id, $element_id, $builder_type) {
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            
            if (!empty($menus_list) && isset($menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id])) {
                unset($menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id]);
                update_option("foodsearch_dashboard_{$builder_type}_menus_list", $menus_list);
                $this->generate_styles($builder_type);
            }
        }
    }
    
    public function move_elem_to_othersec($menu_id, $orig_sec_id, $section_id, $element_id, $builder_type) {
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            
            if (!empty($menus_list) && isset($menus_list[$menu_id]['sections'][$orig_sec_id]['elements'][$element_id])) {
                $elemnt_data = $menus_list[$menu_id]['sections'][$orig_sec_id]['elements'][$element_id];
                unset($menus_list[$menu_id]['sections'][$orig_sec_id]['elements'][$element_id]);
                $menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id] = $elemnt_data;
                update_option("foodsearch_dashboard_{$builder_type}_menus_list", $menus_list);
            }
        }
    }
    
    public function sorting_menu_mitms($builder_type, $post_data) {
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            
            if (!empty($menus_list) && isset($post_data['dashboard_menu_items']) && !empty($post_data['dashboard_menu_items'])) {
                
                $new_menus = array();
                foreach ($menus_list as $menu_id => $menu_itm) {
                    $sort_pos = $menu_itm['sort'];
                    if (isset($post_data['dashboard_menu_items'][$menu_id]['sort'])) {
                        $sort_pos = $post_data['dashboard_menu_items'][$menu_id]['sort'];
                    }
                    $menu_itm['sort'] = $sort_pos;
                    $new_menus[$menu_id] = $menu_itm;
                }
                
                update_option("foodsearch_dashboard_{$builder_type}_menus_list", $new_menus);
            }
        }
    }
    
    public function sorting_menu_sects($menu_id, $builder_type, $post_data) {
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            
            if (!empty($menus_list) && isset($menus_list[$menu_id]['sections']) && isset($post_data['menu_sect_items']) && !empty($post_data['menu_sect_items'])) {
                
                $sections_list = $menus_list[$menu_id]['sections'];
                
                $new_sects = array();
                foreach ($sections_list as $sect_id => $sect_itm) {
                    $sort_pos = $sect_itm['sort'];
                    if (isset($post_data['menu_sect_items'][$sect_id]['sort'])) {
                        $sort_pos = $post_data['menu_sect_items'][$sect_id]['sort'];
                    }
                    $sect_itm['sort'] = $sort_pos;
                    $new_sects[$sect_id] = $sect_itm;
                }
                
                $menus_list[$menu_id]['sections'] = $new_sects;
                
                update_option("foodsearch_dashboard_{$builder_type}_menus_list", $menus_list);
            }
        }
    }
    
    public function sorting_sect_elements($menu_id, $section_id, $builder_type, $post_data) {
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            
            if (!empty($menus_list) && isset($menus_list[$menu_id]['sections'][$section_id]['elements']) && isset($post_data['menu_sectelem_items']) && !empty($post_data['menu_sectelem_items'])) {
                
                $elemnts_list = $menus_list[$menu_id]['sections'][$section_id]['elements'];
                
                $new_elems = array();
                foreach ($elemnts_list as $elem_id => $elem_itm) {
                    $sort_pos = $elem_itm['sort'];
                    if (isset($post_data['menu_sectelem_items'][$elem_id]['sort'])) {
                        $sort_pos = $post_data['menu_sectelem_items'][$elem_id]['sort'];
                    }
                    $elem_itm['sort'] = $sort_pos;
                    $new_elems[$elem_id] = $elem_itm;
                }
                
                $menus_list[$menu_id]['sections'][$section_id]['elements'] = $new_elems;
                
                update_option("foodsearch_dashboard_{$builder_type}_menus_list", $menus_list);
            }
        }
    }
    
    public function sorting_element_fields($menu_id, $section_id, $element_id, $builder_type, $post_data) {
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            
            if (!empty($menus_list) && isset($menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id]) && isset($post_data['sectelem_item_setins']) && !empty($post_data['sectelem_item_setins'])) {
                
                $elemnts_fields = $menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id]['item_fields'];

                $new_elems = array();
                foreach ($elemnts_fields as $elem_id => $elem_itm) {
                    $sort_pos = $elem_itm['sort'];
                    if (isset($post_data['sectelem_item_setins'][$element_id][$elem_id]['sort'])) {
                        $sort_pos = $post_data['sectelem_item_setins'][$element_id][$elem_id]['sort'];
                    }
                    $elem_itm['sort'] = $sort_pos;
                    $new_elems[$elem_id] = $elem_itm;
                }
                
                $menus_list[$menu_id]['sections'][$section_id]['elements'][$element_id]['item_fields'] = $new_elems;
                
                update_option("foodsearch_dashboard_{$builder_type}_menus_list", $menus_list);
            }
        }
    }
    
    public function generate_menu_slug($post_data) {
        
        $builder_type = $_POST['builder_type'];
        $text_val = $_POST['text'];
        $menu_id = $_POST['menu_id'];
        
        if ($builder_type != '') {
            $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
            
            $slugs_list = array();
            if (!empty($menus_list)) {
                foreach ($menus_list as $menu_ukey => $menu_itm) {
                    if ($menu_ukey != $menu_id) {
                        $slugs_list[] = $menu_itm['slug'];
                    }
                }
            }
            
            $slug = sanitize_title($text_val);
            
            if (!empty($slugs_list) && in_array($slug, $slugs_list)) {
                $slug .= rand(10000, 99999);
                wp_send_json(array('error' => '2', 'msg' => esc_html__('menu name already exist. please use another name.', 'wp-foodsearch'), 'slug' => $slug));
            }
            
            wp_send_json(array('error' => '0', 'msg' => '', 'slug' => $slug));
        }
    }
    
    public function generate_styles($builder_type) {
        
        $styles_str = '';
        $menus_list = get_option("foodsearch_dashboard_{$builder_type}_menus_list");
        if (!empty($menus_list)) {
            foreach ($menus_list as $menu_id => $menu_itm) {
                if (isset($menu_itm['sections']) && !empty($menu_itm['sections'])) {
                    $all_sections = $menu_itm['sections'];
                    foreach ($all_sections as $section_key => $sec_itm) {
                        $sec_css = $sec_inner_css = '';
                        if (isset($sec_itm['padding_top']) && $sec_itm['padding_top'] != '') {
                            $sec_inner_css .= 'padding-top: ' . $sec_itm['padding_top'] . 'px;';
                        }
                        if (isset($sec_itm['padding_right']) && $sec_itm['padding_right'] != '') {
                            $sec_inner_css .= 'padding-right: ' . $sec_itm['padding_right'] . 'px;';
                        }
                        if (isset($sec_itm['padding_bottom']) && $sec_itm['padding_bottom'] != '') {
                            $sec_inner_css .= 'padding-bottom: ' . $sec_itm['padding_bottom'] . 'px;';
                        }
                        if (isset($sec_itm['padding_left']) && $sec_itm['padding_left'] != '') {
                            $sec_inner_css .= 'padding-left: ' . $sec_itm['padding_left'] . 'px;';
                        }
                        //
                        if ($sec_inner_css != '') {
                            $styles_str .= '#dashboard-sec-' . $section_key . ' .fds-dashboard-inner-section {' . $sec_inner_css . '}' . "\n";
                        }
                        //
                        if (isset($sec_itm['margin_top']) && $sec_itm['margin_top'] != '') {
                            $sec_css .= 'margin-top: ' . $sec_itm['margin_top'] . 'px;';
                        }
                        if (isset($sec_itm['margin_right']) && $sec_itm['margin_right'] != '') {
                            $sec_css .= 'margin-right: ' . $sec_itm['margin_right'] . 'px;';
                        }
                        if (isset($sec_itm['margin_bottom']) && $sec_itm['margin_bottom'] != '') {
                            $sec_css .= 'margin-bottom: ' . $sec_itm['margin_bottom'] . 'px;';
                        }
                        if (isset($sec_itm['margin_left']) && $sec_itm['margin_left'] != '') {
                            $sec_css .= 'margin-left: ' . $sec_itm['margin_left'] . 'px;';
                        }
                        if (isset($sec_itm['box_shadow_color']) && $sec_itm['box_shadow_color'] != '') {
                            $sec_css .= 'box-shadow: 0px 0px 5px 1px ' . $sec_itm['box_shadow_color'] . ';';
                        }
                        if (isset($sec_itm['box_bg_color']) && $sec_itm['box_bg_color'] != '') {
                            $sec_css .= 'background-color: ' . $sec_itm['box_bg_color'] . ';';
                        }
                        //
                        if ($sec_css != '') {
                            $styles_str .= '#dashboard-sec-' . $section_key . ' {' . $sec_css . '}' . "\n";
                        }

                        //
                        if (isset($sec_itm['elements']) && !empty($sec_itm['elements'])) {
                            $all_elems = $sec_itm['elements'];
                            foreach ($all_elems as $element_key => $elem_itm) {
                                $elem_css = '';
                                if (isset($elem_itm['padding_top']) && $elem_itm['padding_top'] != '') {
                                    $elem_css .= 'padding-top: ' . $elem_itm['padding_top'] . 'px;';
                                }
                                if (isset($elem_itm['padding_right']) && $elem_itm['padding_right'] != '') {
                                    $elem_css .= 'padding-right: ' . $elem_itm['padding_right'] . 'px;';
                                }
                                if (isset($elem_itm['padding_bottom']) && $elem_itm['padding_bottom'] != '') {
                                    $elem_css .= 'padding-bottom: ' . $elem_itm['padding_bottom'] . 'px;';
                                }
                                if (isset($elem_itm['padding_left']) && $elem_itm['padding_left'] != '') {
                                    $elem_css .= 'padding-left: ' . $elem_itm['padding_left'] . 'px;';
                                }
                                if (isset($elem_itm['margin_top']) && $elem_itm['margin_top'] != '') {
                                    $elem_css .= 'margin-top: ' . $elem_itm['margin_top'] . 'px;';
                                }
                                if (isset($elem_itm['margin_right']) && $elem_itm['margin_right'] != '') {
                                    $elem_css .= 'margin-right: ' . $elem_itm['margin_right'] . 'px;';
                                }
                                if (isset($elem_itm['margin_bottom']) && $elem_itm['margin_bottom'] != '') {
                                    $elem_css .= 'margin-bottom: ' . $elem_itm['margin_bottom'] . 'px;';
                                }
                                if (isset($elem_itm['margin_left']) && $elem_itm['margin_left'] != '') {
                                    $elem_css .= 'margin-left: ' . $elem_itm['margin_left'] . 'px;';
                                }
                                //
                                if ($elem_css != '') {
                                    $styles_str .= '#dashboard-element-' . $element_key . ' {' . $elem_css . '}' . "\n";
                                }
                            }
                        }
                    }
                }
            }
        }
        require_once(ABSPATH . 'wp-admin/includes/file.php');
        WP_Filesystem();
        global $wp_filesystem, $foodsearch_upload_files_extpath;
        
        $foodsearch_upload_files_extpath = 'dashboard-css';
        
        add_filter('upload_dir', 'foodsearch_public_upload_files_path');
        $wp_upload_dir = wp_upload_dir();
        $css_files_dir = $wp_upload_dir['path'];

        $css_file = $css_files_dir . '/' . $builder_type . '-dashboard-styles.css';
        
        if ($styles_str != '') {
            $wp_filesystem->put_contents($css_file, $styles_str, FS_CHMOD_FILE);
        } else {
            unlink($css_file);
        }
        
        remove_filter('upload_dir', 'foodsearch_public_upload_files_path');
    }

}

new Common_Functions;
