<?php

namespace FoodSearch\Plugin_Settings;

class Form_Fields {
    
    public $name_prefix = 'foodsearch_plugin_settings';
    
    public function __construct() {
        add_action('foodsearch_settings_field_html_text_html', array($this, 'html_text'), 10, 3);
        add_action('foodsearch_settings_field_text_html', array($this, 'text'), 10, 3);
        add_action('foodsearch_settings_field_multi_text_html', array($this, 'multi_text'), 10, 3);
        add_action('foodsearch_settings_field_textarea_html', array($this, 'textarea'), 10, 3);
        add_action('foodsearch_settings_field_color_pickr_html', array($this, 'color_pickr'), 10, 3);
        add_action('foodsearch_settings_field_switch_button_html', array($this, 'switch_button'), 10, 3);
        add_action('foodsearch_settings_field_options_button_html', array($this, 'options_button'), 10, 3);
        add_action('foodsearch_settings_field_select_html', array($this, 'select'), 10, 3);
        add_action('foodsearch_settings_field_image_html', array($this, 'image'), 10, 3);
    }
    
    public function html_text($html, $params, $sec_id) {
        
        extract($params);

        $prop_id = '';
        $prop_class = 'fds-options-infotxt';
        $extra_attr = '';
        
        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
        }
        if (isset($cus_name) && $cus_name != '') {
            $prop_name = " name=\"{$cus_name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class .= " {$classes}";
        }
        if (isset($ext_attr) && $ext_attr != '') {
            $extra_attr = $ext_attr;
        }

        $html = '';
        if (isset($default) && $default != '') {
            $html = "<div {$prop_id} class=\"{$prop_class}\"{$extra_attr}>" . $default . "</div>";
        }

        return $html;
    }
    
    public function text($html, $params, $sec_id) {
        global $foodsearch_plugin_settings;
        
        extract($params);

        $prop_id = '';
        $prop_name = '';
        $prop_class = '';
        $prop_value = '';
        $extra_attr = '';
        
        $options_name = $this->name_prefix;

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
            $prop_name = " name=\"{$options_name}[{$sec_id}][{$id}]\"";
            if (isset($foodsearch_plugin_settings[$sec_id][$id])) {
                $db_value = $foodsearch_plugin_settings[$sec_id][$id];
            }
        }
        if (isset($cus_id) && $cus_id != '') {
            $prop_id = " id=\"{$cus_id}\"";
        }
        if (isset($cus_name) && $cus_name != '') {
            $prop_name = " name=\"{$cus_name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = ' ' . $classes;
        }
        if (isset($ext_attr) && $ext_attr != '') {
            $extra_attr = $ext_attr;
        }

        if (isset($default) && $default != '') {
            $value = $default;
            $prop_value = " value=\"{$value}\"";
        }
        if (isset($db_value)) {
            $value = $db_value;
            $prop_value = " value=\"{$value}\"";
        }

        $html = "<input type=\"text\"{$prop_id} class=\"fds-input-style{$prop_class}\"{$prop_name}{$prop_value}{$extra_attr} />";

        return $html;
    }
    
    public function multi_text($html, $params, $sec_id) {
        global $foodsearch_plugin_settings;
        
        extract($params);

        $prop_id = '';
        $prop_name = '';
        $prop_class = '';
        $value = '';
        $extra_attr = '';
        
        $options_name = $this->name_prefix;

        if (isset($id) && $id != '') {
            $prop_id = " id=\"multi-text-{$id}\"";
            $prop_name = " name=\"{$options_name}[{$sec_id}][{$id}][]\"";
            if (isset($foodsearch_plugin_settings[$sec_id][$id])) {
                $db_value = $foodsearch_plugin_settings[$sec_id][$id];
            }
        }
        if (isset($cus_id) && $cus_id != '') {
            $prop_id = " id=\"{$cus_id}\"";
        }
        if (isset($cus_name) && $cus_name != '') {
            $prop_name = " name=\"{$cus_name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = ' ' . $classes;
        }
        if (isset($ext_attr) && $ext_attr != '') {
            $extra_attr = $ext_attr;
        }

        if (isset($default) && $default != '') {
            $value = $default;
        }
        if (isset($db_value)) {
            $value = $db_value;
        }
        ob_start();
        ?>
        <div<?php echo ($prop_id) ?> class="multi-text-inputs">
            <?php
            if (!empty($value) && is_array($value)) {
                $inputs_countr = 1;
                foreach ($value as $val) {
                    ?>
                    <div class="text-input-itm">
                        <input type="text"<?php echo ($prop_name) ?> class="fds-input-style<?php echo ($prop_class) ?>" value="<?php echo foodsearch_esc_html($val) ?>"<?php echo ($extra_attr) ?>>
                        <a href="#" class="add-mtext-itm fds-link"><i class="dashicons-before dashicons-plus"></i></a>
                        <?php
                        if ($inputs_countr > 1) {
                            ?>
                            <a href="#" class="remove-mtext-itm fds-link"><i class="dashicons-before dashicons-no"></i></a>
                            <?php
                        }
                        ?>
                    </div>
                    <?php
                    $inputs_countr++;
                }
            } else {
                ?>
                <div class="text-input-itm">
                    <input type="text"<?php echo ($prop_name) ?> class="fds-input-style<?php echo ($prop_class) ?>"<?php echo ($extra_attr) ?>>
                    <a href="#" class="add-mtext-itm fds-link"><i class="dashicons-before dashicons-plus"></i></a>
                </div>
                <?php
            }
            ?>
        </div>
        <?php
        $html = ob_get_clean();

        return $html;
    }
    
    public function textarea($html, $params, $sec_id) {
        global $foodsearch_plugin_settings;
        
        extract($params);

        $prop_id = '';
        $prop_name = '';
        $prop_class = '';
        $value = '';
        $extra_attr = '';
        
        $options_name = $this->name_prefix;

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
            $prop_name = " name=\"{$options_name}[{$sec_id}][{$id}]\"";
            if (isset($foodsearch_plugin_settings[$sec_id][$id])) {
                $db_value = $foodsearch_plugin_settings[$sec_id][$id];
            }
        }
        if (isset($cus_id) && $cus_id != '') {
            $prop_id = " id=\"{$cus_id}\"";
        }
        if (isset($cus_name) && $cus_name != '') {
            $prop_name = " name=\"{$cus_name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = ' ' . $classes;
        }
        if (isset($ext_attr) && $ext_attr != '') {
            $extra_attr = $ext_attr;
        }

        if (isset($default) && $default != '') {
            $value = $default;
        }
        if (isset($db_value)) {
            $value = $db_value;
        }

        $html = "<textarea {$prop_id} class=\"fds-textarea-style{$prop_class}\"{$prop_name}{$extra_attr}>{$value}</textarea>";

        return $html;
    }
    
    public function color_pickr($html, $params, $sec_id) {
        global $foodsearch_plugin_settings;
        
        extract($params);

        $prop_id = '';
        $prop_name = '';
        $prop_class = '';
        $prop_value = '';
        $extra_attr = '';
        
        $options_name = $this->name_prefix;

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
            $prop_name = " name=\"{$options_name}[{$sec_id}][{$id}]\"";
            if (isset($foodsearch_plugin_settings[$sec_id][$id])) {
                $db_value = $foodsearch_plugin_settings[$sec_id][$id];
            }
        }
        if (isset($cus_id) && $cus_id != '') {
            $prop_id = " id=\"{$cus_id}\"";
        }
        if (isset($cus_name) && $cus_name != '') {
            $prop_name = " name=\"{$cus_name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = ' ' . $classes;
        }
        if (isset($ext_attr) && $ext_attr != '') {
            $extra_attr = $ext_attr;
        }

        if (isset($default) && $default != '') {
            $value = $default;
            $prop_value = " value=\"{$value}\"";
        }
        if (isset($db_value)) {
            $value = $db_value;
            $prop_value = " value=\"{$value}\"";
        }

        $html = "<div class=\"fds-pickr-containr\"{$prop_id}{$prop_class}>";
        $html .= "<div class=\"fds-pickr-selectr\" data-colr=\"{$value}\"></div>";
        $html .= "<input type=\"hidden\"{$prop_name}{$prop_value}{$extra_attr} />";
        $html .= "</div>";

        return $html;
    }
    
    public function switch_button($html, $params, $sec_id) {
        global $foodsearch_plugin_settings;
        
        extract($params);

        $prop_id = '';
        $prop_name = '';
        $prop_class = '';
        $extra_attr = '';
        $value = '';
        
        $options_name = $this->name_prefix;
        
        $is_multi = false;
        if (isset($multi) && $multi == 'true') {
            $is_multi = true;
        }

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
            $prop_name = " name=\"{$options_name}[{$sec_id}][{$id}]" . ($is_multi ? '[]' : '') . "\"";

            if (isset($foodsearch_plugin_settings[$sec_id][$id])) {
                $db_value = $foodsearch_plugin_settings[$sec_id][$id];
            }
        }
        if (isset($cus_name) && $cus_name != '') {
            $prop_name = " name=\"{$cus_name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = ' ' . $classes;
        }
        if (isset($ext_attr) && $ext_attr != '') {
            $extra_attr = $ext_attr;
        }

        if (isset($default) && $default != '') {
            $value = $default;
        }
        if (isset($db_value)) {
            $value = $db_value;
        }
        $prop_value = " value=\"{$value}\"";
        
        $label_on_txt = isset($label_on) && $label_on != '' ? $label_on : esc_html__('on', 'wp-foodsearch');
        $label_off_txt = isset($label_off) && $label_off != '' ? $label_off : esc_html__('off', 'wp-foodsearch');
        
        ob_start();
        ?>
        <label class="fds-switch fds-input-label">
            <input<?php echo ($prop_id) ?> type="checkbox" class="fds-settings-switch<?php echo ($prop_class) ?>"<?php echo ($extra_attr) ?><?php echo ($value == 'on' ? ' checked' : '') ?>>
            <strong class="fds-switch-inn">
                <span class="fds-off-switch"><?php echo ($label_off_txt) ?></span>
                <span class="fds-on-switch"><?php echo ($label_on_txt) ?></span>
            </strong>
            <input type="hidden"<?php echo ($prop_name . $prop_value) ?>>
        </label>
        <?php
        $html = ob_get_clean();

        return $html;
    }
    
    public function options_button($html, $params, $sec_id) {
        global $foodsearch_plugin_settings;
        
        extract($params);

        $prop_id = '';
        $prop_name = '';
        $prop_class = '';
        $extra_attr = '';
        $value = '';
        
        $options_name = $this->name_prefix;
        
        $is_multi = false;
        if (isset($multi) && $multi == 'true') {
            $is_multi = true;
        }

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}_btncon\"";
            $prop_name = " name=\"{$options_name}[{$sec_id}][{$id}]" . ($is_multi ? '[]' : '') . "\"";

            if (isset($foodsearch_plugin_settings[$sec_id][$id])) {
                $db_value = $foodsearch_plugin_settings[$sec_id][$id];
            }
        }
        if (isset($cus_name) && $cus_name != '') {
            $prop_name = " name=\"{$cus_name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = " class=\"{$classes}\"";
        }
        if (isset($ext_attr) && $ext_attr != '') {
            $extra_attr = $ext_attr;
        }

        if (isset($default) && $default != '') {
            $value = $default;
        }
        if (isset($db_value)) {
            $value = $db_value;
        }
        
        $rand = rand(100000, 999999);
        
        ob_start();
        ?>
        <div<?php echo ($prop_id) ?> class="fds-check-list fds-options-btnsholdr">
            <?php
            if (isset($options) && is_array($options)) {
                foreach ($options as $opton_key => $opton_label) {
                    $rand = rand(100000, 999999);
                    $checked = '';
                    if ($is_multi && is_array($value)) {
                        if (in_array($opton_key, $value)) {
                            $checked = ' checked';
                        }
                    } else {
                        if ($opton_key == $value) {
                            $checked = ' checked';
                        }
                    }
                    ?>
                    <div class="fds-check-style">
                        <input id="<?php echo ($id . '-' . $rand) ?>" type="<?php echo ($is_multi ? 'checkbox' : 'radio') ?>"<?php echo ($prop_name . $prop_class . $extra_attr) ?> value="<?php echo ($opton_key) ?>"<?php echo ($checked) ?> />
                        <label for="<?php echo ($id . '-' . $rand) ?>" class="fds-input-label">
                            <span><?php echo ($opton_label) ?></span>
                        </label>
                    </div>
                    <?php
                }
            }
            ?>
        </div>
        <?php
        $html = ob_get_clean();

        return $html;
    }
    
    public function select($html, $params, $sec_id) {
        global $foodsearch_plugin_settings;
        
        extract($params);

        $prop_id = '';
        $prop_name = '';
        $prop_class = '';
        $extra_attr = '';
        $is_multi = false;
        $value = '';
        $select_dropdwn_class = 'fds-select-dropdown';
        if (isset($no_dropdwn_clas) && $no_dropdwn_clas) {
            $select_dropdwn_class = '';
        }
        
        if (isset($multi) && $multi == 'true') {
            $is_multi = true;
        }
        
        $options_name = $this->name_prefix;

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
            $prop_name = " name=\"{$options_name}[{$sec_id}][{$id}]" . ($is_multi ? '[]' : '') . "\"";
            if (isset($foodsearch_plugin_settings[$sec_id][$id])) {
                $db_value = $foodsearch_plugin_settings[$sec_id][$id];
            }
        }
        if (isset($cus_id) && $cus_id != '') {
            $prop_id = " id=\"{$cus_id}\"";
        }
        if (isset($cus_name) && $cus_name != '') {
            $prop_name = " name=\"{$cus_name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = ' ' . $classes;
        }
        if (isset($ext_attr) && $ext_attr != '') {
            $extra_attr = $ext_attr;
        }

        if (isset($default) && $default != '') {
            $value = $default;
        }
        if (isset($db_value)) {
            $value = $db_value;
        }
        
        $placeholder_txt = isset($placeholder) ? $placeholder : esc_html__('select option', 'wp-foodsearch');

        $html = "<div class=\"fds-select-field" . ($is_multi ? ' fds-multi-select' : '') . "\"><select{$prop_id}{$prop_name}" . ($is_multi ? ' multiple' : '') . " data-placeholder=\"{$placeholder_txt}\" class=\"{$select_dropdwn_class}{$prop_class}\"{$extra_attr}>";
        if (isset($options) && is_array($options)) {
            foreach ($options as $opton_key => $opton_val) {
                $selected = '';
                if ($is_multi) {
                    if (is_array($value) && in_array($opton_key, $value)) {
                        $selected = ' selected="selected"';
                    }
                } else {
                    if (!is_array($value)) {
                        $selected = $value == $opton_key ? ' selected="selected"' : '';
                    }
                }
                $html .= "<option{$selected} value=\"{$opton_key}\">{$opton_val}</option>" . "\n";
            }
        }
        $html .= "</select></div>";

        return $html;
    }
    
    public function image($html, $params, $sec_id) {
        global $foodsearch_plugin_settings;
        
        extract($params);

        $prop_id = '';
        $prop_id_name = '';
        $prop_name = '';
        $prop_class = '';
        $prop_value = '';
        $extra_attr = '';
        $value = '';
        
        $options_name = $this->name_prefix;

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
            $prop_id_name = " name=\"{$id}\"";
            $prop_name = " name=\"{$options_name}[{$sec_id}][{$id}]\"";
            if (isset($foodsearch_plugin_settings[$sec_id][$id])) {
                $db_value = $foodsearch_plugin_settings[$sec_id][$id];
            }
        }
        if (isset($cus_id) && $cus_id != '') {
            $prop_id = " id=\"{$cus_id}\"";
        }
        if (isset($cus_name) && $cus_name != '') {
            $prop_name = " name=\"{$cus_name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = ' ' . $classes;
        }
        if (isset($ext_attr) && $ext_attr != '') {
            $extra_attr = $ext_attr;
        }

        if (isset($default) && $default != '') {
            $value = $default;
            $prop_value = " value=\"{$value}\"";
        }
        if (isset($db_value)) {
            $value = $db_value;
            $prop_value = " value=\"{$value}\"";
        }

        $html = "<div class=\"fds-imgfield-con\">";
        $html .= "<input type=\"text\"{$prop_id}{$prop_name} class=\"fds-input-style{$prop_class}\"{$prop_value}{$extra_attr} />";
        $html .= "<img src=\"{$value}\" class=\"fds-imgpreview-withbg\" alt=\"\">";
        $html .= "<div class=\"img-uploder-btn fds-btn fds-medium-btn\">";
        $html .= "<input type=\"button\" class=\"fds-upload-file fds-has-bg\" {$prop_id_name} value=\"" . esc_html__('browse', 'wp-foodsearch') . "\" />";
        $html .= "<input type=\"button\"" . ($value != '' ? '' : ' style="display:none;"') . " class=\"fds-remvupload-file\" value=\"" . esc_html__('remove', 'wp-foodsearch') . "\" />";
        $html .= "</div>";
        $html .= "</div>";

        return $html;
    }

}

new Form_Fields;
