<?php

namespace FoodSearch\Plugin_Settings;
use FoodSearch\user_orders as User_Orders;

class Settings_Fields {
    
    public function list_set() {
        global $foodsearch_countries_list, $foodsearch_currencies_list;
        
        $curencies_list_arr = array();
        foreach ($foodsearch_currencies_list as $cus_currency_key => $cus_currency) {
            $cus_cur_name = isset($cus_currency['name']) ? $cus_currency['name'] : '';
            $cus_cur_code = isset($cus_currency['code']) ? $cus_currency['code'] : '';
            $curencies_list_arr[$cus_cur_code] = $cus_cur_name;
        }
        
        $user_orders = new User_Orders;
        
        $settins_fields = array();
        
        $all_page = array();
        $args = array(
            'sort_order' => 'asc',
            'sort_column' => 'post_title',
            'hierarchical' => 1,
            'exclude' => '',
            'include' => '',
            'meta_key' => '',
            'meta_value' => '',
            'authors' => '',
            'child_of' => 0,
            'parent' => -1,
            'exclude_tree' => '',
            'number' => '',
            'offset' => 0,
            'post_type' => 'page',
            'post_status' => 'publish'
        );

        if (is_admin()) {
            $pages = get_pages($args);
            if (!empty($pages)) {
                $all_page[''] = esc_html__('select page', 'wp-foodsearch');
                foreach ($pages as $page) {
                    $all_page[$page->post_name] = $page->post_title;
                }
            }
        }
        
        $sec_fields = array();
        
        $status_list = $user_orders->get_order_statuses();
        $default_colors = $user_orders->get_order_colors();
        foreach ($status_list as $status_key => $status_label) {
            $sec_fields[] = array(
                'id' => $status_key . '_status_color',
                'type' => 'color_pickr',
                'title' => sprintf(esc_html__('%s status color', 'wp-foodsearch'), $status_label),
                'desc' => sprintf(esc_html__('select %s status color.', 'wp-foodsearch'), $status_label),
                'default' => (isset($default_colors[$status_key]) ? $default_colors[$status_key] : ''),
            );
        }
        
        $sec_fields[] = array(
            'id' => 'terms_conditions_page',
            'type' => 'select',
            'title' => esc_html__('terms and conditions page', 'wp-foodsearch'),
            'desc' => esc_html__('select terms and conditions page.', 'wp-foodsearch'),
            'options' => $all_page,
            'default' => '',
        );
        
        $sec_fields[] = array(
            'id' => 'currency_settings_sec',
            'type' => 'section',
            'title' => esc_html__('currency settings', 'wp-foodsearch'),
            'desc' => esc_html__('these settings will apply for default site currency.', 'wp-foodsearch'),
        );
        
        $sec_fields[] = array(
            'id' => 'foodsearch_default_currency',
            'type' => 'select',
            'title' => esc_html__('default currency', 'wp-foodsearch'),
            'desc' => '',
            'options' => $curencies_list_arr,
            'default' => 'USD',
        );
        
        $sec_fields[] = array(
            'id' => 'foodsearch_currency_pos',
            'type' => 'select',
            'title' => esc_html__('currency position', 'wp-foodsearch'),
            'subtitle' => esc_html__('select currency position.', 'wp-foodsearch'),
            'desc' => '',
            'options' => array(
                'left' => esc_html__('left', 'wp-foodsearch'),
                'right' => esc_html__('right', 'wp-foodsearch'),
                'left_space' => esc_html__('left with space', 'wp-foodsearch'),
                'right_space' => esc_html__('right with space', 'wp-foodsearch'),
            ),
            'default' => 'left',
        );
        $sec_fields[] = array(
            'id' => 'foodsearch_currency_separator',
            'type' => 'text',
            'title' => esc_html__('thousand separator', 'wp-foodsearch'),
            'subtitle' => esc_html__('add thousand separator.', 'wp-foodsearch'),
            'desc' => '',
            'default' => ',',
        );        
        $sec_fields[] = array(
            'id' => 'foodsearch_currency_numdecmls',
            'type' => 'text',
            'title' => esc_html__('number of decimals', 'wp-foodsearch'),
            'subtitle' => '',
            'desc' => '',
            'default' => '2',
        );
        $sec_fields[] = array(
            'id' => 'foodsearch_cur_decimal_separator',
            'type' => 'text',
            'title' => esc_html__('decimal separator', 'wp-foodsearch'),
            'subtitle' => esc_html__('add decimal separator.', 'wp-foodsearch'),
            'desc' => '',
            'default' => '.',
        );
        
        $sec_fields[] = array(
            'type' => 'section_close',
        );
        
        $settings_arr = array(
            'title' => esc_html__('general options', 'wp-foodsearch'),
            'id' => 'general_options',
            'desc' => esc_html__('these are general options!', 'wp-foodsearch'),
            'icon' => 'el el-home',
            'fields' => $sec_fields,
        );
        
        $settings_arr = apply_filters('foodsearch_general_settings_fields_list', $settings_arr);
        
        $settins_fields['general'] = $settings_arr;
        
        $sec_fields = array();
        
        $allow_tags = array(
            'strong' => array(),
        );
        ob_start();
        ?>
        <ol>
            <li><?php echo wp_kses(__('add necessary class (<strong>foodsearch-user-loginform-open</strong> or <strong>foodsearch-user-regform-open</strong>) to <strong>&lt;button&gt;</strong>, <strong>&lt;a&gt;</strong> or <strong>menu item</strong>.', 'wp-foodsearch'), $allow_tags) ?></li>
            <li><?php echo wp_kses(__('if you want to hide login/registration link when user is logged in then add class <strong>(foodsearch-hide-when-login)</strong>.', 'wp-foodsearch'), $allow_tags) ?></li>
            <li><?php echo wp_kses(__('if you want to display any link like <strong>my account</strong> when user is logged in then add class (<strong>foodsearch-show-when-login</strong>).', 'wp-foodsearch'), $allow_tags) ?></li>
        </ol>
        <?php
        $modal_integ_html = ob_get_clean();
        $sec_fields[] = array(
            'id' => 'loginreg-modalinteg-info',
            'type' => 'html_text',
            'title' => esc_html__('how to integrate login/register modal', 'wp-foodsearch'),
            'desc' => '',
            'default' => $modal_integ_html,
        );
        
        $sec_fields[] = array(
            'id' => 'first_last_name',
            'type' => 'switch_button',
            'title' => esc_html__('display first name last name fields', 'wp-foodsearch'),
            'desc' => '',
            'label_on' => esc_html__('yes', 'wp-foodsearch'),
            'label_off' => esc_html__('no', 'wp-foodsearch'),
            'default' => '',
        );
        $sec_fields[] = array(
            'id' => 'loginreg_page',
            'type' => 'select',
            'title' => esc_html__('user login/registration page', 'wp-foodsearch'),
            'desc' => esc_html__('select login/registration page.', 'wp-foodsearch'),
            'options' => $all_page,
            'default' => '',
        );
        $sec_fields[] = array(
            'id' => 'user_approval_type',
            'type' => 'select',
            'title' => esc_html__('user approval type', 'wp-foodsearch'),
            'desc' => esc_html__('create new user account auto or after email verification. if it is set to email verification then user will not be able to set password in register form.', 'wp-foodsearch'),
            'options' => array(
                'auto' => esc_html__('auto', 'wp-foodsearch'),
                'email_verify' => esc_html__('email verification', 'wp-foodsearch'),
            ),
            'default' => '',
        );
        
        $settings_arr = array(
            'title' => esc_html__('register settings', 'wp-foodsearch'),
            'id' => 'register_settings',
            'desc' => esc_html__('these are register settings!', 'wp-foodsearch'),
            'icon' => 'el el-home',
            'fields' => $sec_fields,
        );
        
        $settings_arr = apply_filters('foodsearch_register_settings_fields_list', $settings_arr);
        
        $settins_fields['register'] = $settings_arr;
        
        //
        $sec_fields = array();
        
        $sec_fields[] = array(
            'id' => 'dashboard_page',
            'type' => 'select',
            'title' => esc_html__('user dashboard page', 'wp-foodsearch'),
            'desc' => esc_html__('select dashboard page.', 'wp-foodsearch'),
            'options' => $all_page,
            'default' => '',
        );
        
        $settings_arr = array(
            'title' => esc_html__('dashboard settings', 'wp-foodsearch'),
            'id' => 'dashboard_settings',
            'desc' => esc_html__('these are dashboard settings!', 'wp-foodsearch'),
            'icon' => 'el el-home',
            'fields' => $sec_fields,
        );
        
        $settings_arr = apply_filters('foodsearch_dashboard_settings_fields_list', $settings_arr);
        
        $settins_fields['dashboard'] = $settings_arr;
        
        //
        $sec_fields = array();
        
        $sec_fields[] = array(
            'id' => 'dashboard_logo',
            'type' => 'image',
            'title' => esc_html__('dashboard logo', 'wp-foodsearch'),
            'desc' => esc_html__('this logo will appear in user dashboard only.', 'wp-foodsearch'),
            'default' => '',
        );
        
        $settings_arr = array(
            'title' => esc_html__('dashboard builder', 'wp-foodsearch'),
            'id' => 'dashboard_bilder_settings',
            'desc' => esc_html__('these are dashboard builder settings!', 'wp-foodsearch'),
            'icon' => 'el el-home',
            'fields' => $sec_fields,
        );
        
        $settings_arr = apply_filters('foodsearch_dashbuilder_settings_fields_list', $settings_arr);
        
        $settins_fields['dashboard_builder'] = $settings_arr;
        
        //
        $sec_fields = array();
        
        $sec_fields[] = array(
            'id' => 'restaurant_listing_page',
            'type' => 'select',
            'title' => esc_html__('restaurant listing page', 'wp-foodsearch'),
            'desc' => esc_html__('select restaurant listing page for better search results.', 'wp-foodsearch'),
            'options' => $all_page,
            'default' => '',
        );
        
        $sec_fields[] = array(
            'id' => 'restaurant_detail_section',
            'type' => 'section',
            'title' => esc_html__('restaurant detail', 'wp-foodsearch'),
            'desc' => esc_html__('restaurant detail page settings.', 'wp-foodsearch'),
        );
        $sec_fields[] = array(
            'id' => 'detail_container',
            'type' => 'switch_button',
            'title' => esc_html__('detail page container', 'wp-foodsearch'),
            'desc' => '',
            'label_on' => esc_html__('yes', 'wp-foodsearch'),
            'label_off' => esc_html__('no', 'wp-foodsearch'),
            'default' => 'off',
        );
        $sec_fields[] = array(
            'id' => 'detail_container_width',
            'type' => 'text',
            'condition' => array(
                'detail_container' => array(
                    'compare' => '=',
                    'value' => 'on'
                ),
            ),
            'title' => esc_html__('container width', 'wp-foodsearch'),
            'desc' => esc_html__('add container width here.', 'wp-foodsearch'),
            'default' => '1150',
        );
        $sec_fields[] = array(
            'type' => 'section_close',
        );
        
        $sec_fields[] = array(
            'id' => 'restaurant_socialbtns_section',
            'type' => 'section',
            'title' => esc_html__('social share', 'wp-foodsearch'),
            'desc' => esc_html__('select social share for restaurant detail page.', 'wp-foodsearch'),
        );
        $sec_fields[] = array(
            'id' => 'social_share',
            'type' => 'switch_button',
            'title' => esc_html__('social sharing', 'wp-foodsearch'),
            'desc' => '',
            'label_on' => esc_html__('yes', 'wp-foodsearch'),
            'label_off' => esc_html__('no', 'wp-foodsearch'),
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'facebook_share',
            'type' => 'switch_button',
            'title' => esc_html__('facebook', 'wp-foodsearch'),
            'condition' => array(
                'social_share' => array(
                    'compare' => '=',
                    'value' => 'on'
                ),
            ),
            'desc' => '',
            'label_on' => esc_html__('yes', 'wp-foodsearch'),
            'label_off' => esc_html__('no', 'wp-foodsearch'),
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'twitter_share',
            'type' => 'switch_button',
            'title' => esc_html__('twitter', 'wp-foodsearch'),
            'condition' => array(
                'social_share' => array(
                    'compare' => '=',
                    'value' => 'on'
                ),
            ),
            'desc' => '',
            'label_on' => esc_html__('yes', 'wp-foodsearch'),
            'label_off' => esc_html__('no', 'wp-foodsearch'),
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'linkedin_share',
            'type' => 'switch_button',
            'title' => esc_html__('linkedin', 'wp-foodsearch'),
            'condition' => array(
                'social_share' => array(
                    'compare' => '=',
                    'value' => 'on'
                ),
            ),
            'desc' => '',
            'label_on' => esc_html__('yes', 'wp-foodsearch'),
            'label_off' => esc_html__('no', 'wp-foodsearch'),
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'more_share',
            'type' => 'switch_button',
            'title' => esc_html__('share more btn', 'wp-foodsearch'),
            'condition' => array(
                'social_share' => array(
                    'compare' => '=',
                    'value' => 'on'
                ),
            ),
            'desc' => '',
            'label_on' => esc_html__('yes', 'wp-foodsearch'),
            'label_off' => esc_html__('no', 'wp-foodsearch'),
            'default' => 'on',
        );
        $sec_fields[] = array(
            'type' => 'section_close',
        );
        
        $settings_arr = array(
            'title' => esc_html__('restaurant settings', 'wp-foodsearch'),
            'id' => 'restaurant_settings',
            'desc' => esc_html__('these are restaurant settings!', 'wp-foodsearch'),
            'icon' => 'el el-home',
            'fields' => $sec_fields,
        );
        
        $settings_arr = apply_filters('foodsearch_restaurant_settings_fields_list', $settings_arr);
        
        $settins_fields['restaurant_settings'] = $settings_arr;
        
        //
        $sec_fields = array();
        $sec_fields[] = array(
            'id' => 'wc_cart_active',
            'type' => 'switch_button',
            'title' => esc_html__('WooCommerce Checkout', 'wp-foodsearch'),
            'desc' => esc_html__('Enable WooCommerce Checkout for each order', 'wp-foodsearch'),
            'label_on' => esc_html__('yes', 'wp-foodsearch'),
            'label_off' => esc_html__('no', 'wp-foodsearch'),
            'default' => '',
        );       
        $sec_fields[] = array(
            'id' => 'checkout_page',
            'type' => 'select',
            'title' => esc_html__('checkout page', 'wp-foodsearch'),
            'desc' => esc_html__('select checkout page.', 'wp-foodsearch'),
            'options' => $all_page,
            'default' => '',
            'condition' => array(
                'wc_cart_active' => array(
                    'compare' => '!=',
                    'value' => 'on'
                ),
            ),
        );
        $sec_fields[] = array(
            'id' => 'order_vat_tax',
            'type' => 'switch_button',
            'title' => esc_html__('vat', 'wp-foodsearch'),
            'desc' => esc_html__('enable value added tax for each order', 'wp-foodsearch'),
            'label_on' => esc_html__('yes', 'wp-foodsearch'),
            'label_off' => esc_html__('no', 'wp-foodsearch'),
            'default' => 'on',
            'condition' => array(
                'wc_cart_active' => array(
                    'compare' => '!=',
                    'value' => 'on'
                ),
            ),
        );
        $sec_fields[] = array(
            'id' => 'vat_tax_amount',
            'type' => 'text',
            'title' => esc_html__('vat amount', 'wp-foodsearch'),
            'condition' => array(
                'order_vat_tax' => array(
                    'compare' => '=',
                    'value' => 'on'
                ),
                'wc_cart_active' => array(
                    'compare' => '!=',
                    'value' => 'on'
                ),
            ),
            'desc' => esc_html__('it will apply in percentage of total order amount', 'wp-foodsearch'),
            'default' => '',
        );
        
        $settings_arr = array(
            'title' => esc_html__('payment settings', 'wp-foodsearch'),
            'id' => 'payment_settings',
            'desc' => esc_html__('these are payment settings!', 'wp-foodsearch'),
            'icon' => 'el el-home',
            'fields' => $sec_fields,
        );
        
        $settings_arr = apply_filters('foodsearch_payment_settings_fields_list', $settings_arr);
        
        $settins_fields['payment'] = $settings_arr;
        
        //
        $sec_fields = array();
        
        $sec_fields[] = array(
            'id' => 'google_api',
            'type' => 'text',
            'title' => esc_html__('google api key', 'wp-foodsearch'),
            'desc' => '',
            'default' => '',
        );
        
        $sec_fields[] = array(
            'id' => 'mapbox_api',
            'type' => 'text',
            'title' => esc_html__('mapbox api key', 'wp-foodsearch'),
            'desc' => '',
            'default' => '',
        );
        
        $settings_arr = array(
            'title' => esc_html__('api settings', 'wp-foodsearch'),
            'id' => 'api_settings',
            'desc' => esc_html__('these are api settings!', 'wp-foodsearch'),
            'icon' => 'el el-home',
            'fields' => $sec_fields,
        );
        
        $settings_arr = apply_filters('foodsearch_api_settings_fields_list', $settings_arr);
        
        $settins_fields['api_settings'] = $settings_arr;
        
        //
        $sec_fields = array();
        
        $sec_fields[] = array(
            'id' => 'email_from_name',
            'type' => 'text',
            'title' => esc_html__('email from name', 'wp-foodsearch'),
            'desc' => esc_html__('type name for from name.', 'wp-foodsearch'),
            'default' => 'WordPress',
        );
        $sec_fields[] = array(
            'id' => 'email_from_address',
            'type' => 'text',
            'title' => esc_html__('email from address', 'wp-foodsearch'),
            'desc' => esc_html__('type email for email from address.', 'wp-foodsearch'),
            'default' => get_bloginfo('admin_email'),
        );
        
        $settings_arr = array(
            'title' => esc_html__('email settings', 'wp-foodsearch'),
            'id' => 'email_settings',
            'desc' => esc_html__('these are email template settings!', 'wp-foodsearch'),
            'icon' => 'el el-home',
            'fields' => $sec_fields,
        );
        
        $settings_arr = apply_filters('foodsearch_email_settings_fields_list', $settings_arr);
        
        $settins_fields['email_settings'] = $settings_arr;
        
        //
        $sec_fields = array();
        
        $countries_arr = ['' => esc_html__('select country', 'wp-foodsearch')];
        foreach ($foodsearch_countries_list as $country_code => $country_name) {
            $countries_arr[$country_code] = $country_name;
        }
        $sec_fields[] = array(
            'id' => 'default_country',
            'type' => 'select',
            'multi' => 'true',
            'title' => esc_html__('default country', 'wp-foodsearch'),
            'desc' => esc_html__('select your country.', 'wp-foodsearch'),
            'options' => $countries_arr,
            'default' => 'US',
        );
        $sec_fields[] = array(
            'id' => 'loc_maps',
            'type' => 'switch_button',
            'title' => esc_html__('display maps', 'wp-foodsearch'),
            'desc' => '',
            'label_on' => esc_html__('yes', 'wp-foodsearch'),
            'label_off' => esc_html__('no', 'wp-foodsearch'),
            'default' => '',
        );
        $sec_fields[] = array(
            'id' => 'map_type',
            'type' => 'options_button',
            'condition' => array(
                'loc_maps' => array(
                    'compare' => '=',
                    'value' => 'on'
                ),
            ),
            'title' => esc_html__('select map type', 'wp-foodsearch'),
            'desc' => '',
            'options' => array(
                'google' => esc_html__('google maps', 'wp-foodsearch'),
                'mapbox' => esc_html__('mapbox', 'wp-foodsearch'),
            ),
            'default' => 'google',
        );
        $sec_fields[] = array(
            'id' => 'default_map_zoom',
            'type' => 'text',
            'condition' => array(
                'loc_maps' => array(
                    'compare' => '=',
                    'value' => 'on'
                ),
            ),
            'title' => esc_html__('default map zoom', 'wp-foodsearch'),
            'desc' => '',
            'default' => '6',
        );
        $sec_fields[] = array(
            'id' => 'google_map_style',
            'type' => 'textarea',
            'condition' => array(
                'loc_maps' => array(
                    'compare' => '=',
                    'value' => 'on'
                ),
                'map_type' => array(
                    'compare' => '=',
                    'value' => 'google'
                ),
            ),
            'title' => esc_html__('google maps style', 'wp-foodsearch'),
            'desc' => sprintf(esc_html__('you can get all map styles from <a href="%s" class="fds-link" target="_blank">here</a>', 'wp-foodsearch'), 'https://snazzymaps.com/'),
            'default' => '',
        );
        $sec_fields[] = array(
            'id' => 'mapbox_style',
            'type' => 'text',
            'condition' => array(
                'loc_maps' => array(
                    'compare' => '=',
                    'value' => 'on'
                ),
                'map_type' => array(
                    'compare' => '=',
                    'value' => 'mapbox'
                ),
            ),
            'title' => esc_html__('mapbox maps style', 'wp-foodsearch'),
            'desc' => sprintf(esc_html__('paste mapbox style url here. get your mapbox style url from here <a href="%s" class="fds-link" target="_blank">www.mapbox.com/</a>', 'wp-foodsearch'), 'https://mapbox.com/'),
            'default' => 'mapbox://styles/mapbox/streets-v11',
        );
        
        $settings_arr = array(
            'title' => esc_html__('location settings', 'wp-foodsearch'),
            'id' => 'location_settings',
            'desc' => esc_html__('here are location settings!', 'wp-foodsearch'),
            'icon' => 'el el-home',
            'fields' => $sec_fields,
        );
        
        $settings_arr = apply_filters('foodsearch_loc_settings_fields_list', $settings_arr);
        
        $settins_fields['location_settings'] = $settings_arr;
        
        //
        $sec_fields = array();
        $sec_fields[] = array(
            'id' => 'enable_reviews',
            'type' => 'switch_button',
            'title' => esc_html__('enable reviews', 'wp-foodsearch'),
            'desc' => '',
            'label_on' => esc_html__('yes', 'wp-foodsearch'),
            'label_off' => esc_html__('no', 'wp-foodsearch'),
            'default' => 'on',
        );
        $sec_fields[] = array(
            'id' => 'review_titles',
            'type' => 'multi_text',
            'title' => esc_html__('review labels', 'wp-foodsearch'),
            'desc' => '',
            'default' => 'on',
        );
        
        $settings_arr = array(
            'title' => esc_html__('review settings', 'wp-foodsearch'),
            'id' => 'review_settings',
            'desc' => esc_html__('here are review settings!', 'wp-foodsearch'),
            'icon' => 'el el-home',
            'fields' => $sec_fields,
        );
        
        $settings_arr = apply_filters('foodsearch_review_settings_fields_list', $settings_arr);
        
        $settins_fields['review_settings'] = $settings_arr;
        
        $settins_fields = apply_filters('foodsearch_allplugin_settings_fields_list', $settins_fields);

        return $settins_fields;
    }

}

global $fds_plugin_setting_fields;
$fds_plugin_setting_fields = new Settings_Fields;
