// init global vars
var foodsearch_upload_croppr;

jQuery(document).ready(function() {
    
    "use strict";
    
    if (jQuery('.fds-select-dropdown').length > 0) {
        jQuery('.fds-select-dropdown').select2({
            width: '100%'
        });
    }
    
    if (jQuery('#fds-imgcropper-box').length > 0) {
        var pic_size_pix = jQuery('#fds-imgcropper-box').parents('div[id^="upload-pic-"]').attr('data-pid');
        pic_size_pix = parseInt(pic_size_pix);
        pic_size_pix = pic_size_pix > 0 ? pic_size_pix : 150;
        var croper_boundry_size = pic_size_pix + 50;
        foodsearch_upload_croppr = jQuery('#fds-imgcropper-box').croppie({
            enableExif: true,
            viewport: {
                width: pic_size_pix,
                height: pic_size_pix,
                type: 'square'
            },
            boundary: {
                width: croper_boundry_size,
                height: croper_boundry_size
            },
            minZoom: 0.1,
            enforceBoundary: false
        });
    }
    
    // restaurant tags
    jQuery('.restaurant-tags-group').select2({
        width: '100%',
        tags: true,
        ajax: {
            data: function (params) {
                var query = {
                    search: params.term
                }
                return query;
            },
            url: dashboard_common_vars.site_url + 'wp/v1/restaurant_possible_tags_list',
            dataType: 'json',
            beforeSend: function (xhr) {
                if(dashboard_common_vars.adminCheck!='true'){
                     xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
                }       
            }
            
        }
    });
});

jQuery(document).on('submit', '.dashboard-settings-form', function (ev) {
    "use strict";
    ev.preventDefault();

    var _this = jQuery(this),
    this_btn_con = _this.find('.fds-submitbtn-con').find('button'),
    btn_txt = this_btn_con.html(),
    from_element = _this[0],
    form_data = new FormData(from_element);
    this_btn_con.html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');

    var request = jQuery.ajax({
        method: "POST",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/foodsearch-save-dashboard-settings',
        processData: false,
        contentType: false,
        data: form_data,
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        }
    });
    request.done(function (response) {

        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.error == '0') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
        } else if (response.error == '2') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
    });
    request.always(function () {
        this_btn_con.html(btn_txt);
    });

    return false;
});

jQuery(document).on('submit', '.dashboard-changpass-form', function (ev) {
    "use strict";
    ev.preventDefault();

    var _this = jQuery(this),
    this_loder = _this.find('.fds-loader-holder'),
    from_element = _this[0],
    form_data = new FormData(from_element);
    
    this_loder.html('<div class="fds-loader"></div>').removeAttr('style');

    var request = jQuery.ajax({
        method: "POST",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/foodsearch-user-change-password',
        processData: false,
        contentType: false,
        data: form_data,
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        }
    });
    request.done(function (response) {

        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.error == '0') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
            window.location.reload();
        } else if (response.error == '2') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
    });
    request.always(function () {
        this_loder.html('').hide();
    });

    return false;
});

jQuery(document).on('change', 'input[name="fds_upload_logo"],input[name="fds_upload_photo"]', function () {
    "use strict";
    var input = this;
    if (input.files && input.files[0]) {
        var _this = jQuery(this),
        msg_rand = Math.floor(Math.random() * 1000000) + 1,
        img_file = input.files[0],
        img_size = img_file.size,
        file_type = img_file.type,
        this_id = _this.attr('data-id'),
        parent_con = jQuery('#upload-pic-' + this_id),
        p_id = parent_con.attr('data-pid'),
        f_id = parent_con.attr('data-fid'),
        file_type_err = parent_con.attr('data-typerr'),
        file_size_err = parent_con.attr('data-sizerr'),
        allowed_file_types = ["image/jpg","image/jpeg","image/png","image/gif"];
        
        p_id = parseInt(p_id);
        p_id = p_id > 0 ? p_id : 150;
        f_id = parseInt(f_id);
        
        if (allowed_file_types.indexOf(file_type) < 0) {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, file_type_err, 'fds-alert-info');
            return false;
        }
        
        img_size = parseFloat(img_size / 1024).toFixed(2);
        if (img_size > f_id) {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, file_size_err, 'fds-alert-info');
            return false;
        }

        var imag_reader = new FileReader();
        
        imag_reader.onload = function (e) {
            foodsearch_upload_croppr.croppie('bind', {
                url: e.target.result
            }).then(function () {
                console.log('bind complete');
            });
        }
        imag_reader.readAsDataURL(img_file);
        
        //
        parent_con.find('.fds-proile-savedimg-con').hide();
        parent_con.find('.fds-imgcropper-mainbox').css({display: 'inline-flex'});
        
        return false;
    }
});

const foodsearch_crpimg_URL_to_file = (function() {
    "use strict";
    return function foodsearch_crpimg_URL_to_file(dataurl, filename) {

        var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1],
                bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
        while (n--) {
            u8arr[n] = bstr.charCodeAt(n);
        }
        return new File([u8arr], filename, {type: mime});
    }
})();

jQuery(document).on('click', '.fds-imgcropper-mainbox .fds-cropimg-uploadbtn', function(ev) {
    "use strict";
    ev.preventDefault();
    
    var this_btn = jQuery(this);
    var this_btn_html = this_btn.html();
    var this_id = this_btn.attr('data-id');
    var n_id = this_btn.attr('data-nid');
    
    foodsearch_upload_croppr.croppie('result', {
        type: 'canvas',
        size: 'viewport'
    }).then(function (resp) {
        var file = foodsearch_crpimg_URL_to_file(resp, 'profile-img.png');
        var formData = new FormData();
        formData.append('fds_user_photo', file);
        formData.append('id', this_id);
        formData.append('n_id', n_id);
        
        //
        this_btn.html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');
        
        //
        var parent_con = jQuery('#upload-pic-' + this_id);
        var rem_con = parent_con.find('.remove-user-img');

        var request = jQuery.ajax({
            method: "POST",
            dataType: "json",
            url: dashboard_common_vars.site_url + 'wp/v1/foodsearch-user-change-photo',
            data: formData,
            processData: false,
            contentType: false,
            beforeSend: function (xhr) {
                if(dashboard_common_vars.adminCheck!='true'){
                     xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
                }       
            }
        });
        request.done(function (response) {

            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            if (response.error == '0') {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
                jQuery('#upload-pic-' + this_id).find('img').attr('src', response.img);
                rem_con.removeAttr('style');
                //
                parent_con.find('.fds-imgcropper-mainbox').hide();
                parent_con.find('.fds-proile-savedimg-con').removeAttr('style');
                //
            } else if (response.error == '2') {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
            } else {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
            }
        });
        request.always(function () {
            this_btn.html(this_btn_html);
        });
    });
});

jQuery(document).on('change', 'input[name="fds_upload_cover"]', function () {
    "use strict";
    var input = this;
    if (input.files && input.files[0]) {
        var _this = jQuery(this),
        msg_rand = Math.floor(Math.random() * 1000000) + 1,
        img_file = input.files[0],
        img_size = img_file.size,
        file_type = img_file.type,
        this_id = _this.attr('data-id'),
        n_id = _this.attr('data-nid'),
        parent_con = jQuery('#upload-coverimg-' + this_id),
        f_id = parent_con.attr('data-fid'),
        file_type_err = parent_con.attr('data-typerr'),
        file_size_err = parent_con.attr('data-sizerr'),
        this_loder = parent_con.find('.fds-loader-holder'),
        allowed_file_types = ["image/jpg","image/jpeg","image/png","image/gif"];
        
        f_id = parseInt(f_id);
        
        if (allowed_file_types.indexOf(file_type) < 0) {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, file_type_err, 'fds-alert-info');
            return false;
        }
        
        img_size = parseFloat(img_size / 1024).toFixed(2);
        if (img_size > f_id) {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, file_size_err, 'fds-alert-info');
            return false;
        }

        this_loder.html('<div class="fds-loader"></div>').removeAttr('style');

        var formData = new FormData();
        formData.append('fds_restaurant_cover', img_file);
        formData.append('id', this_id);
        formData.append('n_id', n_id);

        var request = jQuery.ajax({
            method: "POST",
            dataType: "json",
            url: dashboard_common_vars.site_url + 'wp/v1/foodsearch-user-cover-upload',
            data: formData,
            processData: false,
            contentType: false,
            beforeSend: function (xhr) {
                if(dashboard_common_vars.adminCheck!='true'){
                     xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
                }       
            }
        });
        request.done(function (response) {

            if (response.error == '0') {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
                parent_con.find('.fds-coverimg-holder').css({'background-image': response.img});
            } else if (response.error == '2') {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
            } else {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
            }
        });
        request.always(function () {
            this_loder.html('').hide();
        });

        return false;
    }
});

jQuery(document).on('click', '.remove-user-img', function () {
    "use strict";
    var _this = jQuery(this),
    this_id = _this.attr('data-id'),
    n_id = _this.attr('data-nid'),
    parent_con = jQuery('#upload-pic-' + this_id),
    rem_con = parent_con.find('.remove-user-img'),
    this_loder = parent_con.find('.fds-loader-holder');
    
    this_loder.html('<div class="fds-loader"></div>').removeAttr('style');

    var request = jQuery.ajax({
        method: "POST",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/foodsearch-remove-user-img',
        data: {
            id: this_id,
            n_id: n_id,
        },
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        }
    });
    request.done(function (response) {

        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.error == '0') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
            jQuery('#upload-pic-' + this_id).find('img').attr('src', response.img);
            rem_con.hide();
        } else if (response.error == '2') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
    });
    request.always(function () {
        this_loder.html('').hide();
    });

    return false;
});

jQuery(document).on('click', '.fds-uplod-fooditm', function () {
    "use strict";
    var _this = jQuery(this),
    parent_con = _this.parents('.image-upload'),
    img_file_input = parent_con.find('input[type=file]');
    
    img_file_input.trigger('click');
});

jQuery(document).on('change', '.fooditm-img-uploder', function () {
    "use strict";
    var input = this;
    if (input.files && input.files[0]) {
        var _this = jQuery(this),
        msg_rand = Math.floor(Math.random() * 1000000) + 1,
        img_file = input.files[0],
        img_size = img_file.size,
        file_type = img_file.type,
        f_id = 20120,
        n_id = _this.attr('data-nid'),
        g_id = _this.attr('data-gid'),
        parent_con = _this.parents('.image-upload'),
        rem_con = parent_con.find('.fds-remove'),
        file_type_err = parent_con.attr('data-typerr'),
        file_size_err = parent_con.attr('data-sizerr'),
        this_loder = parent_con.find('.fds-loader-holder'),
        allowed_file_types = ["image/jpg","image/jpeg","image/png","image/gif"];
        
        if (allowed_file_types.indexOf(file_type) < 0) {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, file_type_err, 'fds-alert-info');
            return false;
        }
        
        img_size = parseFloat(img_size / 1024).toFixed(2);
        if (img_size > f_id) {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, file_size_err, 'fds-alert-info');
            return false;
        }

        this_loder.html('<div class="fds-loader"></div>').removeAttr('style');

        var formData = new FormData();
        formData.append('fds_fooditm_photo', img_file);
        formData.append('n_id', n_id);
        formData.append('g_id', g_id);

        var request = jQuery.ajax({
            method: "POST",
            dataType: "json",
            url: dashboard_common_vars.site_url + 'wp/v1/foodsearch-upload-fooditm-img',
            data: formData,
            processData: false,
            contentType: false,
            beforeSend: function (xhr) {
                if(dashboard_common_vars.adminCheck!='true'){
                     xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
                }       
            }
        });
        request.done(function (response) {

            if (response.error == '0') {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
                parent_con.find('.fds-uplod-fooditm').css({background: 'url(' + response.img + ') no-repeat top center / cover'});
                parent_con.find('input[type=hidden]').val(response.id);
                parent_con.find('.fds-uplod-fooditm').find('i').remove();
                rem_con.removeAttr('style');
            } else if (response.error == '2') {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
            } else {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
            }
        });
        request.always(function () {
            this_loder.html('').hide();
        });

        return false;
    }
});

jQuery(document).on('click', '.userlinks-dropbtn', function() {
    "use strict";
    var menu_links_con = jQuery('.fds-useracount-dropnav');
    menu_links_con.toggleClass('active-navmenus');
});

jQuery('body').on('click', function(ev) {
    "use strict";
    var this_dom = ev.target;
    var thisdom_obj = jQuery(this_dom);
    var menu_links_con = jQuery('.fds-useracount-dropnav');
    
    var triger_close = true;
    if (thisdom_obj.hasClass('userlinks-dropbtn') || thisdom_obj.parents('a').hasClass('userlinks-dropbtn')) {
        triger_close = false;
    }
    if (thisdom_obj.hasClass('fds-useracount-dropnav') || thisdom_obj.parents('div').hasClass('fds-useracount-dropnav')) {
        triger_close = false;
    }
    
    if (triger_close === true && menu_links_con.hasClass('active-navmenus')) {
        menu_links_con.removeClass('active-navmenus');
    }
});

function foodsearch_restaurant_dropdown() {
    "use strict";
    jQuery('.restaurant-dropdown').select2({
        width: '100%',
        ajax: {
            url: dashboard_common_vars.site_url + 'wp/v1/restaurantDropdown',
            dataType: 'json',
            beforeSend: function (xhr) {
                if(dashboard_common_vars.adminCheck!='true'){
                     xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
                }       
            }
        }
    });
}
function foodsearch_update_dropdown(n) {
    "use strict";
    var maxContent, minContent = '';
    for(var i =0;i<=n;i++){
        minContent +='<option value="'+i+'">'+i+'</option>';
    }
    jQuery('.min_dropdown').html(minContent);

    for(var i =1;i<=n;i++){
        maxContent +='<option value="'+i+'">'+i+'</option>';
    }
    jQuery('.max_dropdown').html(maxContent);
}

const foodsearch_initailize_select2 = (function() {
    "use strict";

    return function foodsearch_initailize_select2(restaurant_id = 0) {
        jQuery('.food-item-dropdown').select2({
            width: '100%',
            ajax: {
                url: dashboard_common_vars.site_url + 'wp/v1/fooditems',
                dataType: 'json',
                data: function (params) {
                    var query = {
                        restaurant: restaurant_id,
                        q: params.term
                    }
                    return query;
                },
                beforeSend: function (xhr) {
                    if(dashboard_common_vars.adminCheck!='true'){
                         xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
                    }       
                }
            }
        });
    }
})();

function foodsearch_choicegroup_option() {
    "use strict";
    var maxField = 100; //Input fields increment limitation
    var wrapper = jQuery('.field_wrapper'); //Input field wrapper
    
    var restaurant_id = jQuery("#fooditemFiled").parents('form').find('input[name="restaurant_id"]').val();
    
    var fieldHTML = jQuery("#fooditemFiled")
        .eq(0)
        .clone()
        .find("input").val("").end().html(); //Input field wrapper
    var fieldHTMLContent = '<div class="item_box">'+fieldHTML+'</div>'; //New input field html
    var x = 1; //Initial field counter is 1

    //Once add button is clicked
    jQuery(document).on('click', '.add_button', function () {
        if (x < maxField) {
            x++; //Increment field counter
            jQuery(wrapper).append(fieldHTMLContent); //Add field html
        }
        var last_itm_labels = jQuery(wrapper).find('div.item_box').last().find('.label_wrap');
        last_itm_labels.each(function(itm_indx) {
            if (itm_indx == 0) {
                jQuery(this).append('<a href="javascript:void(0);" class="remove_button fds-link"><i class="dashicons-before dashicons-trash"></i></a>');
            }
        });
        var n = jQuery(wrapper).find('div.item_box').length;
        foodsearch_update_dropdown(n);
        foodsearch_initailize_select2(restaurant_id);
    });

    //Once remove button is clicked
    jQuery(document).on('click', '.remove_button', function (e) {
        e.preventDefault();
        //
        jQuery(this).parents('div.item_box').remove(); //Remove field html
        x--; //Decrement field counter
        var n = jQuery(wrapper).find('div.item_box').length;
        foodsearch_update_dropdown(n);
    });
}

jQuery(document).on('click', 'a.fds-add-choicegroup', function () {
    "use strict";
    var restaurant = jQuery(this).attr('data-restaurant');
    var n_id = jQuery(this).attr('data-nid');
    
    jQuery('#choice-group-popup').find('.fds-dynm-modal-content').html('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:dashboard_common_vars.site_url + 'wp/v1/adding-choice-group-html',
        data:  {
            restaurant: restaurant,
            n_id: n_id,
        },
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        },
        success: function(data){
            jQuery('#choice-group-popup').find('.fds-dynm-modal-content').html(data.html);
            foodsearch_select_dropdown();
            foodsearch_choicegroup_option();
            foodsearch_initailize_select2(restaurant);
        }
    });
    foodsearch_modal_popup_open('choice-group-popup');
});

jQuery(document).on('click', 'a.fds-updte-choicegrp', function() {
    "use strict";
    var restaurant = jQuery(this).attr('data-restaurant');
    var n_id = jQuery(this).attr('data-nid');
    
    jQuery('#choice-group-popup').find('.fds-dynm-modal-content').html('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:dashboard_common_vars.site_url + 'wp/v1/updatin-choice-group-html',
        data:  {
            restaurant: restaurant,
            n_id: n_id,
        },
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        },
        success: function(data){
            jQuery('#choice-group-popup').find('.fds-dynm-modal-content').html(data.html);
            foodsearch_select_dropdown();
            foodsearch_choicegroup_option();
            foodsearch_initailize_select2(restaurant);
        }
    });
    foodsearch_modal_popup_open('choice-group-popup');
});

jQuery(document).on('submit', '#fds-addchoicegroup-form', function (ev) {

    "use strict";
    ev.preventDefault();
    
    var _this = jQuery(this),
    from_element = _this[0],
    form_data = new FormData(from_element),
    this_loder = _this.find('.fds-loader-holder');
    
    this_loder.html('<div class="fds-loader"></div>').removeAttr('style');

    var request = jQuery.ajax({
        method: "POST",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/create-choice-group',
        processData: false,
        contentType: false,
        data: form_data,
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        },
    });
    request.done(function (response) {

        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.status == 'success') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
            window.location.reload();
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
    });
    request.always(function () {
        this_loder.html('').hide();
    });

    return false;
});

jQuery(document).on('submit', '#fds-updatechoicegroup-form', function (ev) {
    "use strict";
    ev.preventDefault();
    
    var _this = jQuery(this),
    from_element = _this[0],
    form_data = new FormData(from_element),
    this_loder = _this.find('.fds-loader-holder');
    
    this_loder.html('<div class="fds-loader"></div>').removeAttr('style');

    var request = jQuery.ajax({
        method: "POST",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/update-choice-group',
        processData: false,
        contentType: false,
        data: form_data,
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        },
    });
    request.done(function (response) {

        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.status == 'success') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
            window.location.reload();
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
    });
    request.always(function () {
        this_loder.html('').hide();
    });

    return false;
});

jQuery(document).ready(function() {
    "use strict";
    var dashchoice_groups_con = jQuery('.all-choice-groups-con');
    if (dashchoice_groups_con.length > 0) {
        var this_loder = dashchoice_groups_con.parents('.fds-dash-add-choicegroups').find('.fds-loader-holder');
        var restaurant = dashchoice_groups_con.attr('data-restaurant');

        this_loder.html('<div class="fds-loader"></div>').removeAttr('style');

        var request = jQuery.ajax({
            method: "POST",
            dataType: "json",
            url: dashboard_common_vars.site_url + 'wp/v1/dashboard-choice-groups-list',
            data: {
                restaurant: restaurant,
            },
            beforeSend: function (xhr) {
                if(dashboard_common_vars.adminCheck!='true'){
                     xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
                }       
            },
        });
        request.done(function (response) {
            if (response.error == '0') {
                dashchoice_groups_con.html(response.html);
            }
        });
        request.always(function () {
            this_loder.html('').hide();
        });
    }
});

jQuery(document).on('click', 'a.fds-remve-choicegrp', function() {
    "use strict";
    var _this = jQuery(this);
    jQuery.fds_confirm_popup({
        message: dashboard_common_vars.delete_conf_msg,
        buttons: {
            Yes: {
                class: 'fds-accept-btn',
                action: function () {
                    var restaurant = _this.attr('data-restaurant');
                    var n_id = _this.attr('data-nid');

                    jQuery.ajax({
                        type: "post",
                        dataType: "json",
                        url:dashboard_common_vars.site_url + 'wp/v1/remove-choice-group-byid',
                        data:  {
                            restaurant: restaurant,
                            n_id: n_id,
                        },
                        beforeSend: function (xhr) {
                            if(dashboard_common_vars.adminCheck!='true'){
                                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
                            }       
                        },
                        success: function(data) {
                            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
                            if (data.error == '0') {
                                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-success');
                            }
                        }
                    });
                    _this.parents('.fds-choicegroup-itm').remove();
                    jQuery.fds_confirm_popup.hide();
                },
            },
            No: {
                class: 'fds-decline-btn',
                action: function () {
                    jQuery.fds_confirm_popup.hide();
                }
            }
        }
    });
});

jQuery(document).on('click', '.fds-get-orderdet-popup', function(e) {
    "use strict";
    e.preventDefault();
    var restaurant = jQuery(this).attr('data-restaurant');
    var n_id = jQuery(this).attr('data-nid');
    
    jQuery('#fds-orderdet-mpopup').find('.fds-dynm-modal-content').html('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

    jQuery.ajax({
        type: "POST",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/restaurant-order-detail-html',
        data:  {
            restaurant_id: restaurant,
            n_id: n_id,
        },
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        },
        success: function(data) {
            jQuery('#fds-orderdet-mpopup').find('.fds-dynm-modal-content').html(data.html);
            jQuery('#fds-orderdet-mpopup').find('.fds-item-table-list').each(function() {
                var this_itm_con = jQuery(this);
                var this_id = this_itm_con.attr('data-id');
                if (jQuery('#fds-orderdet-mpopup').find('.items-con-' + this_id).length > 0) {
                    this_itm_con.find('.itm-totl').find('.order-itm-total').append('&nbsp;<i class="fds-icon fds-down-arrow"></i>');
                }
            });
        }
    });
    foodsearch_modal_popup_open('fds-orderdet-mpopup');
});


jQuery(document).on('click', '.fds-get-wc-orderdet-popup', function(e) {
    "use strict";
    e.preventDefault();
    var restaurant = jQuery(this).attr('data-restaurant');
    var n_id = jQuery(this).attr('data-nid');
    
    jQuery('#fds-orderdet-mpopup').find('.fds-dynm-modal-content').html('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

    jQuery.ajax({
        type: "POST",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/restaurant-wc-order-detail-html',
        data:  {
            restaurant_id: restaurant,
            n_id: n_id,
        },
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        },
        success: function(data) {
            jQuery('#fds-orderdet-mpopup').find('.fds-dynm-modal-content').html(data.html);
            jQuery('#fds-orderdet-mpopup').find('.fds-item-table-list').each(function() {
                var this_itm_con = jQuery(this);
                var this_id = this_itm_con.attr('data-id');
                if (jQuery('#fds-orderdet-mpopup').find('.items-con-' + this_id).length > 0) {
                    this_itm_con.find('.itm-totl').find('.order-itm-total').append('&nbsp;<i class="fds-icon fds-down-arrow"></i>');
                }
            });
        }
    });
    foodsearch_modal_popup_open('fds-orderdet-mpopup');
});
jQuery(document).on('click', '.fds-get-userorderdet-popup', function(e) {
    "use strict";
    e.preventDefault();
    var t_id = jQuery(this).attr('data-tid');
    var n_id = jQuery(this).attr('data-nid');
    
    jQuery('#fds-orderdet-mpopup').find('.fds-dynm-modal-content').html('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

    jQuery.ajax({
        type: "POST",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/customer-order-detail-html',
        data:  {
            t_id: t_id,
            n_id: n_id,
        },
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        },
        success: function(data) {
            jQuery('#fds-orderdet-mpopup').find('.fds-dynm-modal-content').html(data.html);
            jQuery('#fds-orderdet-mpopup').find('.fds-item-table-list').each(function() {
                var this_itm_con = jQuery(this);
                var this_id = this_itm_con.attr('data-id');
                if (jQuery('#fds-orderdet-mpopup').find('.items-con-' + this_id).length > 0) {
                    this_itm_con.find('.itm-totl').find('.order-itm-total').append('&nbsp;<i class="fds-icon fds-down-arrow"></i>');
                }
            });
        }
    });
    foodsearch_modal_popup_open('fds-orderdet-mpopup');
});

jQuery(document).on('click', '.fds-to-list-itms', function() {
    "use strict";
    var _this = jQuery(this);
    var this_id = _this.attr('data-id');
    
    var child_itms_con = jQuery('.items-con-' + this_id);
    if (child_itms_con.hasClass('active-list-itms')) {
        child_itms_con.slideUp();
        child_itms_con.removeClass('active-list-itms');
    } else {
        child_itms_con.slideDown();
        child_itms_con.addClass('active-list-itms');
    }
});

jQuery(document).on('click', '.fds-to-orderstatus-update', function() {
    "use strict";
    var _this = jQuery(this);
    var dropdwn = _this.parents('.fds-restaurant-order-status').find('.fds-order-status-list-box');
    if (dropdwn.hasClass('active-status-drpdwn')) {
        dropdwn.slideUp();
        dropdwn.removeClass('active-status-drpdwn');
    } else {
        dropdwn.slideDown();
        dropdwn.addClass('active-status-drpdwn');
    }
});
jQuery('body,html').on('click', function(ev) {
    "use strict";
    var this_dom = ev.target;
    var thisdom_obj = jQuery(this_dom);
    if (thisdom_obj.hasClass('fds-order-status-list-box') || thisdom_obj.parents('ul').hasClass('fds-order-status-list-box')) {
        //
    } else {
        jQuery('.fds-order-status-list-box').hide().removeClass('active-status-drpdwn');
    }
});

jQuery(document).on('click', '.fds-order-status-list a', function (ev) {
    "use strict";
    ev.preventDefault();
    var _this = jQuery(this),
    this_prent = _this.parents('.fds-restaurant-order-status'),
    this_status = _this.attr('data-key'),
    nid = this_prent.attr('data-nid');
    
    this_prent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

    var request = jQuery.ajax({
        type: "POST",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/restaurant-update-order-status',        
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        },
        data: {
            status: this_status,
            nid: nid,
        }
    });
    request.done(function (response) {

        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.error == '0') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
            window.location.reload();
        } else if (response.error == '2') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
    });
    request.always(function () {
        this_prent.find('.fds-loader-holder').remove();
    });

    return false;
});


jQuery(document).on('click', '.fds-wc-order-status-list a', function (ev) {
    "use strict";
    ev.preventDefault();
    var _this = jQuery(this),
    this_prent = _this.parents('.fds-restaurant-order-status'),
    this_status = _this.attr('data-key'),
    nid = this_prent.attr('data-nid');
    
    this_prent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

    var request = jQuery.ajax({
        type: "POST",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/restaurant-wc-update-order-status',
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        },
        data: {
            status: this_status,
            nid: nid,
        }
    });
    request.done(function (response) {

        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.error == '0') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
            window.location.reload();
        } else if (response.error == '2') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
    });
    request.always(function () {
        this_prent.find('.fds-loader-holder').remove();
    });

    return false;
});

jQuery(document).on('change', '.restaurant-filter-orders-form input,.restaurant-filter-orders-form select', function() {
    "use strict";
    jQuery(this).parents('.fds-restaurant-orders-page').append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
    jQuery(this).parents('form').trigger('submit');
});

jQuery(document).on('click', '.fds-userchose-type', function () {
    "use strict";
    var _this = jQuery(this),
    this_prent = _this.parents('.fds-resturant-dashboard-wrapper');
    var this_type = _this.attr('data-utyp');
    
    var nid = _this.attr('data-nid');
    
    this_prent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

    var request = jQuery.ajax({
        type: "POST",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/foodsearch-choose-user-type',
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        },
        data: {
            user_type: this_type,
            nid: nid,
        }
    });
    request.done(function (response) {

        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.error == '0') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
            window.location.reload();
        } else if (response.error == '2') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
    });
    request.always(function () {
        this_prent.find('.fds-loader-holder').remove();
    });

    return false;
});

jQuery('.fds-switch-acountbtn').on('click', function () {
    "use strict";
    var _this = jQuery(this);
    var this_type = _this.attr('data-utyp');
    if (this_type == 'customer') {
        var alrt_msg = dashboard_common_vars.becom_cust;
    } else {
        var alrt_msg = dashboard_common_vars.becom_rest;
    }
    jQuery.fds_confirm_popup({
        message: alrt_msg,
        buttons: {
            Yes: {
                class: 'fds-accept-btn',
                action: function () {
                    var nid = _this.attr('data-nid');

                    var msg_popup_con = jQuery('#fds-confirm-msg-popup').find('.fds-confirmsg-con');
                    msg_popup_con.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
                    var chng_type_req = jQuery.ajax({
                        type: "post",
                        dataType: "json",
                        url:dashboard_common_vars.site_url + 'wp/v1/change-user-dashboard-type',
                        beforeSend: function (xhr) {
                            if(dashboard_common_vars.adminCheck!='true'){
                                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
                            }       
                        },
                        data:  {
                            utype: this_type,
                            nid: nid,
                        }
                    });
                    chng_type_req.done(function (response) {
                        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
                        if (response.error == '0') {
                            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
                            
                            setTimeout(function() {
                                window.location.href = response.url;
                            }, 1000);
                        } else {
                            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'alert-warning');
                        }
                    });
                    chng_type_req.always(function () {
                        msg_popup_con.find('.fds-loader-holder').remove();
                        jQuery.fds_confirm_popup.hide();
                    });
                },
            },
            No: {
                class: 'fds-decline-btn',
                action: function () {
                    jQuery.fds_confirm_popup.hide();
                }
            }
        }
    });
});

jQuery(document).on('click', '.fds-remove-fav-restaurant', function (ev) {
    "use strict";
    ev.preventDefault();
    
    var _this = jQuery(this);
    
    var this_html = _this.html();
    var this_id = _this.attr('data-id');
    var n_id = _this.attr('data-nid');
    
    jQuery.fds_confirm_popup({
        message: dashboard_common_vars.delete_conf_msg,
        buttons: {
            Yes: {
                class: 'fds-accept-btn',
                action: function () {
                    _this.html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');

                    jQuery.ajax({
                        type: "post",
                        dataType: "json",
                        url: dashboard_common_vars.site_url + 'wp/v1/user-restaurant-remove-from-fav',
                        beforeSend: function (xhr) {
                            if(dashboard_common_vars.adminCheck!='true'){
                                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
                            }       
                        },
                        data: {
                            id: this_id,
                            n_id: n_id,
                        },
                        success: function(data) {
                            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
                            if (data.error == '0') {
                                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-success');
                                _this.parents('.fds-col-4').remove();
                                return false;
                            } else {
                                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-danger');
                            }
                            _this.html(this_html);
                        },
                        error: function() {
                            _this.html(this_html);
                        }
                    });
                    jQuery.fds_confirm_popup.hide();
                },
            },
            No: {
                class: 'fds-decline-btn',
                action: function () {
                    jQuery.fds_confirm_popup.hide();
                }
            }
        }
    });
});

jQuery(document).on('click', '#fds-restaurant-orders-morebtn a', function (ev) {
    "use strict";
    ev.preventDefault();
    var _this = jQuery(this),
    btn_html = _this.html(),
    total_pages = _this.attr('data-tpages'),
    page_num = _this.attr('data-gtopage'),
    appender_con = jQuery('#fds-user-orders-mainlist'),
    nid = _this.attr('data-nid');
    
    total_pages = parseInt(total_pages);
    page_num = parseInt(page_num);
    
    var form_data = jQuery('.restaurant-filter-orders-form').serialize();
    form_data += '&n_id=' + nid + '&page_num=' + page_num;
    
    _this.html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');

    var request = jQuery.ajax({
        type: "GET",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/restaurant-orders-load-more',
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        },
        data: form_data,
    });
    request.done(function (response) {

        page_num += 1;
        _this.attr('data-gtopage', page_num)
        if (page_num > total_pages) {
            _this.parent('div').hide();
        }
        appender_con.append(response.html);
    });
    request.always(function () {
        _this.html(btn_html);
    });

    return false;
});

jQuery(document).on('click', '#fds-wc-restaurant-orders-morebtn a', function (ev) {
    "use strict";
    ev.preventDefault();
    var _this = jQuery(this),
    btn_html = _this.html(),
    total_pages = _this.attr('data-tpages'),
    page_num = _this.attr('data-gtopage'),
    appender_con = jQuery('#fds-user-orders-mainlist'),
    nid = _this.attr('data-nid');
    
    total_pages = parseInt(total_pages);
    page_num = parseInt(page_num);
    
    var form_data = jQuery('.restaurant-filter-orders-form').serialize();
    form_data += '&n_id=' + nid + '&page_num=' + page_num;
    
    _this.html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');

    var request = jQuery.ajax({
        type: "GET",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/wc-restaurant-orders-load-more',
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        },
        data: form_data,
    });
    request.done(function (response) {

        page_num += 1;
        _this.attr('data-gtopage', page_num)
        if (page_num > total_pages) {
            _this.parent('div').hide();
        }
        appender_con.append(response.html);
    });
    request.always(function () {
        _this.html(btn_html);
    });

    return false;
});

jQuery(document).on('click', '#fds-customer-orders-morebtn a', function (ev) {
    "use strict";
    ev.preventDefault();
    var _this = jQuery(this),
    btn_html = _this.html(),
    total_pages = _this.attr('data-tpages'),
    page_num = _this.attr('data-gtopage'),
    appender_con = jQuery('#fds-user-orders-mainlist'),
    nid = _this.attr('data-nid');
    
    total_pages = parseInt(total_pages);
    page_num = parseInt(page_num);
    
    var form_data = jQuery('.restaurant-filter-orders-form').serialize();
    form_data += '&n_id=' + nid + '&page_num=' + page_num;
    
    _this.html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');

    var request = jQuery.ajax({
        type: "GET",
        dataType: "json",
        url: dashboard_common_vars.site_url + 'wp/v1/customer-orders-load-more',
        beforeSend: function (xhr) {
            if(dashboard_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', dashboard_common_vars.wpnonce);
            }       
        },
        data: form_data,
    });
    request.done(function (response) {

        page_num += 1;
        _this.attr('data-gtopage', page_num)
        if (page_num > total_pages) {
            _this.parent('div').hide();
        }
        appender_con.append(response.html);
    });
    request.always(function () {
        _this.html(btn_html);
    });

    return false;
});

jQuery(document).on('change', '.fds-settings-switch', function() {
    "use strict";
    var this_btn = jQuery(this);
    if (this_btn.is(':checked')) {
        if (this_btn.hasClass('fds-intig-val')) {
            var on_val = '1';
        } else {
            var on_val = 'on';
        }
        this_btn.parents('.fds-switch').find('input[type=hidden]').val(on_val).trigger('change');
    } else {
        this_btn.parents('.fds-switch').find('input[type=hidden]').val('').trigger('change');
    }
});