document.querySelector('html').setAttribute('id', 'foodsearch-top');

const foodsearch_submit_msg_alert = (function() {
    "use strict";

    return function foodsearch_submit_msg_alert(id, msg, alert_class = 'alert-info') {
        if (jQuery('body').find('.fds-msg-wrap').length == 0) {
            jQuery('body').append('<div class="fds-msg-wrap"></div>');
        }
        jQuery('body').find('.fds-msg-wrap').append('<div class="fds-alert-msg ' + alert_class + '" id="' + id + '">' + msg + '</div>');
        setTimeout(function(){ jQuery('#' + id).addClass('fds-alert-hide'); }, 4000);
        setTimeout(function(){ jQuery('#' + id).remove(); }, 6000);
    }
})();

function foodsearch_select_dropdown() {
    "use strict";
    if (jQuery('.select_dropdown').length > 0) {
        jQuery('.select_dropdown').select2({
            placeholder: "Select a state",
            width: '100%',
        });
    }
}

jQuery(document).on('click', 'body', function(evnt) {
    "use strict";
    var this_target = jQuery(evnt.target);
    if (this_target.is('a.restaurant-food-menu-srchbtn') || this_target.parents('a.restaurant-food-menu-srchbtn').length > 0) {
        //
    } else {
        jQuery('.fds-restaurant-detail-tab').removeClass('menu-filter-search-open');
    }
});

jQuery(document).ready(function () {
    "use strict";
    foodsearch_select_dropdown();
});

var foodsearch_common_getJSON = function (url, callback) {
    "use strict";
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, true);
    xhr.responseType = 'json';
    xhr.onload = function () {
        var status = xhr.status;
        if (status === 200) {
            callback(null, xhr.response);
        } else {
            callback(status, xhr.response);
        }
    };
    xhr.send();
};

jQuery.fds_confirm_popup = function (params) {
    "use strict";
    if (jQuery('#fds-confirm-msg-popup').length) {
        return false;
    }

    var buttonHTML = '';
    jQuery.each(params.buttons, function (name, obj) {

        buttonHTML += '<a class="fds-confirm-button fds-link ' + obj['class'] + '">' + name + '</a>';

        if (!obj.action) {
            obj.action = function () {};
        }
    });

    var markup = [
        '<div id="fds-confirm-msg-popup" class="fds-modal-popup fds-popup-visible fds-confirmsg-modal">',
        '<div class="fds-modal-container">',
        '<div class="fds-modal-inner-area">',
        '<div class="fds-modal-content-area">',
        '<div class="fds-confirmsg-con">',
        '<p class="confrm-msg-txt">', params.message, '</p>',
        '<div class="confirm-popup-btns">',
        buttonHTML,
        '</div></div></div></div></div>'
    ].join('');

    jQuery(markup).appendTo('body');
    jQuery('body').addClass('foodsearch-popup-active');

    var buttons = jQuery('#fds-confirm-msg-popup .fds-confirm-button'),
    i = 0;

    jQuery.each(params.buttons, function (name, obj) {
        buttons.eq(i++).on('click', function () {

            obj.action();
            return false;
        });
    });
}

jQuery.fds_confirm_popup.hide = function () {
    "use strict";
    foodsearch_modal_popup_close();
    jQuery('#fds-confirm-msg-popup').remove();
}

jQuery(document).on('submit', '.fds-user-register-form', function (ev) {

    "use strict";
    ev.preventDefault();

    var this_form = jQuery(this),
            msg_con_class = 'fds-submitting-msgbox',
            msg_con = this_form.find('.' + msg_con_class),
            from_element = this_form[0];

    var form_button = this_form.find('input[type=submit]');
    var btn_txt = form_button.val();
    form_button.prop('value', foodsearch_common_vars.form_submitting_msg);

    form_button.addClass('disabled-btn');
    form_button.prop('disabled', true);

    msg_con.hide();

    var form_data = new FormData(from_element);
    form_data.append('fds_action', 'foodsearch_user_register_action');

    var request = jQuery.ajax({
        url: foodsearch_common_vars.ajax_url,
        method: "POST",
        processData: false,
        contentType: false,
        data: form_data,
        dataType: "json"
    });
    request.done(function (response) {

        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.error == '0') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
        } else if (response.error == '2') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
        if ('undefined' !== typeof response.redirect) {
            window.location.href = response.redirect;
        }
    });
    request.always(function () {
        form_button.removeClass('disabled-btn');
        form_button.prop('disabled', false);
        form_button.prop('value', btn_txt);
    });

    return false;
});

jQuery(document).on('keyup', '.fds-userchk-passtrength', function () {
    "use strict";
    var _this = jQuery(this);
    var _this_classes = 'fds-form-field fds-input-style fds-userchk-passtrength';
    var chk_msg_hloder = _this.parents('form').find('.passlenth-chk-holdr');
    var chk_msg_con = chk_msg_hloder.find('.passlenth-chk-msg');
    var chkmsg_con_classes = 'passlenth-chk-msg';
    var pass_val = _this.val();

    var acptable_pass_strnths = foodsearch_common_vars.acptable_pass_strnth;
    acptable_pass_strnths = JSON.parse(acptable_pass_strnths);

    if (acptable_pass_strnths.length < 1) {
        return -1;
    }

    var short_pass_msg = foodsearch_common_vars.pass_length_short;
    var bad_pass_msg = foodsearch_common_vars.pass_length_med;
    var good_pass_msg = foodsearch_common_vars.pass_length_good;
    var strong_pass_msg = foodsearch_common_vars.pass_length_strng;

    if (pass_val == '') {
        chk_msg_hloder.css({display: 'none'});
        chk_msg_con.attr('class', chkmsg_con_classes);
        chk_msg_con.html('');
        _this.attr('class', _this_classes);
        return false;
    }
    var blacklistArray = ["querty", "password", "P@ssword1", "132", "123"];
    blacklistArray = blacklistArray.concat(wp.passwordStrength.userInputDisallowedList());

    var pass_strength = wp.passwordStrength.meter(pass_val, blacklistArray);

    switch (pass_strength) {
        case 0 :
            chk_msg_hloder.removeAttr('style');
            chk_msg_con.attr('class', chkmsg_con_classes + ' fds-vweakpass');
            _this.attr('class', _this_classes + ' fds-vweakpass');
            chk_msg_con.html(short_pass_msg);
            
            break;
        case 1 :
            chk_msg_hloder.removeAttr('style');
            chk_msg_con.attr('class', chkmsg_con_classes + ' fds-weakpass');
            _this.attr('class', _this_classes + ' fds-weakpass');
            chk_msg_con.html(bad_pass_msg);
            
            break;
        case 2 :
            chk_msg_hloder.removeAttr('style');
            chk_msg_con.attr('class', chkmsg_con_classes + ' fds-weakpass');
            _this.attr('class', _this_classes + ' fds-weakpass');
            chk_msg_con.html(bad_pass_msg);
            
            break;
        case 3 :
            chk_msg_hloder.removeAttr('style');
            chk_msg_con.attr('class', chkmsg_con_classes + ' fds-mediumpass');
            _this.attr('class', _this_classes + ' fds-mediumpass');
            chk_msg_con.html(good_pass_msg);
            
            break;
        case 4 :
            chk_msg_hloder.removeAttr('style');
            chk_msg_con.attr('class', chkmsg_con_classes + ' fds-strongpass');
            _this.attr('class', _this_classes + ' fds-strongpass');
            chk_msg_con.html(strong_pass_msg);
            
            break;
        case 5 :
            chk_msg_hloder.removeAttr('style');
            chk_msg_con.attr('class', chkmsg_con_classes + ' fds-shortpass');
            _this.attr('class', _this_classes + ' fds-shortpass');
            chk_msg_con.html(short_pass_msg);
            
            break;
    }
});

jQuery(document).on('submit', '.fds-user-login-form', function (ev) {
    "use strict";

    ev.preventDefault();

    var this_form = jQuery(this),
            msg_con_class = 'fds-submitting-msgbox',
            msg_con = this_form.find('.' + msg_con_class),
            from_element = this_form[0];

    var form_button = this_form.find('input[type=submit]');
    var btn_txt = form_button.val();
    form_button.prop('value', foodsearch_common_vars.form_submitting_msg);

    form_button.addClass('disabled-btn');
    form_button.prop('disabled', true);

    msg_con.hide();

    var form_data = new FormData(from_element);
    form_data.append('fds_action', 'foodsearch_user_login_action');

    var request = jQuery.ajax({
        url: foodsearch_common_vars.ajax_url,
        method: "POST",
        processData: false,
        contentType: false,
        data: form_data,
        dataType: "json"
    });
    request.done(function (response) {
        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.error == '0') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
        } else if (response.error == '2') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
        if ('undefined' !== typeof response.redirect) {
            window.location.href = response.redirect;
        }
    });
    request.always(function () {
        form_button.removeClass('disabled-btn');
        form_button.prop('disabled', false);
        form_button.prop('value', btn_txt);
    });

    return false;
});

jQuery(document).on('submit', '.fds-user-lostpass-form', function (ev) {
    "use strict";
    ev.preventDefault();

    var this_form = jQuery(this),
            msg_con_class = 'fds-submitting-msgbox',
            msg_con = this_form.find('.' + msg_con_class),
            from_element = this_form[0];

    var form_button = this_form.find('input[type=submit]');
    var btn_txt = form_button.val();
    form_button.prop('value', foodsearch_common_vars.form_submitting_msg);

    form_button.addClass('disabled-btn');
    form_button.prop('disabled', true);

    msg_con.hide();

    var form_data = new FormData(from_element);
    form_data.append('fds_action', 'foodsearch_user_forgotpass_action');

    var request = jQuery.ajax({
        url: foodsearch_common_vars.ajax_url,
        method: "POST",
        processData: false,
        contentType: false,
        data: form_data,
        dataType: "json"
    });
    request.done(function (response) {
        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.error == '0') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
        } else if (response.error == '2') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
        if ('undefined' !== typeof response.redirect) {
            window.location.href = response.redirect;
        }
    });
    request.always(function () {
        form_button.removeClass('disabled-btn');
        form_button.prop('disabled', false);
        form_button.prop('value', btn_txt);
    });

    return false;
});

jQuery(document).on('click', '.form-logn-tab a', function () {
    "use strict";
    var _this = jQuery(this);
    var parent_con = _this.parents('.fds-useracount-formcon');
    var login_tab = parent_con.find('.form-logn-tab');
    var signup_tab = parent_con.find('.form-reg-tab');
    var activ_tab_class = 'active-frm-tab';
    var login_con = parent_con.find('.login-frm-con');
    var signup_con = parent_con.find('.register-frm-con');
    if (!login_tab.hasClass(activ_tab_class)) {

        var forgtpass_con = parent_con.find('.lostpass-frm-con');
        forgtpass_con.hide();
        signup_con.hide();
        login_con.removeAttr('style');
        signup_tab.removeClass(activ_tab_class);
        login_tab.addClass(activ_tab_class);
    }
});

jQuery(document).on('click', '.form-reg-tab a', function () {
    "use strict";
    var _this = jQuery(this);
    var parent_con = _this.parents('.fds-useracount-formcon');
    var login_tab = parent_con.find('.form-logn-tab');
    var signup_tab = parent_con.find('.form-reg-tab');
    var activ_tab_class = 'active-frm-tab';
    var login_con = parent_con.find('.login-frm-con');
    var signup_con = parent_con.find('.register-frm-con');
    if (!signup_tab.hasClass(activ_tab_class)) {
        
        var forgtpass_con = parent_con.find('.lostpass-frm-con');
        forgtpass_con.hide();
        login_con.hide();
        signup_con.removeAttr('style');
        login_tab.removeClass(activ_tab_class);
        signup_tab.addClass(activ_tab_class);
    }
});

jQuery(document).on('click', '.fds-forgtpass-btn', function () {
    "use strict";
    var _this = jQuery(this);
    var parent_con = _this.parents('.fds-useracount-formcon');
    var login_con = parent_con.find('.login-frm-con');
    var forgtpass_con = parent_con.find('.lostpass-frm-con');
    
    login_con.hide();
    forgtpass_con.removeAttr('style');
});

jQuery(document).on('click', '.fds-forgtologin-btn', function () {
    "use strict";
    var _this = jQuery(this);
    var parent_con = _this.parents('.fds-useracount-formcon');
    var login_con = parent_con.find('.login-frm-con');
    var forgtpass_con = parent_con.find('.lostpass-frm-con');
    
    forgtpass_con.hide();
    login_con.removeAttr('style');
});

function foodsearch_modal_popup_open(target) {
    "use strict";
    jQuery('#' + target).removeClass('fds-popup-hide').addClass('fds-popup-visible').css({'visibility':'visible','opacity':1});
    if (jQuery('body').hasClass('foodsearch-popup-active')) {
        jQuery('body').addClass('foodsearch-hardcore-popup');
        if (!jQuery('#' + target).hasClass('fds-hardcore-popupcon')) {
            jQuery('#' + target).addClass('fds-hardcore-popupcon');
        }
    } else {
        jQuery('body').addClass('foodsearch-popup-active');
    }
}

function foodsearch_modal_popup_close() {
    "use strict";
    if (!jQuery('body').hasClass('foodsearch-hardcore-popup')) {
        jQuery('.fds-modal-popup').removeClass('fds-popup-visible').addClass('fds-popup-hide').css({'visibility':'hidden','opacity':0});
        jQuery('body').removeClass('foodsearch-popup-active');
    }
}

jQuery(document).on('mousedown', '.fds-modal-popup', function (e) {
    "use strict";
    var is_close = true;
    var this_dom = e.target;
    var thisdom_obj = jQuery(this_dom);

    if (thisdom_obj.hasClass('fds-modal-inner-area') || thisdom_obj.parents('.fds-modal-inner-area').length > 0) {
        is_close = false;
    }
    if (is_close === true) {
        foodsearch_modal_popup_close();
    }
});

jQuery(document).on('mousedown', '.fds-hardcore-popupcon', function (e) {
    "use strict";
    var this_popup = jQuery(this);
    var is_close = true;
    var this_dom = e.target;
    var thisdom_obj = jQuery(this_dom);

    if (thisdom_obj.hasClass('fds-modal-inner-area') || thisdom_obj.parents('.fds-modal-inner-area').length > 0) {
        is_close = false;
    }
    if (is_close === true) {
        jQuery('body').removeClass('foodsearch-hardcore-popup');
        this_popup.remove();
    }
});

jQuery(document).on('click', '.foodsearch-user-loginform-open', function (ev) {
    "use strict";
    ev.preventDefault();
    var target = 'fds-user-loginreg-mpopup';
    
    var target_dom = jQuery('#' + target);
    target_dom.find('.form-logn-tab a').trigger('click');
    
    foodsearch_modal_popup_open(target);
});

jQuery(document).on('click', '.foodsearch-user-regform-open', function (ev) {
    "use strict";
    ev.preventDefault();
    var target = 'fds-user-loginreg-mpopup';
    
    var target_dom = jQuery('#' + target);
    target_dom.find('.form-reg-tab a').trigger('click');
    
    foodsearch_modal_popup_open(target);
});

jQuery(document).on('click', '.fds-show-userpass', function () {
    "use strict";
    var _this = jQuery(this);
    var this_parent = _this.parents('.fds-form-field');
    if (this_parent.length == 0) {
        this_parent = _this.parents('.field-item-con');
    }
    var input_field = this_parent.find('input');
    var icon_dom = _this.find('i');
    if (_this.hasClass('showin-pass')) {
        input_field.attr('type', 'password');
        icon_dom.attr('class', 'fds-icon fds-eye-line');
        _this.removeClass('showin-pass').find('i').removeAttr('style');
    } else {
        input_field.attr('type', 'text');
        icon_dom.attr('class', 'fds-icon fds-eye-off');
        _this.addClass('showin-pass').find('i').css({ 'font-size': '20px'});
    }
});

jQuery(document).on('click', '.fds-restaurnt-addto-fav', function (ev) {
    "use strict";
    ev.preventDefault();
    
    var _this = jQuery(this);
    
    if (_this.hasClass('foodsearch-user-loginform-open') || _this.hasClass('added-to-favourite')) {
        return;
    }
    
    var this_html = _this.html();
    var this_id = _this.attr('data-id');
    var this_view = _this.attr('data-view');
    var n_id = _this.attr('data-nid');
    
    _this.html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');

    jQuery.ajax({
        type: "post",
        dataType: "json",
        url: foodsearch_common_vars.site_url + 'wp/v1/user-restaurant-add-to-fav',
        data: {
            id: this_id,
            view: this_view,
            n_id: n_id,
        },
        beforeSend: function (xhr) {
            if(foodsearch_common_vars.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', foodsearch_common_vars.wpnonce);
           }  
        },
        success: function(data) {
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            if (data.error == '0') {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-success');
                _this.html(data.html);
                _this.addClass('added-to-favourite');
                return false;
            } else {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-danger');
            }
            _this.html(this_html);
        },
        error: function() {
            _this.html(this_html);
        }
    });
});

/*
 * For Media upload
 */
jQuery(document).on('click', '.fds-user-openmedia', function (ev) {
    "use strict";
    ev.preventDefault();
    
    var this_btn = jQuery(this);
    var nid = this_btn.attr('data-nid');
    var pid = this_btn.attr('data-pid');
    var apndid = this_btn.attr('data-apid');
    var apnd_type = this_btn.attr('data-aptype');
    
    var popup_active = '0';
    if (jQuery('body').hasClass('foodsearch-popup-active')) {
        var popup_active = '1';
    }
    var markup = [
        '<div id="fds-user-media-popup" class="fds-modal-popup fds-popup-visible' + (popup_active == '1' ? ' fds-hardcore-popupcon' : '') + ' fds-media-preview-modal">',
        '<div class="fds-modal-container">',
        '<a href="javascript:void(0);" class="fds-popup-closebtn fds-link"><i class="fds-icon fds-time-simple"></i></a>',
        '<div class="fds-modal-inner-area">',
        '<div class="fds-modal-content-area">',
        '<div class="fds-dynm-modal-content">',
        '<div class="fds-loader-holder"><div class="fds-loader"></div></div>',
        '</div></div></div></div></div>'
    ].join('');

    jQuery(markup).appendTo('body');
    if (popup_active == '1') {
        jQuery('body').addClass('foodsearch-hardcore-popup');
    } else {
        jQuery('body').addClass('foodsearch-popup-active');
    }
    
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url: foodsearch_common_vars.site_url + 'wp/v1/foodsearch-user-media-load',
        data: {
            nid: nid,
            pid: pid,
            apndid: apndid,
            apnd_type: apnd_type,
        },
        beforeSend: function (xhr) {
            if(foodsearch_common_vars.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', foodsearch_common_vars.wpnonce);
           }  
        },
        success: function(data){
            jQuery('#fds-user-media-popup').find('.fds-dynm-modal-content').html(data.html);
        }
    });
    
    return false;
});

jQuery(document).on('click', '.fds-usermedia-uploditm .fds-remove-media', function (ev) {
    "use strict";
    ev.preventDefault();
    
    var this_btn = jQuery(this);
    var this_parent = this_btn.parents('.fds-usermedia-uploditm');
    
    var box_parent = this_btn.parents('.fds-usermedia-selection-box');
    var aid = this_btn.attr('data-id');
    
    this_parent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
    
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url: foodsearch_common_vars.site_url + 'wp/v1/foodsearch-user-media-delete',
        data: {
            aid: aid,
        },        
        beforeSend: function (xhr) {
            if(foodsearch_common_vars.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', foodsearch_common_vars.wpnonce);
           }  
        },
        success: function(data){
            if (this_parent.find('input[type=radio]').is(':checked')) {
                box_parent.find('.fds-insert-media-btn').addClass('disable');
            }
            this_parent.remove();
            //
            if (box_parent.find('.fds-usermedia-uploditm').length < 1) {
                box_parent.find('.fds-dohav-media').hide();
                box_parent.find('.fds-nohav-media').removeAttr('style');
            }
            //
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-success');
        },
        error: function() {
            this_parent.find('.fds-loader-holder').remove();
        }
    });
});

jQuery(document).on('click', '.fds-usermedia-uploditm', function (ev) {
    "use strict";
    var this_itm = jQuery(this);
    var box_parent = this_itm.parents('.fds-usermedia-selection-box');
    
    var is_select = true;
    var this_dom = ev.target;
    var thisdom_obj = jQuery(this_dom);

    if (thisdom_obj.hasClass('fds-remove-media') || thisdom_obj.parents('.fds-remove-media').length > 0) {
        is_select = false;
    }
    if (is_select === true) {
        this_itm.find('input[type=radio]').prop('checked', true).trigger('change');
        
        //
        box_parent.find('.fds-usermedia-uploditm').removeClass('fds-active-itm');
        this_itm.addClass('fds-active-itm').css({'box-shadow': '0px 0px 0px 3px #c2564a','border-radius': '4px'});
        //
        
        box_parent.find('.fds-remove-media').removeAttr('style');
        this_itm.find('.fds-remove-media').hide();
        
        box_parent.find('.fds-insert-media-btn').removeClass('disable');
    }
});

jQuery(document).on('click', '.fds-insert-media-btn', function (ev) {
    "use strict";
    ev.preventDefault();
    
    var this_btn = jQuery(this);
    var box_parent = this_btn.parents('.fds-usermedia-selection-box');
    
    if (box_parent.find('input[type=radio]:checked').length > 0) {
        var cheked_itm = box_parent.find('input[type=radio]:checked');
        var attach_val = cheked_itm.val();
        var apen_id = box_parent.attr('data-apid');
        var attach_src = cheked_itm.parents('.fds-usermedia-uploditm').find('.fds-media-thumbcon').attr('data-src');
        
        jQuery('.img-' + apen_id).val(attach_val);
        if (jQuery('.srcbg-' + apen_id).length > 0) {
            jQuery('.srcbg-' + apen_id).css({'background-image': 'url(' + attach_src + ')'});
        }
        if (jQuery('.srcattr-' + apen_id).length > 0) {
            jQuery('.srcattr-' + apen_id).attr('src', attach_src);
        }
        
        var media_popup = jQuery('#fds-user-media-popup');
        if (jQuery('body').hasClass('foodsearch-hardcore-popup')) {
            jQuery('body').removeClass('foodsearch-hardcore-popup');
        } else {
            jQuery('body').removeClass('foodsearch-popup-active');
        }
        media_popup.remove();
    }
});

jQuery(document).on('change', 'input[name="fds_upload_user_newmedia"]', function () {
    "use strict";
    var input = this;
    if (input.files && input.files[0]) {
        var this_btn = jQuery(this),
        msg_rand = Math.floor(Math.random() * 1000000) + 1,
        img_file = input.files[0],
        img_size = img_file.size,
        file_type = img_file.type;
        
        var box_parent = this_btn.parents('.fds-usermedia-selection-box');
        var nid = box_parent.attr('data-nid');
        var pid = box_parent.attr('data-pid');
        var apnd_type = box_parent.attr('data-aptype');
        
        box_parent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

        var formData = new FormData();
        formData.append('user_media_file', img_file);
        formData.append('nid', nid);
        formData.append('pid', pid);
        formData.append('apnd_type', apnd_type);

        var request = jQuery.ajax({
            method: "POST",
            dataType: "json",
            url: foodsearch_common_vars.site_url + 'wp/v1/foodsearch-user-newmedia-upload',
            data: formData,
            processData: false,
            contentType: false,
            beforeSend: function (xhr) {
                if(foodsearch_common_vars.adminCheck!='true'){
                    xhr.setRequestHeader('X-WP-Nonce', foodsearch_common_vars.wpnonce);
               }  
            },
        });
        request.done(function (response) {

            if (response.error == '0') {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
                var uploder_con = box_parent.find('.fds-usermedia-uploded .mediauploded-items');
                uploder_con.html(response.html + uploder_con.html());
                var up_attch_id = response.id;
                jQuery('#attachd-' + up_attch_id).trigger('click');
                if (box_parent.find('.fds-usermedia-uploditm').length > 0) {
                    box_parent.find('.fds-dohav-media').removeAttr('style');
                    box_parent.find('.fds-nohav-media').hide();
                }
            } else if (response.error == '2') {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
            } else {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
            }
        });
        request.always(function () {
            box_parent.find('.fds-loader-holder').remove();
        });

        return false;
    }
});

jQuery(document).on('click', '#fds-usermedia-morebtn a', function (ev) {
    "use strict";
    ev.preventDefault();
    var _this = jQuery(this),
    btn_html = _this.html(),
    total_pages = _this.attr('data-tpages'),
    page_num = _this.attr('data-gtopage'),
    appender_con = _this.parents('.fds-usermedia-uploded').find('.mediauploded-items'),
    nid = _this.attr('data-nid');
    
    total_pages = parseInt(total_pages);
    page_num = parseInt(page_num);
    
    _this.html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');

    var request = jQuery.ajax({
        type: "POST",
        dataType: "json",
        url: foodsearch_common_vars.site_url + 'wp/v1/foodsearch-usermedia-load-more',
        data: {
            nid: nid,
            page_num: page_num,
        },
        beforeSend: function (xhr) {
            if(foodsearch_common_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', foodsearch_common_vars.wpnonce);
            }  
        },
    });
    request.done(function (response) {

        page_num += 1;
        _this.attr('data-gtopage', page_num)
        if (page_num > total_pages) {
            _this.parent('div').hide();
        }
        appender_con.append(response.html);
    });
    request.always(function () {
        _this.html(btn_html);
    });

    return false;
});

jQuery(document).on('submit', '.fds-user-resetpass-form', function (ev) {
    "use strict";
    ev.preventDefault();
    var this_form = jQuery(this),
            from_element = this_form[0];

    var form_button = this_form.find('input[type=submit]');
    var btn_txt = form_button.val();
    form_button.prop('value', foodsearch_common_vars.form_submitting_msg);

    form_button.addClass('disabled-btn');
    form_button.prop('disabled', true);

    var form_data = new FormData(from_element);
    form_data.append('fds_action', 'foodsearch_user_resetpass_action');

    var request = jQuery.ajax({
        url: foodsearch_common_vars.ajax_url,
        method: "POST",
        processData: false,
        contentType: false,
        data: form_data,
        dataType: "json"
    });
    request.done(function (response) {
        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.error == '0') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
        } else if (response.error == '2') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
        if ('undefined' !== typeof response.redirect && response.redirect != '') {
            window.location.href = response.redirect;
        }
    });
    request.always(function () {
        form_button.removeClass('disabled-btn');
        form_button.prop('disabled', false);
        form_button.prop('value', btn_txt);
    });

    return false;
});

jQuery(document).on('click', '.restaurant-food-menu-srchbtn', function(ev) {
    "use strict";
    ev.preventDefault();
    jQuery(this).parents('.fds-restaurant-detail-tab').toggleClass('menu-filter-search-open');
});

jQuery(document).on('keyup', '#restaurant-search-input', function() {
    "use strict";
    var this_field = jQuery(this);
    var input_val = this_field.val();
    
    var main_parent_con = this_field.parents('.fds-restaurant-detail-tab');
    var parent_con = main_parent_con.find('.fds-restaurant-tab-detailcontent');
    var srch_results_con = parent_con.find('.restaurant-food-srch-results');
    if (srch_results_con.length == 0) {
        parent_con.find('.fds-restaurant-menu-search').after('<div class="restaurant-food-srch-results" style="display: none;"></div>');
    }
    
    if (input_val.length > 2) {
        var results_html = '';
        var menuitms_html = '';
        parent_con.find('> .fds-restaurant-detail-list').each(function() {
            var this_cat_con = jQuery(this);
            this_cat_con.find('.fds-menu-item').each(function() {
                var this_menu_itm = jQuery(this);
                var menu_title = this_menu_itm.find('a.fds-menu-item-title').html();
                var input_exp = new RegExp(input_val, 'gi');
                if (menu_title.match(input_exp)) {
                    menuitms_html += '<div class="fds-menu-item">' + this_menu_itm.html() + '</div>';
                }
            });
        });
        if (menuitms_html != '') {
            results_html = '<div class="fds-restaurant-detail-list"><div class="fds-menu-list-wrap">' + menuitms_html + '</div></div>';
        } else {
            results_html = '\
            <div class="foodsearch-noitm-found">\
                <img src="' + foodsearch_common_vars.plugin_url + 'assets/images/not-found.svg" alt="">\
                <p>' + foodsearch_common_vars.no_search_menu_found + '</p>\
            </div>';
        }
        srch_results_con.html(results_html).fadeIn(450);
        parent_con.find('> .fds-restaurant-detail-list').hide();
    } else {
        if (srch_results_con.is(':visible')) {
            srch_results_con.hide();
            main_parent_con.find('.fds-restaurant-detailnav').find('.fds-list-item').each(function(el_index) {
                var this_navitm = jQuery(this);
                if (el_index == 0) {
                    if (!(this_navitm.find('a').hasClass('active'))) {
                        this_navitm.find('a').addClass('active');
                    }
                } else {
                    this_navitm.find('a').removeClass('active');
                }
            });
            parent_con.find('.fds-restaurant-detail-list').removeAttr('style');
        }
    }
});
