<?php

namespace FoodSearch\Dashboard\Customer;
use FoodSearch\Common_Functions;

class Settings {
    
    public function __construct() {
        
        add_filter('foodsearch_customer_dash_account_settings_html', [$this, 'content'], 10, 4);
    }
    
    public function content($html, $menu_data, $section_key, $element_key) {
        
        $element_data = $menu_data['sections'][$section_key]['elements'][$element_key];
        
        $user_id = get_current_user_id();
        $user_obj = get_user_by('id', $user_id);
        
        $common_functions = new Common_Functions;

        $customer_id = Common_Functions::user_customer_id($user_id);

        ob_start();
        ?>
        <form class="fds-common-form dashboard-settings-form" method="post">
            <?php
            if (isset($element_data['item_fields']) && !empty($element_data['item_fields'])) {

                $item_fields = $element_data['item_fields'];

                uasort($item_fields, function ($a, $b) {
                    if ($a['sort'] == $b['sort']) {
                        $ret_val = 0;
                    }
                    $ret_val = ($a['sort'] < $b['sort']) ? -1 : 1;
                    return $ret_val;
                });
                foreach ($item_fields as $field_key => $field_data) {
                    $label = isset($field_data['label']) ? $field_data['label'] : '';
                    $enabled = isset($field_data['status']) ? $field_data['status'] : 'on';
                    $required = isset($field_data['required']) ? $field_data['required'] : '';
                    $col_width = isset($field_data['width']) ? $field_data['width'] : '2';

                    if ($field_key == 'first_name') {
                        $itm_value = isset($user_obj->first_name) ? $user_obj->first_name : '';
                    } else if ($field_key == 'last_name') {
                        $itm_value = isset($user_obj->last_name) ? $user_obj->last_name : '';
                    } else if ($field_key == 'display_name') {
                        $itm_value = isset($user_obj->display_name) ? $user_obj->display_name : '';
                    } else if ($field_key == 'email_address') {
                        $itm_value = isset($user_obj->user_email) ? $user_obj->user_email : '';
                    } else {
                        $itm_value = get_post_meta($customer_id, 'foodsearch_' . $field_key, true);
                    }

                    if ($enabled == 'on') {
                        $classes_arr = array('fds-input-style');
                        $field_class = implode(' ', $classes_arr);
                        $act_width = 100 / $col_width;
                        ?>
                        <div class="fds-dashform-field fds-form-field" style="flex: 0 0 calc(<?php echo ($act_width) ?>% - 20px);">
                            <div class="label_wrap"><label class="fds-input-label"><?php echo ($label) ?><?php echo ($required == 'on' ? ' *' : '') ?></label></div>
                            <input type="<?php echo ($field_key == 'email_address' ? 'email' : 'text') ?>" name="fds_setting_<?php echo ($field_key) ?>" class="<?php echo ($field_class) ?>"<?php echo ($required == 'on' ? ' required' : '') ?><?php echo ($field_key == 'email_address' ? ' readonly' : '') ?> value="<?php echo ($itm_value) ?>" placeholder="<?php echo ($label) ?>">
                        </div>
                        <?php
                    }
                }
                ?>
                <div class="fds-dashform-field fds-form-field">
                    <div class="fds-submitbtn-con">
                        <input type="hidden" name="fds_nonce_id" value="<?php echo ($user_id) ?>">
                        <?php
                        wp_nonce_field('ajax-settings-nonce', 'dashboard-settings');
                        ?>
                        <div class="fds-btn fds-medium-btn">
                            <button type="submit" class="fds-has-bg fds-update-anything-action"><?php esc_html_e('save settings', 'wp-foodsearch') ?></button>
                        </div>
                    </div>
                    <?php
                    echo apply_filters('foodsearch_customer_dash_setin_savebtn_after', '', $user_id);
                    ?>
                </div>
                <?php
            }
            ?>
        </form>
        <?php
        $html = ob_get_clean();
        
        return $html;
    }

}

new Settings;
