<?php

namespace FoodSearch\Dashboard\Common;
use FoodSearch\User_Locations;
use FoodSearch\Common_Functions;

class Loc_Address {
    
    public function __construct() {
        
        add_filter('foodsearch_restaurant_dash_loc_address_html', [$this, 'content'], 10, 4);
        add_filter('foodsearch_customer_dash_loc_address_html', [$this, 'content'], 10, 4);
    }
    
    public function content($html, $menu_data, $section_key, $element_key) {
        
        $locations_obj = new User_Locations;
        $common_functions = new Common_Functions;
        
        $user_id = get_current_user_id();
        $user_type = Common_Functions::user_type($user_id);

        if ($user_type == 'restaurant') {
            $post_obj_id = Common_Functions::user_restaurant_id($user_id);
        } else {
            $post_obj_id = Common_Functions::user_customer_id($user_id);
        }
        ob_start();
        
        $locations_obj->add_locations($user_id, $post_obj_id);

        $html = ob_get_clean();

        return $html;
    }

}

new Loc_Address;
