<?php

namespace FoodSearch\Dashboard\Restaurant;

use FoodSearch\Common_Functions;

class Following_Customers {

    public function __construct() {
        
        add_filter('foodsearch_restaurant_dash_following_customers_html', [$this, 'content'], 10, 4);
    }
    
    public function content($html, $menu_data, $section_key, $element_key) {
        
        $common_functions = new Common_Functions;
        
        $user_id = get_current_user_id();
        
        $restaurant_id = Common_Functions::user_restaurant_id($user_id);
        
        $fav_list = $common_functions->restaurant_fav_list($restaurant_id, 'restaurant');
        
        ob_start();
        if (!empty($fav_list)) {
            ?>
            <div class="fds-userposts-itmex">
                <?php
                foreach ($fav_list as $fav_itm) {
                    $customer_id = $fav_itm['id'];
                    $customer_user_id = Common_Functions::customer_user_id($customer_id);
                    $photo_url = foodsearch_customer_photo_url($customer_user_id);
                    ?>
                    <div class="fds-userposts-itm">
                        <div class="user-img-con"><a href="<?php echo get_permalink($customer_id) ?>" class="fds-link"><img src="<?php echo ($photo_url) ?>" alt=""></a></div>
                        <div class="user-titltxt-con"><span class="fds-post-label"><?php echo get_the_title($customer_id) ?></span></div>
                    </div>
                    <?php
                }
                ?>
            </div>
            <?php
        } else {
            ?>
            <div class="foodsearch-noitm-found">
                <img src="<?php echo foodsearch_plugin_get_url('assets/images/not-found.svg') ?>" alt="">
                <p><?php esc_html_e('no record found.', 'wp-foodsearch') ?></p>
            </div>
            <?php
        }
        $html = ob_get_clean();
        
        return $html;
    }

}

new Following_Customers;
