<?php

use FoodSearch\Common_Functions;
use FoodSearch\Restaurant_Menu_Templates;

class customApiHooks {

    public function __construct() {
        //$this->locationDateInsert();
        add_action('rest_api_init', [$this, 'register_api'], 5);
    }

    public function register_api() {

        register_rest_route('wp/v1', 'itemcategories', array(
            'methods' => 'GET',
            'callback' => [$this, 'food_item_cats'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'select_menuitem_categories', array(
            'methods' => 'GET',
            'callback' => [$this, 'food_menuitem_categories'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'add_menuitem_category', array(
            'methods' => 'POST',
            'callback' => [$this, 'add_menuitem_category'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'menuList', array(
            'methods' => 'GET',
            'callback' => [$this, 'food_menu_list'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        
        register_rest_route('wp/v1', 'remove-food-menu-byid', array(
            'methods' => 'POST',
            'callback' => array($this, 'remove_food_menu'),
            'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'remove-food-menuitem-byid', array(
            'methods' => 'POST',
            'callback' => array($this, 'remove_food_menu_item'),
            'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'choicegroupList', array(
            'methods' => 'GET',
            'callback' => [$this, 'food_item_choicegroup_list'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'fooditems', array(
            'methods' => 'GET',
            'callback' => [$this, 'get_food_items'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'restaurantlist', array(
            'methods' => 'GET',
            'callback' => [$this, 'restaurantList'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'menuListByRestaurantID', array(
            'methods' => 'GET',
            'callback' => [$this, 'menuListByRestaurantID'],
           'permission_callback' =>  'admin_permissions_check',
        ));

        register_rest_route('wp/v1', 'menuItemListByMenuID', array(
            'methods' => 'POST',
            'callback' => [$this, 'menuItemListByMenuID'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'menuCategoriesByRestaurantID', array(
            'methods' => 'POST',
            'callback' => [$this, 'menuCategoriesByRestaurantID'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'menuDetailByID', array(
            'methods' => 'POST',
            'callback' => [$this, 'menuDetailByID'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'restaurantDropdown', array(
            'methods' => 'GET',
            'callback' => [$this, 'restaurantDropdown'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'create-menu', array(
            'methods' => 'POST',
            'callback' => [$this, 'menuSave'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'update-menu', array(
            'methods' => 'POST',
            'callback' => [$this, 'menuUpdate'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'update-menu-item', array(
            'methods' => 'POST',
            'callback' => [$this, 'menuItemUpdate'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'create-menu-item', array(
            'methods' => 'POST',
            'callback' => [$this, 'menuItemSave'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'sort-menu-items', array(
            'methods' => 'POST',
            'callback' => [$this, 'sort_menu_items'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'unlink-menu-items-category', array(
            'methods' => 'POST',
            'callback' => [$this, 'unlink_menu_items_category'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'add-menu-item-html', array(
            'methods' => 'GET',
            'callback' => [$this, 'add_menuitem_html_to_list'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'create-choice-group', array(
            'methods' => 'POST',
            'callback' => [$this, 'choiceGroupSave'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'update-choice-group', array(
            'methods' => 'POST',
            'callback' => [$this, 'choiceGroupUpdate'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        
        register_rest_route('wp/v1', 'fmenu-fitems-html-byid', array(
            'methods' => 'POST',
            'callback' => [$this, 'menu_itemslist_byID'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'menu-detail-html-byid', array(
            'methods' => 'POST',
            'callback' => [$this, 'menu_itm_detail_byID'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'menu-detail-update-byid', array(
            'methods' => 'POST',
            'callback' => [$this, 'menu_itm_update_byID'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'food-menu-add-inlist', array(
            'methods' => 'POST',
            'callback' => [$this, 'food_menu_add_inlist'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'food-menu-edit-byid', array(
            'methods' => 'POST',
            'callback' => [$this, 'food_menu_edit_byid'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'food-menu-add-category', array(
            'methods' => 'POST',
            'callback' => [$this, 'food_menu_add_catpop'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'foodsearch-upload-fooditm-img', array(
            'methods' => 'POST',
            'callback' => [$this, 'upload_fooditm_img'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'user-restaurant-add-to-fav', array(
            'methods' => 'POST',
            'callback' => [$this, 'user_restaurant_add_favourite'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'user-restaurant-remove-from-fav', array(
            'methods' => 'POST',
            'callback' => [$this, 'user_restaurant_remove_favourite'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'restaurant-menu-item-export-template', array(
            'methods' => 'POST',
            'callback' => [$this, 'menu_item_export_template'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'restaurant-menu-item-import-template', array(
            'methods' => 'POST',
            'callback' => [$this, 'menu_item_import_template'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'menuitems-templates-popup-html', array(
            'methods' => 'POST',
            'callback' => [$this, 'menu_item_templates_popup_html'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'menu-template-setting-popup-html', array(
            'methods' => 'POST',
            'callback' => [$this, 'menu_template_setting_popup_html'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'menu-template-settings-save', array(
            'methods' => 'POST',
            'callback' => [$this, 'menu_template_setting_save'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'remove-menu-template-itm', array(
            'methods' => 'POST',
            'callback' => [$this, 'menu_template_remove_itm'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'fds-search-users', array(
            'methods' => 'GET',
            'callback' => [$this, 'select_search_users'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'fds-item-category-setting-popup', array(
            'methods' => 'POST',
            'callback' => [$this, 'update_item_category_form'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'fds-item-category-update', array(
            'methods' => 'POST',
            'callback' => [$this, 'update_item_category'],
           'permission_callback' =>  'admin_permissions_check',
        ));
    }
    public function to_check_nonce() {
        if (defined("WP_CACHE")) {
            return false;
        }
    }
    
    public function menu_itemslist_byID() {
        $menu_id = '';
        if (isset($_POST['id'])) {
            $menu_id = $_POST['id'];
        }
        $user_id = $_POST['n_id'];
        
        $restaurant_id = 0;
        if (isset($_POST['r_id']) && $_POST['r_id'] > 0) {
            $restaurant_id = $_POST['r_id'];
        }
        
        $foodsearch_menu_builder_object = MenuBuilder::instance();
        $content = $foodsearch_menu_builder_object->menu_items_bywhere_id($menu_id, $user_id, $restaurant_id);
        
        $responsedata = array('status' => 'success', 'html' => $content);
        wp_send_json($responsedata);
        wp_die();
    }
    
    public function menu_itm_detail_byID() {
        
        $foodsearch_menu_builder_object = MenuBuilder::instance();
        
        $content = $foodsearch_menu_builder_object->add_menuitems();
        $responsedata = array('status' => 'success', 'html' => $content);
        wp_send_json($responsedata);
        wp_die();
    }
    
    public function update_item_category_form() {
        
        $foodsearch_menu_builder_object = MenuBuilder::instance();
        
        $content = $foodsearch_menu_builder_object->updateItemCategoryForm();
        $responsedata = array('status' => 'success', 'html' => $content);
        wp_send_json($responsedata);
        wp_die();
    }
    public function update_item_category() {
      // echo '<pre>'.print_r($_REQUEST,true).'</pre>';
        $responsedata = array('status' => 'error', 'results' => array(), 'msg' => esc_html__('please fill all required fileds', 'wp-foodsearch'));
        if (isset($_REQUEST['cat_item_description']) && !empty($_REQUEST['cat_item_description'])) {
            $term = get_term_meta($_REQUEST['category'],'_'.$_REQUEST['resturant_id'].'_cat_item_desc');
            if($term){
                $res = update_term_meta($_REQUEST['category'],'_'.$_REQUEST['resturant_id'].'_cat_item_desc',$_REQUEST['cat_item_description']);
            }
            else{
                $res = add_term_meta( $_REQUEST['category'], '_'.$_REQUEST['resturant_id'].'_cat_item_desc', $_REQUEST['cat_item_description'] );
            }
            
            if ( ! is_wp_error( $res ) ) {
                $responsedata = array('status' => 'success', 'msg' => esc_html__('Item category updated successfully', 'wp-foodsearch'));
            } else {
                $responsedata = array('status' => 'error', 'msg' => esc_html__('opps! some error occur while inserting data, please contact to support team or try after some time again.', 'wp-foodsearch'));
            }
        }
        wp_send_json($responsedata);
       wp_die();
    }
    
    public function menu_itm_update_byID() {
        
        $foodsearch_menu_builder_object = MenuBuilder::instance();
        
        $content = $foodsearch_menu_builder_object->edit_menuitems();
        $responsedata = array('status' => 'success', 'html' => $content);
        wp_send_json($responsedata);
        wp_die();
    }
    
    public function food_menu_add_inlist() {
        
        $foodsearch_menu_builder_object = MenuBuilder::instance();
        
        $content = $foodsearch_menu_builder_object->add_menu();
        $responsedata = array('status' => 'success', 'html' => $content);
        wp_send_json($responsedata);
        wp_die();
    }
    
    public function food_menu_edit_byid() {
        
        $foodsearch_menu_builder_object = MenuBuilder::instance();
        
        $content = $foodsearch_menu_builder_object->edit_menu();
        $responsedata = array('status' => 'success', 'html' => $content);
        wp_send_json($responsedata);
        wp_die();
    }
    
    public function food_menu_add_catpop() {
        
        $foodsearch_menu_builder_object = MenuBuilder::instance();
        
        $content = $foodsearch_menu_builder_object->add_category();
        $responsedata = array('status' => 'success', 'html' => $content);
        wp_send_json($responsedata);
        wp_die();
    }

    public function categorySave() {
        
        $responsedata = array('status' => 'error', 'results' => array(), 'msg' => esc_html__('please fill all required fileds', 'wp-foodsearch'));
        if (isset($_REQUEST['title']) && !empty($_REQUEST['title']) && isset($_REQUEST['menu_opening_days']) && !empty($_REQUEST['menu_opening_days']) && isset($_REQUEST['menu_start_time']) && !empty($_REQUEST['menu_start_time']) && isset($_REQUEST['menu_end_time']) && !empty($_REQUEST['menu_end_time'])) {
            global $table_prefix, $wpdb;
            $table_name = $table_prefix . 'menus';
            $slug = str_replace(' ', '-', $_REQUEST['title']);
            $data['slug'] = $slug;
            $data['name'] = $_REQUEST['title'];
            $data['menu_opening_days'] = json_encode($_REQUEST['menu_opening_days'], true);
            $data['menu_start_time'] = foodsearch_esc_html($_REQUEST['menu_start_time']);
            $data['menu_end_time'] = foodsearch_esc_html($_REQUEST['menu_end_time']);
            $data['restaurant_id'] = foodsearch_esc_html($_REQUEST['restaurant_id']);
            $data['details'] = foodsearch_esc_html($_REQUEST['details']);
            $data['status'] = foodsearch_esc_html($_REQUEST['status']);
            $wpdb->insert($table_name, $data);
            if ($wpdb->insert_id != 0) {
                $responsedata = array('status' => 'success', 'msg' => esc_html__('new menu created successfully', 'wp-foodsearch'));
            } else {
                $responsedata = array('status' => 'error', 'msg' => esc_html__('opps! some error occur while inserting data, please contact to support team or try after some time again.', 'wp-foodsearch'));
            }
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function menuSave() {
        if ($this->to_check_nonce()) {
            if (!isset($_POST['menu_save_nonce']) || !wp_verify_nonce($_POST['menu_save_nonce'], 'adding_menu')) {
                $responsedata = array('status' => 'error', 'results' => array(), 'msg' => 'Session token has expired, please reload the page and try again.');
                wp_send_json($responsedata);
            }
        }

        $responsedata = array('status' => 'error', 'results' => array(), 'msg' => esc_html__('please fill all required fileds', 'wp-foodsearch'));
        if (isset($_REQUEST['title']) && !empty($_REQUEST['title']) && isset($_REQUEST['menu_opening_days']) && !empty($_REQUEST['menu_opening_days']) && isset($_REQUEST['menu_start_time']) && !empty($_REQUEST['menu_start_time']) && isset($_REQUEST['menu_end_time']) && !empty($_REQUEST['menu_end_time'])) {
            global $table_prefix, $wpdb;
            $table_name = $table_prefix . 'menus';
            $menu_title = foodsearch_esc_html($_REQUEST['title']);
            $slug = str_replace(' ', '-', $menu_title);
            
            $status = isset($_REQUEST['status']) ? $_REQUEST['status'] : 2;
            
            $openin_days = foodsearch_esc_html($_REQUEST['menu_opening_days']);
            $data['slug'] = $slug;
            $data['name'] = $menu_title;
            $data['menu_opening_days'] = json_encode($openin_days, true);
            $data['menu_start_time'] = foodsearch_esc_html($_REQUEST['menu_start_time']);
            $data['menu_end_time'] = foodsearch_esc_html($_REQUEST['menu_end_time']);
            $data['restaurant_id'] = foodsearch_esc_html($_REQUEST['restaurant_id']);
            $data['details'] = foodsearch_esc_html($_REQUEST['details']);
            $data['status'] = foodsearch_esc_html($status);
            $wpdb->insert($table_name, $data);
            if ($wpdb->insert_id != 0) {
                $responsedata = array('status' => 'success', 'msg' => esc_html__('new menu created successfully', 'wp-foodsearch'));
            } else {
                $responsedata = array('status' => 'error', 'msg' => esc_html__('opps! some error occur while inserting data, please contact to support team or try after some time again.', 'wp-foodsearch'));
            }
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function menuUpdate() {
        if ($this->to_check_nonce()) {
            if (!isset($_POST['menu_save_nonce']) || !wp_verify_nonce($_POST['menu_save_nonce'], 'updating_menu')) {
                $responsedata = array('status' => 'error', 'results' => array(), 'msg' => 'Session token has expired, please reload the page and try again.');
                wp_send_json($responsedata);
            }
        }
        $responsedata = array('status' => 'error', 'results' => array(), 'msg' => esc_html__('please fill all required fileds', 'wp-foodsearch'));
        if (isset($_REQUEST['title']) && isset($_REQUEST['menu_opening_days']) && isset($_REQUEST['menu_start_time']) && isset($_REQUEST['menu_end_time']) && !empty($_REQUEST['title']) && !empty($_REQUEST['menu_opening_days']) && !empty($_REQUEST['menu_start_time']) && !empty($_REQUEST['menu_end_time'])) {
            global $table_prefix, $wpdb;
            $table_name = $table_prefix . 'menus';
            $menu_title = foodsearch_esc_html($_REQUEST['title']);
            $slug = str_replace(' ', '-', $menu_title);
            $openin_days = foodsearch_esc_html($_REQUEST['menu_opening_days']);
            $data['slug'] = $slug;
            $data['name'] = $menu_title;
            $data['menu_opening_days'] = json_encode($openin_days, true);
            $data['menu_start_time'] = foodsearch_esc_html($_REQUEST['menu_start_time']);
            $data['menu_end_time'] = foodsearch_esc_html($_REQUEST['menu_end_time']);
            $data['restaurant_id'] = foodsearch_esc_html($_REQUEST['restaurant_id']);
            $data['details'] = foodsearch_esc_html($_REQUEST['details']);
            $data['status'] = isset($_REQUEST['status'])?foodsearch_esc_html($_REQUEST['status']):'';
            $where['id'] = foodsearch_esc_html($_REQUEST['id']);
            $result = $wpdb->update($table_name, $data, $where);

            if ($result >= 0) {
                $responsedata = array('status' => 'success', 'msg' => esc_html__('menu updated successfully', 'wp-foodsearch'));
            } else {
                $responsedata = array('status' => 'error', 'msg' => esc_html__('you have not change any form data', 'wp-foodsearch'));
            }
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function menuItemUpdate() {
        if ($this->to_check_nonce()) {
            if (!isset($_POST['menu_item_nonce']) || !wp_verify_nonce($_POST['menu_item_nonce'], 'updating_menuitem')) {
                $responsedata = array('status' => 'error', 'results' => array(), 'msg' => 'Session token has expired, please reload the page and try again.');
                wp_send_json($responsedata);
            }
        }
        $responsedata = array('status' => 'error', 'results' => array(), 'msg' => esc_html__('please fill all required fileds', 'wp-foodsearch'));
        if (isset($_REQUEST['menu_id']) && isset($_REQUEST['title']) && isset($_REQUEST['category'])) {
            global $table_prefix, $wpdb;
            $table_name = $table_prefix . 'menu_items';

            $variationData = array();
            if (!empty($_POST['variation_name'])) {
                $variation_prices = [];
                foreach ($_REQUEST['variation_name'] as $key => $group) {
                    if (!empty($group)) {
                        $variationData[] = array('variation_name' => foodsearch_esc_html($group), 'variation_price' => foodsearch_esc_html($_POST['variation_price'][$key]));
                        $variation_prices[] = foodsearch_esc_html($_POST['variation_price'][$key]);

                        $data['discount_price'] = 0;
                    }
                }
                if (!empty($variation_prices)) {
                    $_REQUEST['price'] = min($variation_prices);
                }
            }
            
            $choice_group_val = '';
            if (isset($_REQUEST['item_choice_gruop']) && !empty($_REQUEST['item_choice_gruop'])) {
                $choice_group_val = implode(',', $_REQUEST['item_choice_gruop']);
            }
            
            $restaurant_id = SELF::resturantIdOnMenuID($_REQUEST['menu_id']);
            $category_id = foodsearch_esc_html($_REQUEST['category']);
            
            $data['name'] = foodsearch_esc_html($_REQUEST['title']);
            $data['status'] = foodsearch_esc_html($_REQUEST['status']);
            $data['price'] = foodsearch_esc_html($_REQUEST['price']);
            $data['discount_price'] = foodsearch_esc_html($_REQUEST['discount_price']);
            $data['offer_status'] = (isset($_REQUEST['offer_status']) || $_REQUEST['offer_status'] == 'on' ? 1 : 0);
            $data['attachment_id'] = foodsearch_esc_html($_REQUEST['image']);
            $data['menu_id'] = foodsearch_esc_html($_REQUEST['menu_id']);
            $data['restaurant_id'] = $restaurant_id;
            $data['variations'] = json_encode($variationData, true);
            $data['category_id'] = $category_id;
            $data['choice_groups_id'] = foodsearch_esc_html($choice_group_val);
            $data['details'] = foodsearch_esc_html($_REQUEST['item_details']);
            $where['id'] = foodsearch_esc_html($_REQUEST['id']);

            $result = $wpdb->update($table_name, $data, $where);
            
            //
            if ($category_id > 0) {
                wp_set_post_terms($restaurant_id, array($category_id), 'food_item_cat', true);
                do_action('foodsearch_aftersave_restaurant_taxcats', $restaurant_id);
            }
            //

            $item_nutritions = '';
            if (isset($_REQUEST['item_nutritions'])) {
                $item_nutritions = $_REQUEST['item_nutritions'];
            }
            if (!empty($item_nutritions)) {
                $item_nutritions = implode(',', $item_nutritions);
            }

            $menu_item_id = $_REQUEST['id'];

            $table_name = $table_prefix . 'menu_itemmeta';
            $meta_query = "SELECT menu_meta_id FROM $table_name WHERE menu_item_id=$menu_item_id AND meta_key='item_nutritions'";
            $meta_id = $wpdb->get_col($meta_query);
            if (isset($meta_id[0])) {

                $meta_row_id = $meta_id[0];

                $data = array();
                $data['menu_item_id'] = $menu_item_id;
                $data['meta_key'] = 'item_nutritions';
                $data['meta_value'] = $item_nutritions;

                $where = array('menu_meta_id' => $meta_row_id);
                $wpdb->update($table_name, $data, $where);
            } else {
                $data = array();
                $data['menu_item_id'] = $menu_item_id;
                $data['meta_key'] = 'item_nutritions';
                $data['meta_value'] = $item_nutritions;

                $wpdb->insert($table_name, $data);
            }

            $responsedata = array('status' => 'success', 'msg' => esc_html__('menu item updated successfully', 'wp-foodsearch'));
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function menuItemSave() {
        if ($this->to_check_nonce()) {
            if (!isset($_POST['menu_item_nonce']) || !wp_verify_nonce($_POST['menu_item_nonce'], 'adding_menuitem')) {
                $responsedata = array('status' => 'error', 'results' => array(), 'msg' => 'Session token has expired, please reload the page and try again.');
                wp_send_json($responsedata);
            }
        }
        $responsedata = array('status' => 'error', 'results' => array(), 'msg' => 'Please Fill all required Fileds');
        if (isset($_REQUEST['menu_id']) && isset($_REQUEST['title']) && isset($_REQUEST['category']) && !empty($_REQUEST['menu_id']) && !empty($_REQUEST['title']) && !empty($_REQUEST['category'])) {
            global $table_prefix, $wpdb;
            $table_name = $table_prefix . 'menu_items';
            $variationData = array();
            if (!empty($_REQUEST['variation_name'])) {
                $variation_prices = [];
                foreach ($_REQUEST['variation_name'] as $key => $group) {
                    if (!empty($group)) {
                        $variationData[] = array('variation_name' => foodsearch_esc_html($group), 'variation_price' => foodsearch_esc_html($_REQUEST['variation_price'][$key]));
                        $variation_prices[] = foodsearch_esc_html($_POST['variation_price'][$key]);
                    }
                }
                if (!empty($variation_prices)) {
                    $_REQUEST['price'] = min($variation_prices);
                }
            }
            $menu_id = $_REQUEST['menu_id'];
            $category_id = $_REQUEST['category'];
            
            $restaurant_id = SELF::resturantIdOnMenuID($_REQUEST['menu_id']);

            $data['name'] = foodsearch_esc_html($_REQUEST['title']);
            $data['price'] = foodsearch_esc_html($_REQUEST['price']);
            $data['discount_price'] = foodsearch_esc_html($_REQUEST['discount_price']);
            $data['offer_status'] = foodsearch_esc_html($_REQUEST['offer_status']);
            $data['attachment_id'] = foodsearch_esc_html($_REQUEST['image']);
            $data['menu_id'] = foodsearch_esc_html($_REQUEST['menu_id']);
            $data['restaurant_id'] = $restaurant_id;
            $data['variations'] = json_encode($variationData, true);
            $data['category_id'] = foodsearch_esc_html($_REQUEST['category']);
            $data['choice_groups_id'] = !empty($_REQUEST['item_choice_gruop']) ? implode(',', $_REQUEST['item_choice_gruop']) : '';
            $data['details'] = foodsearch_esc_html($_REQUEST['item_details']);
            $data['status'] = foodsearch_esc_html($_REQUEST['status']);
            $wpdb->insert($table_name, $data);
            if ($wpdb->insert_id != 0) {
                
                if ($category_id > 0) {
                    wp_set_post_terms($restaurant_id, array($category_id), 'food_item_cat', true);
                    do_action('foodsearch_aftersave_restaurant_taxcats', $restaurant_id);
                }
                
                $menu_item_id = $wpdb->insert_id;
                if (isset($_REQUEST['item_nutritions']) && !empty($_REQUEST['item_nutritions'])) {
                    $item_nutritions = $_REQUEST['item_nutritions'];
                    
                    $data = array();
                    $data['menu_item_id'] = $menu_item_id;
                    $data['meta_key'] = 'item_nutritions';
                    $data['meta_value'] = implode(',', $item_nutritions);
                    
                    $table_name = $table_prefix . 'menu_itemmeta';
                    $wpdb->insert($table_name, $data);
                }
                
                $responsedata = array('status' => 'success', 'item_id' => $menu_item_id, 'menu_id' => $menu_id, 'cat_id' => $category_id, 'msg' => esc_html__('new menu item created successfully', 'wp-foodsearch'));
            } else {
                $responsedata = array('status' => 'error', 'msg' => $wpdb->last_error);
            }
        }

        wp_send_json($responsedata);
        wp_die();
    }

    public function add_menuitem_html_to_list() {
        $responsedata = array('status' => 'error', 'result' => '', 'msg' => esc_html__('no menu item found.', 'wp-foodsearch'));

        if (isset($_REQUEST['menu_item_id']) && $_REQUEST['menu_item_id'] != '') {
            global $table_prefix, $wpdb;
            $menu_item_id = $_REQUEST['menu_item_id'];
            $table_name = $table_prefix . 'menu_items';
            $sql = "SELECT * FROM $table_name WHERE 1=1 AND id=$menu_item_id";

            $result = $wpdb->get_results($sql);
            
            $common_functions = new Common_Functions;

            $menuitem = '';

            if (isset($result[0]->id)) {
                $menuitem = $result[0];
            }

            if (!empty($menuitem)) {
                $restaurant_id = $menuitem->restaurant_id;
                $restaurant_user_id = Common_Functions::restaurant_user_id($restaurant_id);
                $menu_id = $menuitem->id;
                
                $menu_price = $menuitem->price;
                $menu_discount_price = $menuitem->discount_price;

                $menu_offer_status = $menuitem->offer_status;
                
                $menu_nutritions = $common_functions->get_menu_item_nutritions($restaurant_id, $menu_id);
                $nutritions_html = '';
                if (!empty($menu_nutritions)) {
                    $nutritions_html .= '<div class="fds-builder-veg">';
                    foreach ($menu_nutritions as $nutri_key => $nutri_item) {
                        $nutri_label = $nutri_item['title'];
                        $nutri_img = $nutri_item['image'];
                        $image_thumb = wp_get_attachment_image_src($nutri_img);
                        $image_src = isset($image_thumb[0]) ? $image_thumb[0] : '';
                        $nutritions_html .= '<a class="fds-link"><img src="' . $image_src . '" title="' . $nutri_label . '"></a>';
                    }
                    $nutritions_html .= '</div>';
                }
                
                $html = '<div class="fds-menu-builder-inn">
                    <div class="fds-menu-builder-inn-cell">
                    <i class="fds-icon fds-move-drager fds-builder-inner-drager menu-item-sorter"></i>
                        <div class="fds-builder-thumb">';
                $image_id = $menuitem->attachment_id;
                $image = wp_get_attachment_image_src($image_id);
                $html .= '<a href="#" class="fds-menu-item-thumb fds-link" style="background: url(' . (isset($image[0]) ? $image[0] : '') . ') no-repeat top center / cover; "></a>
                            <div class="fds-builder-content">
                                <input type="hidden" name="foodsearch_menu_sort[item_id][]" value="' . $menuitem->id . '">
                                <input type="hidden" name="foodsearch_menu_sort[item_cat_id][]" value="' . $menuitem->category_id . '">
                                <input type="hidden" name="foodsearch_menu_sort[menu_id][]" value="' . $menuitem->menu_id . '">
                                <input type="hidden" name="foodsearch_menu_sort[restaurant_id][]" value="' . $menuitem->restaurant_id . '">
                                <input type="hidden" name="foodsearch_menu_sort[item_position][]">
                                <a href="#" class="fds-link">' . $menuitem->name . '</a>
                                <p>' . $menuitem->details . '</p>
                            </div>
                        </div>
                    </div>
                    <div class="fds-menu-builder-inn-cell">
                        ' . $nutritions_html . '
                    </div>
                    <div class="fds-menu-builder-inn-cell">
                        ' . ($menu_discount_price > 0 ? '<span class="fds-item-price fds-actual-price">' . Common_Functions::get_formatted_price($menu_price, 'menu-item') . '</span> <strong class="fds-discount-price">' . Common_Functions::get_formatted_price($menu_discount_price, 'menu-item') . '</strong>' : '<span class="fds-item-price">' . Common_Functions::get_formatted_price($menu_price, 'menu-item') . '</span>') . ($menu_offer_status == 1 ? ' <small class="fds-special-offer">' . esc_html__('special offer', 'wp-foodsearch') . '</small>' : '') . '
                    </div>
                    <div class="fds-menu-builder-inn-cell">
                        <div class="fds-menu-ations">
                            <a href="#" class="fds-body-action byeditmenuitem fds-link" data-id="' . $menuitem->id . '" data-nid="' . $restaurant_user_id . '"><i class="fds-icon fds-edit"></i></a><a href="#" class="fds-body-action fds-remove-action delet-action remove-foodmenu-item fds-link" data-id="' . $menuitem->id . '" data-mid="' . $menuitem->menu_id . '"><i class="fds-icon fds-time-simple"></i></a>
                        </div>
                    </div>
                </div>';

                $responsedata = array('status' => 'success', 'result' => $html, 'msg' => esc_html__('menu item append in html.', 'wp-foodsearch'));
            }
        }

        wp_send_json($responsedata);
        wp_die();
    }

    public function sort_menu_items() {
        $responsedata = array('status' => 'error', 'msg' => esc_html__('no menu item found.', 'wp-foodsearch'));

        if (isset($_REQUEST['foodsearch_menu_sort']['item_id']) && !empty($_REQUEST['foodsearch_menu_sort']['item_id']) && is_array($_REQUEST['foodsearch_menu_sort']['item_id'])) {
            global $table_prefix, $wpdb;
            $table_name = $table_prefix . 'menu_items';
            $menu_sort_items = $_REQUEST['foodsearch_menu_sort']['item_id'];

            $menu_sort_positions = $_REQUEST['foodsearch_menu_sort']['item_position'];
            $menu_sort_categories = $_REQUEST['foodsearch_menu_sort']['item_cat_id'];
            $menu_sort_menu_ids = $_REQUEST['foodsearch_menu_sort']['menu_id'];
            $menu_sort_rest_ids = $_REQUEST['foodsearch_menu_sort']['restaurant_id'];

            $itm_countr = 0;
            foreach ($menu_sort_items as $menu_item_id) {
                $restaurant_id = $menu_sort_rest_ids[$itm_countr];
                $menu_id = $menu_sort_menu_ids[$itm_countr];
                $cat_id = $menu_sort_categories[$itm_countr];
                $sort_pos = $menu_sort_positions[$itm_countr];
                $wpdb->update($table_name, array('category_id' => $cat_id, 'sort_order' => $sort_pos), array('id' => $menu_item_id));
                
                if ($cat_id > 0) {
                    wp_set_post_terms($restaurant_id, array($cat_id), 'food_item_cat', true);
                    do_action('foodsearch_aftersave_restaurant_taxcats', $restaurant_id);
                }

                // activating idle items in category if any
                $sql = "SELECT id FROM $table_name WHERE 1=1 AND restaurant_id=$restaurant_id AND menu_id=$menu_id AND category_id=$cat_id AND status=1";
                $results = $wpdb->get_col($sql);
                if (!empty($results)) {
                    foreach ($results as $menu_item_id) {
                        $wpdb->update($table_name, array('status' => '2', 'sort_order' => $sort_pos), array('id' => $menu_item_id));
                    }
                }
                //
                $itm_countr++;
            }
            $responsedata = array('status' => 'success', 'msg' => esc_html__('menu item sorted successfully.', 'wp-foodsearch'));
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function unlink_menu_items_category() {
        $responsedata = array('status' => 'error', 'msg' => esc_html__('no menu items found.', 'wp-foodsearch'));

        if (isset($_REQUEST['restaurant_id']) && $_REQUEST['restaurant_id'] > 0 && isset($_REQUEST['menu_id']) && $_REQUEST['menu_id'] > 0 && isset($_REQUEST['cat_id']) && $_REQUEST['cat_id'] > 0) {
            global $table_prefix, $wpdb;
            $table_name = $table_prefix . 'menu_items';

            $restaurant_id = $_REQUEST['restaurant_id'];
            $menu_id = $_REQUEST['menu_id'];
            $cat_id = $_REQUEST['cat_id'];

            $sql = "SELECT id FROM $table_name WHERE 1=1 AND restaurant_id=$restaurant_id AND menu_id=$menu_id AND category_id=$cat_id";

            $results = $wpdb->get_col($sql);
            if (!empty($results)) {
                foreach ($results as $menu_item_id) {
                    $wpdb->update($table_name, array('status' => '1'), array('id' => $menu_item_id));
                }
            }
            
            $sql = "SELECT category_id FROM $table_name WHERE 1=1 AND restaurant_id=$restaurant_id AND menu_id=$menu_id AND status=2";
            $results = $wpdb->get_col($sql);
            $cats = [];
            if (!empty($results)) {
                foreach ($results as $menu_cat_id) {
                    if (!in_array($menu_cat_id, $cats)) {
                        $cats[] = $menu_cat_id;
                    }
                }
            }
            wp_set_post_terms($restaurant_id, $cats, 'food_item_cat', false);
            do_action('foodsearch_aftersave_restaurant_taxcats', $restaurant_id);

            $responsedata = array('status' => 'success', 'msg' => esc_html__('menu category unlinked.', 'wp-foodsearch'));
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function foodCategorySave() {
        $responsedata = array('status' => 'error', 'results' => array(), 'msg' => esc_html__('please fill all required fileds', 'wp-foodsearch'));
        if (isset($_REQUEST['menu_id']) && isset($_REQUEST['title']) && isset($_REQUEST['category']) && !empty($_REQUEST['menu_id']) && !empty($_REQUEST['title']) && !empty($_REQUEST['category'])) {
            global $table_prefix, $wpdb;
            $table_name = $table_prefix . 'menu_items';
            $variationData = array();
            if (!empty($_REQUEST['variation_name'])) {
                foreach ($_REQUEST['variation_name'] as $key => $group) {
                    if (!empty($group)) {
                        $variationData[] = array('variation_name' => $group, 'variation_price' => $_REQUEST['variation_price'][$key]);
                        $_REQUEST['price'] = ($_REQUEST['price'] > $_REQUEST['variation_price'][$key]) ? $_REQUEST['variation_price'][$key] : $_REQUEST['price'];
                    }
                }
            }

            $data['name'] = foodsearch_esc_html($_REQUEST['title']);
            $data['price'] = foodsearch_esc_html($_REQUEST['price']);
            $data['discount_price'] = foodsearch_esc_html($_REQUEST['discount_price']);
            $data['offer_status'] = foodsearch_esc_html($_REQUEST['offer_status']);
            $data['attachment_id'] = foodsearch_esc_html($_REQUEST['image']);
            $data['menu_id'] = foodsearch_esc_html($_REQUEST['menu_id']);
            $data['restaurant_id'] = SELF::resturantIdOnMenuID($_REQUEST['menu_id']);
            $data['variations'] = json_encode($variationData, true);
            $data['category_id'] = foodsearch_esc_html($_REQUEST['category']);
            $data['choice_groups_id'] = implode(',', $_REQUEST['item_choice_gruop']);
            $data['details'] = foodsearch_esc_html($_REQUEST['item_details']);
            $data['status'] = foodsearch_esc_html($_REQUEST['status']);
            $wpdb->insert($table_name, $data);
            if ($wpdb->insert_id != 0) {
                $responsedata = array('status' => 'success', 'msg' => esc_html__('new menu item created successfully', 'wp-foodsearch'));
            } else {
                $responsedata = array('status' => 'error', 'msg' => $wpdb->last_error);
            }
        }

        wp_send_json($responsedata);
        wp_die();
    }

    public function foodCategoryUpdate() {
        $responsedata = array('status' => 'error', 'results' => array(), 'msg' => esc_html__('please fill all required fileds', 'wp-foodsearch'));
        if (isset($_REQUEST['menu_id']) && isset($_REQUEST['title']) && isset($_REQUEST['category'])) {
            global $table_prefix, $wpdb;
            $table_name = $table_prefix . 'menu_items';

            if (!empty($_POST['variation_name'])) {
                $variationData = array();
                foreach ($_REQUEST['variation_name'] as $key => $group) {
                    if (!empty($group)) {
                        $variationData[] = array('variation_name' => $group, 'variation_price' => $_POST['variation_price'][$key]);
                        $_REQUEST['price'] = ($_REQUEST['price'] > $_POST['variation_price'][$key]) ? $_POST['variation_price'][$key] : $_REQUEST['price'];

                        $data['discount_price'] = 0;
                    }
                }
            }
            $data['name'] = foodsearch_esc_html($_REQUEST['title']);
            $data['status'] = foodsearch_esc_html($_REQUEST['status']);
            $data['price'] = foodsearch_esc_html($_REQUEST['price']);
            $data['discount_price'] = foodsearch_esc_html($_REQUEST['discount_price']);
            $data['offer_status'] = (isset($_REQUEST['offer_status']) || $_REQUEST['offer_status'] == 'on' ? 1 : 0);
            $data['attachment_id'] = foodsearch_esc_html($_REQUEST['image']);
            $data['menu_id'] = foodsearch_esc_html($_REQUEST['menu_id']);
            $data['restaurant_id'] = SELF::resturantIdOnMenuID($_REQUEST['menu_id']);
            $data['variations'] = json_encode($variationData, true);
            $data['category_id'] = foodsearch_esc_html($_REQUEST['category']);
            $data['choice_groups_id'] = implode(',', $_REQUEST['item_choice_gruop']);
            $data['details'] = foodsearch_esc_html($_REQUEST['item_details']);
            $where['id'] = foodsearch_esc_html($_REQUEST['id']);
            $result = $wpdb->update($table_name, $data, $where);
            if ($result != 0) {
                $responsedata = array('status' => 'success', 'msg' => esc_html__('menu item updated successfully', 'wp-foodsearch'));
            } else {
                $responsedata = array('status' => 'error', 'msg' => esc_html__('you have not change any form data.', 'wp-foodsearch'));
            }
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function choiceGroupSave() {
        if ($this->to_check_nonce()) {
            if (!isset($_POST['choice_group_nonce']) || !wp_verify_nonce($_POST['choice_group_nonce'], 'choice_group')) {
                $responsedata = array('status' => 'error', 'results' => array(), 'msg' => 'Session token has expired, please reload the page and try again.');
                wp_send_json($responsedata);
            }
        }
        $responsedata = array('status' => 'error', 'results' => array(), 'msg' => esc_html__('please fill all required fileds', 'wp-foodsearch'));
        // `name`, `min`, `max`, `menuItem_id`, `restaurant_id`
        if (isset($_REQUEST['name']) && !empty($_REQUEST['name']) && isset($_REQUEST['restaurant_id']) && !empty($_REQUEST['restaurant_id']) && isset($_REQUEST['min']) && isset($_REQUEST['max']) && !empty($_REQUEST['max'])) {
            global $table_prefix, $wpdb;
            $table_name = $table_prefix . 'menu_choice_group';
            $variationData = array();
            if (!empty($_POST['item_id'])) {
                foreach ($_REQUEST['item_id'] as $key => $group) {
                    if (!empty($group)) {
                        $variationData[] = array('item_id' => foodsearch_esc_html($group), 'item_price' => foodsearch_esc_html($_POST['item_price'][$key]));
                        $_REQUEST['price'] = ($_REQUEST['price'] > $_POST['item_price'][$key]) ? foodsearch_esc_html($_POST['item_price'][$key]) : foodsearch_esc_html($_REQUEST['price']);
                    }
                }
            }
            $data['name'] = foodsearch_esc_html($_REQUEST['name']);
            $data['min'] = foodsearch_esc_html($_REQUEST['min']);
            $data['max'] = foodsearch_esc_html($_REQUEST['max']);
            $data['menuItem_id'] = json_encode($variationData, true);
            $data['restaurant_id'] = foodsearch_esc_html($_REQUEST['restaurant_id']);
            $data['status'] = 2;
            $wpdb->insert($table_name, $data);
            if ($wpdb->insert_id != 0) {
                $responsedata = array('status' => 'success', 'msg' => esc_html__('new choice group created successfully', 'wp-foodsearch'));
            } else {
                $responsedata = array('status' => 'error', 'msg' => esc_html__('opps! some error occur while inserting data, please contact to support team or try after some time again.', 'wp-foodsearch'));
            }
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function choiceGroupUpdate() {
        if ($this->to_check_nonce()) {
            if (!isset($_POST['choice_group_nonce']) || !wp_verify_nonce($_POST['choice_group_nonce'], 'choice_group')) {
                $responsedata = array('status' => 'error', 'results' => array(), 'msg' => 'Session token has expired, please reload the page and try again.');
                wp_send_json($responsedata);
            }
        }
        $responsedata = array('status' => 'error', 'results' => array(), 'msg' => esc_html__('please fill all required fileds', 'wp-foodsearch'));
        if (isset($_REQUEST['name']) && !empty($_REQUEST['name']) && isset($_REQUEST['restaurant_id']) && !empty($_REQUEST['restaurant_id']) && isset($_REQUEST['min']) && isset($_REQUEST['max']) && !empty($_REQUEST['max'])) {
            global $table_prefix, $wpdb;
            $table_name = $table_prefix . 'menu_choice_group';
            $variationData = array();
            if (!empty($_POST['item_id'])) {
                foreach ($_REQUEST['item_id'] as $key => $group) {
                    if (!empty($group)) {
                        $variationData[] = array('item_id' => foodsearch_esc_html($group), 'item_price' => foodsearch_esc_html($_POST['item_price'][$key]));
                        $_REQUEST['price'] = ($_REQUEST['price'] > $_POST['item_price'][$key]) ? foodsearch_esc_html($_POST['item_price'][$key]) : foodsearch_esc_html($_REQUEST['price']);
                    }
                }
            }
            $data['name'] = foodsearch_esc_html($_REQUEST['name']);
            $data['min'] = foodsearch_esc_html($_REQUEST['min']);
            $data['max'] = foodsearch_esc_html($_REQUEST['max']);
            $data['status'] = foodsearch_esc_html($_REQUEST['status']);
            $data['menuItem_id'] = json_encode($variationData, true);
            $data['restaurant_id'] = foodsearch_esc_html($_REQUEST['restaurant_id']);
            $data['status'] = 2;
            
            $where['id'] = $_REQUEST['id'];
            $result = $wpdb->update($table_name, $data, $where);
            if ($result != 0) {
                $responsedata = array('status' => 'success', 'msg' => esc_html__('choice group updated successfully', 'wp-foodsearch'));
            } else {
                $responsedata = array('status' => 'error', 'msg' => esc_html__('you have not change any form data', 'wp-foodsearch'));
            }
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function menuDetailByID() {
        
        $responsedata = array('status' => 'error', 'results' => array());
        if (isset($_REQUEST['id'])) {
            global $table_prefix, $wpdb;
            $table_name = $table_prefix . 'menus';
            $where = ' where id =' . $_REQUEST['id'];
            $query = "SELECT * FROM $table_name$where";
            $results = $wpdb->get_results($query, 'ARRAY_A');
            if (!empty($results)) { // Checking if $results have some values or not
                $responsedata['status'] = 'success';
                foreach ($results as $row) {
                    $responsedata['results'][] = $row;
                }
            }
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function restaurantList() {
        $args = array(
            'post_type' => 'restaurants'
        );
        if (isset($_GET['filter'])) {
            $filter = $_GET['filter'];

            if ($filter == 'category') {
                $category = $_GET['val'];
                $tax_query = array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'food_item_cat',
                        'field' => 'slug',
                        'terms' => $category,
                    ),
                    array(
                        'taxonomy' => 'food_item_cat',
                        'field' => 'name',
                        'terms' => $category,
                    ),
                );
                $args = array(
                    'post_type' => 'restaurants',
                    'tax_query' => $tax_query
                );
            } elseif ($filter == 'tags') {
                $category = $_GET['val'];
                $tax_query = array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'restaurant_tag',
                        'field' => 'slug',
                        'terms' => $category,
                    ),
                    array(
                        'taxonomy' => 'restaurant_tag',
                        'field' => 'name',
                        'terms' => $category,
                    ),
                );
                $args = array(
                    'post_type' => 'restaurants',
                    'tax_query' => $tax_query
                );
            }
        }
        $myposts = get_posts($args);
        $metas = array('restaurant_address', 'restaurant_cod', 'restaurant_city', 'restaurant_country', 'restaurant_latitude', 'restaurant_longitude', 'restaurant_contact_no', 'restaurant_email', 'manager_no', 'manager_name', 'min_delivery_order', 'min_pickup_order', 'delivery_fee', 'pickup_time', 'restaurant_other_detail', 'restaurant_banner', 'restaurant_monday_opening_hour', 'restaurant_monday_closing_hour', 'restaurant_monday_status', 'restaurant_tuesday_opening_hour', 'restaurant_tuesday_closing_hour', 'restaurant_tuesday_status', 'restaurant_wednesday_opening_hour', 'restaurant_wednesday_closing_hour', 'restaurant_wednesday_status', 'restaurant_thursday_opening_hour', 'restaurant_thursday_closing_hour', 'restaurant_thursday_status', 'restaurant_friday_opening_hour', 'restaurant_friday_closing_hour', 'restaurant_friday_status', 'restaurant_saturday_opening_hour', 'restaurant_saturday_closing_hour', 'restaurant_saturday_status', 'restaurant_sunday_opening_hour', 'restaurant_sunday_closing_hour', 'restaurant_sunday_status');
        if ($myposts) {
            $restaurants['status'] = 'success';
            foreach ($myposts as $key => $post) :
                setup_postdata($post);
                $post = json_decode(json_encode($post, true), true);
                $restaurants['content'][$key] = $post;
                $metafileds = array();
                foreach ($metas as $meta) {
                    $metafileds[$meta] = get_post_meta($post['ID'], $meta, true);
                }
                $restaurants['content'][$key]['metafileds'] = $metafileds;
            endforeach;
            wp_reset_postdata();
        } else {
            $restaurants = array('status' => 'error', 'content' => esc_html__('no data found', 'wp-foodsearch'));
        }
        wp_send_json($restaurants);
        wp_die();
    }

    public function restaurantdropdown() {
        $where = '';
        if (isset($_REQUEST['q'])) {
            $where = $_REQUEST['q'];
        }
        $args = array(
            'post_type' => 'restaurants',
            'posts_per_page' => 100,
            's' => $where,
        );

        $myposts = get_posts($args);
        if ($myposts) {
            $restaurants['status'] = 'success';
            foreach ($myposts as $key => $post) :
                setup_postdata($post);
                //  $post = json_decode(json_encode($post, true), true);
                $restaurants['results'][] = array('id' => $post->ID, 'text' => $post->post_title);
            endforeach;
            wp_reset_postdata();
        }
        else {
            $restaurants = array('status' => 'error', 'results' => array());
        }
        wp_send_json($restaurants);
        wp_die();
    }

    public function food_item_cats() {
        $taxonomy = 'food_item_cat';
        if (isset($_REQUEST['q'])) {
            $args = ['taxonomy' => $taxonomy,
                'hide_empty' => false,
                'name__like' => $_REQUEST['q'],
                'number' => 100
            ];
        } else {
            $args = [
                'taxonomy' => $taxonomy,
                'hide_empty' => false,
                'number' => 100
            ];
        }

        $terms = get_terms($args);
        $responsedata = array();
        $responsedata['status'] = 'success';
        foreach ($terms as $row) {
            $responsedata['results'][] = array('id' => $row->term_id, 'text' => $row->name, 'slug' => $row->slug);
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function food_menuitem_categories() {
        $responsedata = array();
        $responsedata['status'] = 'success';
        $responsedata['results'] = array();

        $menu_id = isset($_GET['menu_id']) ? $_GET['menu_id'] : '';
        $keyword = isset($_GET['search']) ? $_GET['search'] : '';

        if ($menu_id > 0) {
            $menu_cat_terms = array();
            global $table_prefix, $wpdb, $sitepress;
            $table_name = $table_prefix . 'menu_items';
            $sql = "SELECT * FROM $table_name where menu_id=$menu_id AND status=2";
            $results = $wpdb->get_results($sql);
            if (!empty($results)) {
                foreach ($results as $row) {
                    if ($row->category_id != '' && !in_array($row->category_id, $menu_cat_terms)) {
                        $menu_cat_terms[] = $row->category_id;
                    }
                }
            }

            $cats_query = "SELECT terms.term_id,terms.name FROM $wpdb->terms AS terms";
            $cats_query .= " LEFT JOIN $wpdb->term_taxonomy AS term_tax ON(terms.term_id = term_tax.term_id) ";

            if (function_exists('wpml_init_language_switcher')) {
                $trans_tble = $wpdb->prefix . 'icl_translations';
                $cats_query .= " LEFT JOIN $trans_tble AS icl_trans ON (terms.term_id = icl_trans.element_id)";
            }
            $cats_query .= " WHERE term_tax.taxonomy=%s";
            if (!empty($menu_cat_terms)) {
                $menu_cat_ids = implode(',', $menu_cat_terms);
                $cats_query .= " AND terms.term_id NOT IN ($menu_cat_ids)";
            }
            if ($keyword != '') {
                $cats_query .= " AND terms.name LIKE '%$keyword%'";
            }

            if (function_exists('wpml_init_language_switcher')) {
                $cats_query .= " AND icl_trans.element_type='tax_food_item_cat'";
                $cats_query .= " AND icl_trans.language_code='" . $sitepress->get_current_language() . "'";
            }
            $cats_query .= " GROUP BY terms.term_id";
            $cats_query .= " ORDER BY terms.term_id DESC LIMIT 100";

            $cat_terms = $wpdb->get_results($wpdb->prepare($cats_query, 'food_item_cat'), 'ARRAY_A');

            if (!empty($cat_terms)) {

                foreach ($cat_terms as $cat_term) {
                    $cat_id = $cat_term['term_id'];
                    $cat_title = $cat_term['name'];
                    $responsedata['results'][] = array('id' => $cat_id, 'text' => $cat_title);
                }
            }
        }

        wp_send_json($responsedata);
        wp_die();
    }

    public function add_menuitem_category() {
        $responsedata = array();
        $responsedata['status'] = 'error';
        $responsedata['result'] = array('msg' => esc_html__('no category found.', 'wp-foodsearch'));

        if (isset($_POST['cat_val']) && $_POST['cat_val'] != '') {
            $cat_id = 0;
            $cat = $_POST['cat_val'];
            if (is_numeric($cat)) {
                $cat_item = get_term_by('id', $cat, 'food_item_cat');
                if (isset($cat_item->term_id)) {
                    $cat_id = $cat_item->term_id;
                }
            } else {
                $cat_item = get_term_by('name', $cat, 'food_item_cat');
                if (isset($cat_item->term_id)) {
                    $cat_id = $cat_item->term_id;
                } else {
                    $new_cat = wp_insert_term($cat, 'food_item_cat');
                    if (isset($new_cat['term_id'])) {
                        $cat_id = $new_cat['term_id'];
                    }
                }
            }
            if ($cat_id > 0) {
                $responsedata['status'] = 'success';
                $responsedata['cat_id'] = $cat_id;
                $responsedata['result'] = array('msg' => esc_html__('category added.', 'wp-foodsearch'));
            }
        }

        wp_send_json($responsedata);
        wp_die();
    }
    
    public function remove_food_menu() {
        $menu_id = $_POST['n_id'];
        $restaurant_id = $_POST['restaurant'];

        global $table_prefix, $wpdb;
        
        // delete menu items
        $where = ' WHERE menu_id=' . $menu_id . ' AND restaurant_id=' . $restaurant_id;
        $table_name = $table_prefix . 'menu_items';

        $result = $wpdb->get_results("SELECT * FROM $table_name$where");

        if (isset($result[0])) {
            $wpdb->query("DELETE FROM $table_name WHERE menu_id=" . $menu_id);
        }
        
        // delete menu
        $where = ' WHERE id=' . $menu_id . ' AND restaurant_id=' . $restaurant_id;
        $table_name = $table_prefix . 'menus';

        $result = $wpdb->get_results("SELECT * FROM $table_name$where");

        if (isset($result[0])) {
            $wpdb->query("DELETE FROM $table_name WHERE id=" . $menu_id);
        }
        wp_send_json(array('error' => '0', 'msg' => esc_html__('menu deleted successfully.', 'wp-foodsearch')));
    }
    
    public function remove_food_menu_item() {
        $menu_id = $_POST['m_id'];
        $menu_item_id = $_POST['n_id'];

        global $table_prefix, $wpdb;
        
        // delete menu items
        $where = ' WHERE id=' . $menu_item_id . ' AND menu_id=' . $menu_id;
        $table_name = $table_prefix . 'menu_items';

        $result = $wpdb->get_results("SELECT * FROM $table_name$where");

        if (isset($result[0])) {
            $wpdb->query("DELETE FROM $table_name WHERE id=" . $menu_item_id);
        }
        wp_send_json(array('error' => '0', 'msg' => esc_html__('menu item deleted successfully.', 'wp-foodsearch')));
    }

    public function food_menu_list() {
        $where = '';
        if (isset($_REQUEST['q'])) {
            $where = ' where name like "%' . $_REQUEST['q'] . '%"';
        }
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menus';
        $results = $wpdb->get_results("SELECT * FROM $table_name$where limit 100");
        $responsedata = array('status' => 'error', 'results' => array());
        if (!empty($results)) {                        // Checking if $results have some values or not
            $responsedata['status'] = 'success';
            foreach ($results as $row) {
                $responsedata['results'][] = array('id' => $row->id, 'text' => $row->name);
            }
        }
        header('Content-type:application/json;charset=utf-8');
        echo json_encode($responsedata, true);
        die();
    }

    public function food_item_choicegroup_list() {
        $where = ' WHERE 1=1';
        if (isset($_REQUEST['q'])) {
            $where .= ' AND name like "%' . $_REQUEST['q'] . '%"';
        }
        if (isset($_REQUEST['restaurant']) && $_REQUEST['restaurant'] > 0) {
            $where .= ' AND restaurant_id="' . $_REQUEST['restaurant'] . '"';
        }
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menu_choice_group';

        $results = $wpdb->get_results("SELECT * FROM $table_name$where limit 100");
        $responsedata = array('status' => 'error', 'results' => array());
        if (!empty($results)) {
            $responsedata['status'] = 'success';
            foreach ($results as $row) {
                $responsedata['results'][] = array('id' => $row->id, 'text' => $row->name);
            }
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function get_food_items() {
        $where = ' WHERE 1=1';
        
        $restaurant_id = 0;
        if (isset($_REQUEST['restaurant']) && $_REQUEST['restaurant'] > 0) {
            $restaurant_id = $_REQUEST['restaurant'];
            $where .= " AND restaurant_id={$restaurant_id}";
        }
        
        if (isset($_REQUEST['q'])) {
            $where .= ' AND name like "%' . $_REQUEST['q'] . '%"';
        }
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menu_items';
        $results = $wpdb->get_results("SELECT * FROM $table_name$where limit 100");
        $responsedata = array('status' => 'error', 'results' => array());
        if (!empty($results)) { // Checking if $results have some values or not
            $responsedata['status'] = 'success';
            foreach ($results as $row) {
                $responsedata['results'][] = array('id' => $row->id, 'text' => $row->name, 'price' => $row->price);
            }
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function menuListByRestaurantID($request) {

        $where = '';
        $id = $request->get_param('id');
        if (isset($id)) {
            $where = ' where restaurant_id =' . $id;
        }
        
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menus';
        $sql = "SELECT * FROM $table_name$where";
        $results = $wpdb->get_results($sql);
        $responsedata = array('status' => 'error', 'results' => array());
        if (!empty($results)) {
            $responsedata['status'] = 'success';
            foreach ($results as $row) {
                $responsedata['results'][] = $row;
            }
        }
        echo json_encode($responsedata, true);
    }

    public function menuItemListByMenuID() {
        $where = '';
        if (isset($_REQUEST['id'])) {
            $where = ' where menu_id =' . $_REQUEST['id'];
        }
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menu_items';

        $sql = "SELECT * FROM $table_name$where";
        $results = $wpdb->get_results($sql);
        $responsedata = array('status' => 'error', 'results' => 'No Content Found');
        if (!empty($results)) {
            $responsedata['status'] = 'success';
            foreach ($results as $row) {
                $result[] = $row;
            }
            $responsedata['results'] = $result;
        }

        wp_send_json($responsedata);
        wp_die();
    }

    public function menuCategoriesByRestaurantID($request) {
        $where = '';
        $id = $request->get_param('id');
        if (isset($id)) {
            $where = ' where restaurant_id =' . $id;
        }
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menu_category';
        $results = $wpdb->get_results("SELECT * FROM $table_name$where");
        $responsedata = array('status' => 'error', 'results' => array());
        if (!empty($results)) { // Checking if $results have some values or not
            $responsedata['status'] = 'success';
            foreach ($results as $row) {
                $responsedata['results'][] = $row;
            }
        }
        wp_send_json($responsedata);
        wp_die();
    }

    public function addRestaurant() {
        $where = '';
        if (isset($_REQUEST['id'])) {
            $where = ' where restaurant_id =' . $_REQUEST['id'];
        }
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menu_items';
        $tablemenu_category = $table_prefix . 'menu_category';
        $results = $wpdb->get_results("SELECT * FROM $table_name where category_id IN (select id from $tablemenu_category$where)");
        $responsedata = array('status' => 'error', 'results' => array());
        if (!empty($results)) {                        // Checking if $results have some values or not
            $responsedata['status'] = 'success';
            foreach ($results as $row) {
                $responsedata['results'][] = $row;
            }
        }
        wp_send_json($responsedata);
        wp_die();
    }
    
    public function upload_fooditm_img() {
        
        $post_id = $_POST['n_id'];
        $user_id = $_POST['g_id'];
        
        $wp_upload_dir = wp_upload_dir();

        $upload_file = $_FILES['fds_fooditm_photo'];

        $test_uploaded_file = is_uploaded_file($upload_file['tmp_name']);

        require_once ABSPATH . 'wp-admin/includes/image.php';
        require_once ABSPATH . 'wp-admin/includes/file.php';
        require_once ABSPATH . 'wp-admin/includes/media.php';

        $allowed_image_types = array(
            'jpg|jpeg' => 'image/jpeg',
            'png' => 'image/png',
            'gif' => 'image/gif',
        );

        $status_upload = wp_handle_upload($upload_file, array('test_form' => false, 'mimes' => $allowed_image_types));

        if (empty($status_upload['error'])) {

            $image = wp_get_image_editor($status_upload['file']);

            if (!is_wp_error($image)) {

                $file_url = isset($status_upload['url']) ? $status_upload['url'] : '';

                $upload_file_path = $wp_upload_dir['path'] . '/' . basename($file_url);

                // Check the type of file. We'll use this as the 'post_mime_type'.
                $filetype = wp_check_filetype(basename($file_url), null);

                // Prepare an array of post data for the attachment.
                $attachment = array(
                    'guid' => $wp_upload_dir['url'] . '/' . basename($upload_file_path),
                    'post_mime_type' => $filetype['type'],
                    'post_title' => preg_replace('/\.[^.]+$/', '', ($upload_file['name'])),
                    'post_author' => $user_id,
                    'post_status' => 'inherit'
                );

                // Insert the attachment.
                $attach_id = wp_insert_attachment($attachment, $upload_file_path, $post_id);

                // Generate the metadata for the attachment, and update the database record.
                $attach_data = wp_generate_attachment_metadata($attach_id, $upload_file_path);
                wp_update_attachment_metadata($attach_id, $attach_data);

                $user_thumb_image = wp_get_attachment_image_src($attach_id, 'thumbnail');
                $img_url = isset($user_thumb_image[0]) && esc_url($user_thumb_image[0]) != '' ? $user_thumb_image[0] : '';

                wp_send_json(array('msg' => esc_html__('image uploaded successfully.', 'wp-foodsearch'), 'id' => $attach_id, 'img' => $img_url, 'error' => '0'));
            }
        }
        wp_send_json(array('msg' => esc_html__('there is some error in uploading this file.', 'wp-foodsearch'), 'error' => '1'));
    }

    public function resturantIdOnMenuID($id) {
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menus';
        $sql = "SELECT restaurant_id FROM $table_name where id=" . $id;
        $results = $wpdb->get_results($sql);
        return $results[0]->restaurant_id;
    }
    
    public function user_restaurant_add_favourite() {
        $user_id = $_POST['n_id'];
        $restaurant_id = $_POST['id'];
        $view = $_POST['view'];
        
        $common_functions = new Common_Functions;
        
        $customer_id = Common_Functions::user_customer_id($user_id);
        
        if ($customer_id > 0) {
            $is_restaurant_fav = Common_Functions::is_restaurant_fav_by_customer($customer_id, $restaurant_id);
            
            if (!$is_restaurant_fav) {
                $current_time = current_time('timestamp');
                $fav_list = get_post_meta($customer_id, 'foodsearch_favourite_restaurants', true);
                $fav_list = !empty($fav_list) ? $fav_list : array();
                $fav_list[] = array(
                    'id' => $restaurant_id,
                    'time' => $current_time
                );
                update_post_meta($customer_id, 'foodsearch_favourite_restaurants', $fav_list);

                //
                $fav_list = get_post_meta($restaurant_id, 'foodsearch_favourite_by_list', true);
                $fav_list = !empty($fav_list) ? $fav_list : array();
                $fav_list[] = array(
                    'id' => $customer_id,
                    'time' => $current_time
                );
                update_post_meta($restaurant_id, 'foodsearch_favourite_by_list', $fav_list);
            }
            
            if ($view == 'list') {
                $html = '<i class="fds-icon fds-heart-fill"></i>';
            } else {
                $html = '<i class="fds-icon fds-heart-fill"></i> ' . esc_html__('added to favourite', 'wp-foodsearch');
            }
            wp_send_json(array('msg' => esc_html__('added to favourites list.', 'wp-foodsearch'), 'error' => '0', 'html' => $html));
        }
        wp_send_json(array('msg' => esc_html__('only a customer can add restaurant in favourites list.', 'wp-foodsearch'), 'error' => '1'));
    }
    
    public function user_restaurant_remove_favourite() {
        $user_id = $_POST['n_id'];
        $restaurant_id = $_POST['id'];
        
        $common_functions = new Common_Functions;
        
        $customer_id = Common_Functions::user_customer_id($user_id);
        
        if ($customer_id > 0) {
            $fav_list = get_post_meta($customer_id, 'foodsearch_favourite_restaurants', true);
            if (!empty($fav_list)) {
                $filter_itms = [];
                foreach ($fav_list as $fav_itm) {
                    $post_id = $fav_itm['id'];
                    if ($post_id != $restaurant_id) {
                        $filter_itms[] = $fav_itm;
                    }
                }
                if (!empty($filter_itms)) {
                    update_post_meta($customer_id, 'foodsearch_favourite_restaurants', $filter_itms);
                } else {
                    update_post_meta($customer_id, 'foodsearch_favourite_restaurants', '');
                }
            }
            //
            $fav_list = get_post_meta($restaurant_id, 'foodsearch_favourite_by_list', true);
            if (!empty($fav_list)) {
                $filter_itms = [];
                foreach ($fav_list as $fav_itm) {
                    $post_id = $fav_itm['id'];
                    if ($post_id != $customer_id) {
                        $filter_itms[] = $fav_itm;
                    }
                }
                if (!empty($filter_itms)) {
                    update_post_meta($restaurant_id, 'foodsearch_favourite_by_list', $filter_itms);
                } else {
                    update_post_meta($restaurant_id, 'foodsearch_favourite_by_list', '');
                }
            }
            wp_send_json(array('msg' => esc_html__('removed from favourites list.', 'wp-foodsearch'), 'error' => '0'));
        }
        wp_send_json(array('msg' => esc_html__('you are not allowed.', 'wp-foodsearch'), 'error' => '1'));
    }
    
    public function select_search_users() {
        
        //
        global $table_prefix, $wpdb;
        
        $table_name = $table_prefix . 'users';
        $users_query = "SELECT * FROM $table_name";
        
        if (isset($_REQUEST['search']) && $_REQUEST['search'] != '') {
            $search_str = $_REQUEST['search'];
            $users_query .= " WHERE 1=1";
            $users_query .= " AND (ID='$search_str'";

            $users_query .= " OR user_email LIKE '%$search_str%'";
            $users_query .= " OR display_name LIKE '%$search_str%'";
            $users_query .= ")";
        }
        
        $users_query .= " ORDER BY display_name ASC LIMIT 100";
        
        $all_users = $wpdb->get_results($users_query);
        
        $responsedata = array('status' => 'error', 'results' => array());
        if (!empty($all_users)) { // Checking if $results have some values or not
            $responsedata['status'] = 'success';
            foreach ($all_users as $user) {
                $responsedata['results'][] = array('id' => $user->ID, 'text' => $user->display_name . ' (' . $user->user_email . ')');
            }
        }
        wp_send_json($responsedata);
        wp_die();
    }
    
    public function menu_item_export_template() {
        $menu_id = $_POST['menu_id'];
        $restaurant_id = $_POST['restaurant_id'];
        $menu_templates = Restaurant_Menu_Templates::export_menu_item_template($menu_id, $restaurant_id);
        
        if ($menu_templates) {
            wp_send_json(array('msg' => esc_html__('template exported successfully.', 'wp-foodsearch'), 'html' => esc_html__('template exported!', 'wp-foodsearch'), 'error' => '0'));
        }
        wp_send_json(array('msg' => esc_html__('no result found.', 'wp-foodsearch'), 'error' => '1'));
    }
    
    public function menu_item_import_template() {
        $menu_id = $_POST['menu_id'];
        $user_id = $_POST['n_id'];
        $restaurant_id = $_POST['restaurant_id'];
        $template_id = $_POST['temp_id'];
        $template_type = $_POST['temp_type'];
        
        $externl_folder = apply_filters('foodsearch_menu_template_extrnal_folder_path', '', $template_type);
        
        $import_template = Restaurant_Menu_Templates::import_menu_item_template($template_id, $menu_id, $restaurant_id, $externl_folder);
        
        if ($import_template) {
            wp_send_json(array('msg' => esc_html__('template imported successfully.', 'wp-foodsearch'), 'html' => esc_html__('template imported!', 'wp-foodsearch'), 'error' => '0'));
        }
        wp_send_json(array('msg' => esc_html__('no result found.', 'wp-foodsearch'), 'error' => '1'));
    }
    
    public function menu_item_templates_popup_html() {
        global $foodsearch_upload_files_extpath, $foodsearch_upload_subdir_extpath;

        $menu_id = $_POST['menu_id'];
        $user_id = $_POST['n_id'];
        
        $foodsearch_upload_files_extpath = 'templates';
        $foodsearch_upload_subdir_extpath = 'restaurant';

        $common_functions = new Common_Functions;
        
        if (isset($_POST['r_id']) && $_POST['r_id'] > 0) {
            $restaurant_id = $_POST['r_id'];
        } else {
            $restaurant_id = Common_Functions::user_restaurant_id($user_id);
        }
        
        $menu_templates_list = get_option('fds_menu_items_save_templates');
        
        $menu_templates_list = apply_filters('foodsearch_menu_items_save_templates_list', $menu_templates_list);
        
        $have_templates = false;
        
        ob_start();
        echo '<div class="fds-menu-templates-list">';
        if (!empty($menu_templates_list)) {
            
            uasort($menu_templates_list, function ($a, $b) {
                if ($a['time'] == $b['time']) {
                    $ret_val = 0;
                }
                $ret_val = ($b['time'] < $a['time']) ? -1 : 1;
                return $ret_val;
            });
            
            add_filter('upload_dir', 'foodsearch_public_upload_files_path');
            $wp_upload_dir = wp_upload_dir();
            $template_files_dir = $wp_upload_dir['path'] . '/restaurant-menu-templates';
            remove_filter('upload_dir', 'foodsearch_public_upload_files_path');
            
            $temp_counts = 1;
            foreach ($menu_templates_list as $template_id => $menu_template) {
                $custom_dir = '';
                $mian_dir = $template_files_dir;
                if (isset($menu_template['custom_dir'])) {
                    $mian_dir = $custom_dir = $menu_template['custom_dir'];
                }
                
                $temp_type = 'internal';
                if ($custom_dir != '') {
                    $temp_type = 'pre';
                }
                
                $template_folder = $mian_dir . '/' . $menu_template['template_folder'] . '/';

                $template_file = $template_folder . 'data.json';
                
                if (is_dir($template_folder) && file_exists($template_file)) {
                    $have_templates = true;
                    $template_name = $menu_template['name'];
                    $image_id = isset($menu_template['image_id']) ? $menu_template['image_id'] : '';
                    $template_datetime = $menu_template['formatted_time'];
                    ?>
                    <div class="fds-menu-template-itm">
                        <?php
                        $img_src = '';
                        $has_img = false;
                        ob_start();
                        if ($image_id != '' && $image = wp_get_attachment_image_src($image_id, 'full')) {
                            $has_img = true;
                            $img_src = $image[0];
                        }
                        if ($custom_dir != '') {
                            
                        }
                        if ($img_src != '') {
                            $has_img = true;
                            ?>
                            <img src="<?php echo ($img_src) ?>" alt="">
                            <?php
                        } else {
                            ?>
                            <i class="fds-icon fds-food-fire"></i>
                            <?php
                        }
                        $icon_html = ob_get_clean();
                        ?>
                        <div class="fds-template-icon-con<?php echo ($has_img ? ' fds-has-img' : '') ?>">
                            <?php echo ($icon_html) ?>
                        </div>
                        <?php
                        if ($img_src != '') {
                            ?>
                            <div class="fds-template-actbtns">
                                <a href="#" class="fds-preview-menu-template fds-link" data-target-img="<?php echo ($img_src) ?>" data-id="<?php echo ($menu_id) ?>" data-tid="<?php echo ($template_id) ?>" data-rid="<?php echo ($restaurant_id) ?>" data-nid="<?php echo ($user_id) ?>"><i class="fds-icon fds-eye-line"></i></a>
                            </div>
                            <?php
                        }
                        ?>
                        <div class="fds-template-import-con">
                            <a href="#" class="fds-import-menu-template fds-importin-food-template fds-update-anything-action fds-link" data-id="<?php echo ($menu_id) ?>" data-tid="<?php echo ($template_id) ?>" data-type="<?php echo ($temp_type) ?>" data-rid="<?php echo ($restaurant_id) ?>" data-nid="<?php echo ($user_id) ?>"><?php esc_html_e('import template', 'wp-foodsearch') ?></a>
                            <strong class="fds-template-name"><?php echo ($template_name) ?></strong>
                            <span class="fds-template-datetime" style="display:none;"><?php echo ($template_datetime) ?></span>
                        </div>
                    </div>
                    <?php
                    $temp_counts++;
                }
            }
        }
        
        if (!$have_templates) {
            ?>
            <div class="foodsearch-noitm-found">
                <img src="<?php echo foodsearch_plugin_get_url('assets/images/not-found.svg') ?>" alt="">
                <p><?php esc_html_e('no templates found.', 'wp-foodsearch') ?></p>
            </div>
            <?php
        }
        echo '</div>';
        
        $html = ob_get_clean();
        
        wp_send_json(array('html' => $html, 'error' => '0'));
    }
    
    public function menu_template_setting_popup_html() {
        $template_id = $_POST['temp_id'];
        
        $menu_templates_list = get_option('fds_menu_items_save_templates');
        
        ob_start();
        ?>
        <div class="fds-template-setins-inner-con">
            <div class="fds-booking-detail-title">
                <h2 class="fds-heading-title"><?php esc_html_e('template settings', 'wp-foodsearch') ?></h2>
            </div>
            <?php
            if (isset($menu_templates_list[$template_id])) {
                
                $menu_template = $menu_templates_list[$template_id];
                $template_name = $menu_template['name'];
                ?>
                <form id="menu-tmplate-settin-form" method="post">
                    <div class="fds-popupform-inner-wrap">
                        <input type="hidden" name="temp_id" value="<?php echo ($template_id) ?>">
                        <div class="fds-form-field">
                            <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('title *', 'wp-foodsearch') ?></label></div>
                            <input type="text" name="title" class="fds-input-style" value="<?php echo ($template_name) ?>" placeholder="<?php esc_html_e('title', 'wp-foodsearch') ?>" required="">
                        </div>
                        
                        <div class="fds-form-field">
                            <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('browse photo', 'wp-foodsearch') ?></label></div>
                            <div class="fds-popupform-file-upload image-upload">
                                <?php
                                $image_id = isset($menu_template['image_id']) ? $menu_template['image_id'] : '';

                                if ($image = wp_get_attachment_image_src($image_id, 'full')) {
                                    ?>
                                    <a href="#" class="fds-upload fds-link" style="background: url('<?php echo ($image[0]) ?>') no-repeat top center / cover; "></a>
                                    <a href="#" class="fds-remove fds-link"><i class="dashicons-before dashicons-no"></i></a>
                                    <input type="hidden" name="image" value="<?php echo ($image_id) ?>">
                                    <?php
                                } else {
                                    ?>                           
                                    <a href="#" class="fds-upload fds-link"><i class="fds-icon fds-camera"></i></a>
                                    <a href="#" class="fds-remove fds-link" style="display:none"><i class="dashicons-before dashicons-no"></i></a>
                                    <input type="hidden" name="image" value="">
                                    <?php
                                }
                                ?>
                            </div>
                        </div>
                    </div>
                    <div class="fds-add-newcat">
                        <?php
                        wp_nonce_field('save_menu_template_settings', '_nonce');
                        ?>
                        <div class="fds-btn fds-medium-btn">
                            <button class="fds-newcat-savebtn fds-has-save" type="submit"><?php esc_html_e('save settings', 'wp-foodsearch') ?></button>  
                        </div>
                    </div>
                </form>
                <?php
            } else {
                ?>
                <div class="foodsearch-noitm-found">
                    <img src="<?php echo foodsearch_plugin_get_url('assets/images/not-found.svg') ?>" alt="">
                    <p><?php esc_html_e('no templates found.', 'wp-foodsearch') ?></p>
                </div>
                <?php
            }
            ?>
        </div>
        <?php
        $html = ob_get_clean();
        
        wp_send_json(array('html' => $html, 'error' => '0'));
    }
    
    public function menu_template_setting_save() {
        if ($this->to_check_nonce()) {
            if (!isset($_POST['_nonce']) || !wp_verify_nonce($_POST['_nonce'], 'save_menu_template_settings')) {
                $response_data = array('error' => '1', 'msg' => esc_html__('session token has expired, please reload the page and try again.', 'wp-foodsearch'));
                wp_send_json($response_data);
            }
        }
        
        $title = foodsearch_esc_html($_POST['title']);
        $imge_id = foodsearch_esc_html($_POST['image']);
        $temp_id = $_POST['temp_id'];
        
        $menu_templates_list = get_option('fds_menu_items_save_templates');
        if (isset($menu_templates_list[$temp_id]) && $title != '') {
            $menu_templates_list[$temp_id]['name'] = $title;
            $menu_templates_list[$temp_id]['image_id'] = $imge_id;
            
            update_option('fds_menu_items_save_templates', $menu_templates_list);
        }
        
        $img_src = '';
        if ($imge_id != '' && $image = wp_get_attachment_image_src($imge_id, 'full')) {
            $img_src = $image[0];
        }
        
        wp_send_json(array('msg' => esc_html__('settings saved successfully.', 'wp-foodsearch'), 'id' => $temp_id, 'img' => $img_src, 'title' => $title, 'error' => '0'));
    }
    
    public function menu_template_remove_itm() {
        
        $temp_id = $_POST['t_id'];
        
        $menu_templates_list = get_option('fds_menu_items_save_templates');
        if (isset($menu_templates_list[$temp_id])) {
            unset($menu_templates_list[$temp_id]);
            update_option('fds_menu_items_save_templates', $menu_templates_list);
        }
        
        wp_send_json(array('msg' => esc_html__('template item deleted.', 'wp-foodsearch'), 'error' => '0'));
    }
    public function locationDateInsert(){
        global $wpdb,$table_prefix;
        $tblname = 'postmeta';
        $wp_track_table = $table_prefix . "$tblname";
        $sql = 'select post_id,meta_value from `'. $wp_track_table . '` where meta_key = "foodsearch_locations_list"';
       $results = $wpdb->get_results($sql,ARRAY_A);
      // echo 'results: <pre>'.print_r($results,true).'</pre>';
       foreach($results as $result){
        $data =  get_post_meta($result['post_id'],'foodsearch_locations_list');
        $foodsearch_locations_list[$result['post_id']] = $data[0];
       }
       foreach($foodsearch_locations_list as $key=>$posts){
        foreach($posts as $location){
            $tblname = 'fds_locations';
            $wp_track_table = $table_prefix . "$tblname";
            $detail = maybe_serialize($location);
            $sql = 'select id from `'. $wp_track_table . '` where post_id = '.$key;
            $dbCount = $wpdb->get_results($sql,ARRAY_A);
            $dbCount = count($dbCount);
            // echo '<br>'.count($posts);
            // exit();
            if(count($posts)>$dbCount){
            $wpdb->insert( $wp_track_table, array(
                'post_id' => $key,
                'lat' => $location['lat'],
                'lng' => $location['lng'],
                'detail' => $detail,
            ));
        }
           

        }
        
       }        
    }

}

new customApiHooks();

