<?php

/**
 * form fields class
 * html fields
 * @return object
 */
class FoodSearch_Form_Fields
{

    public $prefix;

    /**
     * consttruct function
     *
     * initialize
     */
    public function __construct()
    {
        $this->prefix = 'foodsearch_field_';
    }

    /**
     * input text field
     *
     * @return markup
     */
    public function input_field($params = array())
    {
      //  echo '<pre>'.print_r($params,true).'</pre>';
        extract($params);
        $prop_name = '';
        $prop_id = '';
        $prop_class = '';
        $prop_value = '';
        $prop_label = '';
        $prop_required = '';
        $prop_placeholder = '';
        $prop_min = '';
        $prop_max = '';
        $label_required = '';
        $steps = '';
        $prop_type = 'text';

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = " class=\"{$classes}\"";
        }
        if (isset($label) && $label != '') {
            $prop_label = "{$label}";
        }
        if (isset($placeholder) && $placeholder != '') {
            $prop_placeholder = " placeholder='{$placeholder}'";
        }
        if (isset($required) && $required != '') {
            $prop_required = " required";
            $label_required = '*';
        }
        if (isset($value) && $value != '') {           
            $value = foodsearch_esc_html($value);            
            $prop_value = " value=\"{$value}\"";
        }
        if (isset($type) && $type != '') {
            $prop_type = $type;
        }
        if (isset($min) && $min != '') {
            $prop_min = ' min="'.$min.'"';
        }
        if (isset($max) && $max != '') {
            $prop_max = ' max="'.$max.'"';
        }
        if (isset($type) && $type != '') {
            $prop_type = $type;
        }
       
        if (isset($step) && $step != '') {           
            $steps =' step="'.$step.'"';
        }
        //echo 'value: '.$value;
        $html = '';
        if($prop_type!='hidden' && $label !='') {
            $html .= '<div class="label_wrap wraps">';
            if (!empty($prop_label)) {
                $html .= ' <label class="fds-input-label">' . $prop_label . ' ' . $label_required . '</label>';
            }

            if (isset($field_desc) && $field_desc != '') {
                $html .= "<p class=\"field-description desc\"><small>{$field_desc}</small></p>";
            }
            $html .= '</div>';
        }
        $html .='<input type="'.$prop_type.'" '.$prop_id.$prop_name.$prop_class.$prop_value.$prop_min.$prop_max.$prop_placeholder.$prop_required.$steps.'>';



        if (isset($return) && $return === true) {
            return $html;
        } else {
            echo force_balance_tags($html);
        }
    }

    /**
     * textarea text field
     *
     * @return markup
     */
    public function textarea_field($params = array())
    {
        extract($params);

        $prop_name = '';
        $prop_id = '';
        $prop_class = '';
        $prop_value = '';
        $prop_label = '';
        $prop_required = '';
        $prop_placeholder = '';
        $label_required = '';

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = " class=\"{$classes}\"";
        }
        if (isset($label) && $label != '') {
            $prop_label = "{$label}";
        }
        if (isset($placeholder) && $placeholder != '') {
            $prop_placeholder = " placeholder='{$placeholder}'";
        }
        if (isset($required) && $required != '') {
            $prop_required = " required";
            $label_required = '*';
        }
        if (isset($value) && $value != '') {
            $value = foodsearch_esc_html($value);
            $prop_value = "{$value}";
        }

        $prop_value = foodsearch_esc_html($prop_value);
        $html ='<div class="label_wrap">';
        $html .= " <label class='fds-input-label'>".$prop_label." ".$label_required."</label>";
        if (isset($field_desc) && $field_desc != '') {
            $html .= "<p class=\"field-description\"><small>{$field_desc}</small></p>";
        }
        $html .='</div>';
        $html .= "<textarea {$prop_id}{$prop_name}{$prop_class} {$prop_required} {$prop_placeholder}>{$prop_value}</textarea>";

        if (isset($return) && $return === true) {
            return $html;
        } else {
            echo force_balance_tags($html);
        }
    }

    /**
     * Simple Checkbox Field
     *
     */
    public function checkbox_field($params = array())
    {
        extract($params);
        $prop_name = '';
        $prop_id = '';
        $prop_class = '';
        $prop_value = '';
        $prop_label = '';
        $prop_checked = '';
        $prop_required = '';
        $label_required = '';

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = " class=\"{$classes}\"";
        }
        if (isset($label) && $label != '') {
            $prop_label = "{$label}";
        }
        if (isset($required) && $required != '') {
            $prop_required = " required";
            $label_required = '*';
        }
        if (isset($value) && $value != '') {
            $value = foodsearch_esc_html($value);
            $prop_value = " value=\"{$value}\"";

        }
        if (isset($checked) && $checked == '1') {
            $prop_checked = " checked=\"checked\"";
        }
        $html = '<div class="label_wrap">';
        $html .= ' <label class="fds-input-label" for="'.$id.'"><input type="checkbox" '.$prop_id.$prop_name.$prop_class.$prop_checked.$prop_value.$prop_required.'>'.$prop_label.'</label>';
        if (isset($field_desc) && $field_desc != '') {
            $html .= "<p class=\"field-description\">{$field_desc}</p>";
        }
        $html .= '</div>';
        if (isset($return) && $return === true) {
            return $html;
        } else {
            echo force_balance_tags($html);
        }
    }

    /**
     * Simple Checkbox Field
     *
     */
    public function switch_field($params = array())
    {
        extract($params);
        $prop_name = '';
        $prop_id = '';
        $prop_class = '';
        $extra_attr = '';

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        
        if (isset($classes) && $classes != '') {
            $prop_class = ' ' . $classes;
        }
        if (isset($ext_attr) && $ext_attr != '') {
            $extra_attr = $ext_attr;
        }
        $prop_value = " value=\"{$value}\"";
        
        $label_on_txt = isset($label_on) && $label_on != '' ? $label_on : esc_html__('on', 'wp-foodsearch');
        $label_off_txt = isset($label_off) && $label_off != '' ? $label_off : esc_html__('off', 'wp-foodsearch');
        
        ob_start();
        
        if (isset($label) && $label != '') {
            ?>
            <div class="label_wrap"><label class="fds-input-label"><?php echo ($label) ?></label></div>
            <?php
        }
        ?>
        <label class="fds-switch fds-input-label">
            <input<?php echo ($prop_id) ?> type="checkbox" class="fds-settings-switch<?php echo ($prop_class) ?>"<?php echo ($extra_attr) ?><?php echo ($value == '1' ? ' checked' : '') ?>>
            <strong class="fds-switch-inn">
                <span class="fds-off-switch"><?php echo ($label_off_txt) ?></span>
                <span class="fds-on-switch"><?php echo ($label_on_txt) ?></span>
            </strong>
            <input type="hidden"<?php echo ($prop_name . $prop_value) ?>>
        </label>
        <?php
        $html = ob_get_clean();
        
        if (isset($return) && $return === true) {
            return $html;
        } else {
            echo force_balance_tags($html);
        }
    }
    
    public function switch2_field($params = array())
    {
        extract($params);
        $prop_name = '';
        $prop_id = '';
        $prop_checked = '';

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        if (isset($checked) && $checked == '1') {
            $prop_checked = " checked=\"checked\"";
        }

        $html =' <div class="label_wrap"><label>'.$label.'</label></div><div class="onoffswitch"><input type="checkbox" class="onoffswitch-checkbox" '.$prop_id.$prop_name.$prop_checked.'>';
        $html .= ' <label  class="onoffswitch-label" for="'.$id.'" ><span class="onoffswitch-inner"></span>
                                        <span class="onoffswitch-switch"></span></label>';
        $html .='</div>';
        if (isset($return) && $return === true) {
            return $html;
        } else {
            echo force_balance_tags($html);
        }
    }

    /**
     * input radio field
     *
     * @return markup
     */
    public function radio_field($params = array())
    {
        extract($params);
        $prop_name = '';
        $prop_id = '';
        $prop_class = '';
        $prop_value = '';
        $prop_label = '';
        $prop_required = '';

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = " class=\"{$classes}\"";
        }
        if (isset($label) && $label != '') {
            $prop_label = "{$label}";
        }
        if (isset($required) && $required != '') {
            $prop_required = " required";
        }
        if (isset($value) && $value != '') {
            $value = foodsearch_esc_html($value);
            $prop_value = " value=\"{$value}\"";
        }
        if ($value == 'on') {
            $prop_checked = " checked=\"checked\"";
        }
        $html = ' <label class="fds-input-label" for="'.$id.'" ><input type="radio" '.$prop_id.$prop_name.$prop_class.$prop_checked.$prop_value.$prop_required.'>'.esc_html__($prop_label, 'wp-foodsearch').'</label>';
        if (isset($field_desc) && $field_desc != '') {
            $html .= "<p class=\"field-description\">{$field_desc}</p>";
        }

        if (isset($return) && $return === true) {
            return $html;
        } else {
            echo force_balance_tags($html);
        }
    }

    /**
     * select option field
     *
     * @return markup
     */
    public function select_field($params = array())
    {
       
        extract($params);
        $prop_name = '';
        $prop_id = '';
        $prop_class = '';
        $prop_value = '';
        $prop_label = '';
        $prop_required = '';
        $p_type = '';
        $prop_type = '';
        $label_required = '';

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = " class=\"{$classes}\"";
        }
        if (isset($label) && $label != '') {
            $prop_label = "{$label}";
        }
        if (isset($required) && $required != '') {
            $prop_required = " required";
            $label_required = '*';
        }
        if (isset($placeholder) && $placeholder != '') {
            $prop_placeholder = foodsearch_esc_html($placeholder);
        }
        if (isset($value) && $value != '') {
            $prop_value = foodsearch_esc_html($value);
        }
        if (isset($type) && $type != '') {
            $prop_type = foodsearch_esc_html($type);
            if($prop_type=='multiple') {
                $p_type = 'multiple="multiple"';
            }
        }
        
        $placeholder_txt = isset($placeholder) ? $placeholder : esc_html__('select option', 'wp-foodsearch');
        
        $html ='<div class="label_wrap">';
        $html .= ' <label class="fds-input-label" for="'.$id.'" >'.$prop_label.' '.$label_required.'</label>';
        if (isset($field_desc) && $field_desc != '') {
            $html .= "<p class=\"field-description\"><small>{$field_desc}</small></p>";
        }
        $html .= '</div>';
        $html .= '<div class="fds-select-field' . ($prop_type == 'multiple' ? ' fds-multi-select' : '') . '">';
        $html .= "<select{$prop_id}{$prop_name} data-placeholder=\"{$placeholder_txt}\"{$prop_class}{$prop_required} {$p_type}>";
        if(!empty($prop_value)) {
            foreach ($prop_value as $opton_key => $prop_val) {
                $select = '';

                if ($prop_type == 'multiple') {
                    if (is_array($selected) && in_array($opton_key, $selected)) {
                        $select = ' selected="selected"';
                    }
                } else {
                    $select = $selected == $opton_key ? ' selected="selected"' : '';
                }
                $html .= "<option{$select} value=\"{$opton_key}\">{$prop_val}</option>" . "\n";
            }
        }
        $html .= "</select>";
        $html .= "</div>";

        if (isset($return) && $return === true) {
            return $html;
        }
        else {
            echo force_balance_tags($html);
        }
    }

    /**
     * image field
     *
     * @return markup
     */
    public function image_upload_field($params = array())
    {
        extract($params);

        global $post, $pagenow;

        $prop_name = '';
        $db_value = '';
        $prop_id = '';
        $prop_id_name = '';
        $prop_class = '';
        $prop_value = '';

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
            $prop_id_name = " name=\"{$id}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        if (isset($cus_id) && $cus_id != '') {
            $prop_id = " id=\"{$cus_id}\"";
        }
        if (isset($cus_name) && $cus_name != '') {
            $prop_name = " name=\"{$cus_name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = " class=\"{$classes}\"";
        }

        if (isset($std) && $std != '') {
            $value = $std;
            $prop_value = " value=\"{$value}\"";
        }
        if (isset($db_value)) {
            $value = $db_value;
            $prop_value = " value=\"{$value}\"";
        }
        if (isset($force_std) && $force_std != '') {
            $value = $force_std;
            $prop_value = " value=\"{$value}\"";
        }

        $image_display = $value == '' ? 'none' : 'block';

        $html = '
	<div id="' . $id . '-box" class="foodsearch-browse-med-image" style="display: ' . $image_display . ';">
            <a class="foodsearch-rem-media-b fds-link" data-id="' . $id . '"><i class="dashicons dashicons-no-alt"></i></a>
            <img id="' . $id . '-img" src="' . $value . '" alt="" />
        </div>';

        $html .= "<input type=\"hidden\"{$prop_id}{$prop_name}{$prop_class}{$prop_value} />";
        $html .= "<input type=\"button\" class=\"foodsearch-upload-media foodsearch-bk-btn\" {$prop_id_name} value=\"" . esc_html__('browse', 'wp-foodsearch') . "\" />";

        if (isset($field_desc) && $field_desc != '') {
            $html .= "<p class=\"field-description\">{$field_desc}</p>";
        }

        if (isset($return) && $return === true) {
            return $html;
        } else {
            echo force_balance_tags($html);
        }
    }

    /**
     * file upload field
     *
     * @return markup
     */
    public function button($params = array())
    {
        extract($params);
        $prop_name = '';
        $prop_id = '';
        $prop_class = '';
        $prop_value = '';

        if (isset($type) && $type != '') {
            $prop_type = " type=\"{$type}\"";
        }

        if (isset($id) && $id != '') {
            $prop_id = " id=\"{$id}\"";
        }
        if (isset($name) && $name != '') {
            $prop_name = " name=\"{$name}\"";
        }
        if (isset($classes) && $classes != '') {
            $prop_class = " class=\"{$classes}\"";
        }
        if (isset($value) && $value != '') {
            $prop_value = foodsearch_esc_html($value);
        }
        $html = '<button '.$prop_name.$prop_class.$prop_type.$prop_id.'>'.$prop_value.'</button>';

        if (isset($return) && $return === true) {
            return $html;
        } else {
            echo force_balance_tags($html);
        }
    }
    
    public function padding_margin($params = array()) {
        extract($params);
        
        $field_name = '';
        $main_id = '';
        
        if (isset($name)) {
            $field_name = $name;
        }
        
        if (isset($id)) {
            $main_id = ' id="' . $id . '"';
        }
        
        $multi_vals = isset($multiple) && $multiple === true ? '[]' : '';
        
        $pos_arr = array(
            'top' => esc_html(_x('top', 'Margin Padding Left', 'wp-foodsearch')),
            'right' => esc_html(_x('right', 'Margin Padding Left', 'wp-foodsearch')),
            'bottom' => esc_html(_x('bottom', 'Margin Padding Left', 'wp-foodsearch')),
            'left' => esc_html(_x('left', 'Margin Padding Left', 'wp-foodsearch')),
        );
        
        ob_start();
        ?>
        <div<?php echo ($main_id) ?> class="fds-csstyle-fields">
            <div class="fds-form-field">
                <div class="label_wrap fds-field-fullcalc"><label class="fds-input-label"><?php esc_html_e('padding', 'wp-foodsearch') ?></label></div>
                <?php
                foreach ($pos_arr as $pos_key => $pos_val) {
                    ?>
                    <div class="input_wrap fds-field-forthcalc">
                        <input type="number" name="<?php echo ($field_name) ?>[padding_<?php echo ($pos_key) ?>]<?php echo ($multi_vals) ?>" class="fds-input-style" value="<?php echo (isset($values['padding'][$pos_key]) ? $values['padding'][$pos_key] : '') ?>">
                        <span class="input-bottom-title"><?php echo ($pos_val) ?></span>
                    </div>
                    <?php
                }
                ?>
            </div>
            <div class="fds-form-field">
                <div class="label_wrap fds-field-fullcalc"><label class="fds-input-label"><?php esc_html_e('margin', 'wp-foodsearch') ?></label></div>
                <?php
                foreach ($pos_arr as $pos_key => $pos_val) {
                    ?>
                    <div class="input_wrap fds-field-forthcalc">
                        <input type="number" name="<?php echo ($field_name) ?>[margin_<?php echo ($pos_key) ?>]<?php echo ($multi_vals) ?>" class="fds-input-style" value="<?php echo (isset($values['margin'][$pos_key]) ? $values['margin'][$pos_key] : '') ?>">
                        <span class="input-bottom-title"><?php echo ($pos_val) ?></span>
                    </div>
                    <?php
                }
                ?>
            </div>
        </div>
        <?php
        $html = ob_get_clean();
        
        if (isset($return) && $return === true) {
            return $html;
        } else {
            echo force_balance_tags($html);
        }
    }
    
    public function color_pickr($params = array()) {
        extract($params);
        
        $field_name = '';
        $main_id = '';
        
        if (isset($name)) {
            $field_name = ' name="' . $name . '"';
        }
        
        if (isset($id)) {
            $main_id = ' id="' . $id . '"';
        }
        
        ob_start();
        ?>
        <div<?php echo ($main_id) ?> class="fds-pickr-containr">
            <div class="fds-pickr-selectr" data-colr="<?php echo (isset($value) ? $value : '') ?>"></div>
            <input type="hidden" class="fds-color-pickr"<?php echo ($field_name) ?> value="<?php echo (isset($value) ? $value : '') ?>">
        </div>
        <?php
        $html = ob_get_clean();
        
        if (isset($return) && $return === true) {
            return $html;
        } else {
            echo force_balance_tags($html);
        }
    }

}

global $foodsearch_form_fields;
$foodsearch_form_fields = new FoodSearch_Form_Fields();
