const { Button, ButtonGroup, PanelRow } = wp.components;
const { __ } = wp.i18n;
import { useState } from '@wordpress/element';
import { __experimentalNumberControl as NumberControl } from '@wordpress/components';

export const Margin = (props) => {
    const { setAttributes } = props;
    const [isMarginRes, setMarginRes] = useState("lg");
    const [isMarginLock, setMarginLock] = useState("false");
    var name = props.name;

    var marginArr = {
        "lg":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
        "md":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
        "sm":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
        "xs":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
    };

    const prepare_val = (index1, index2, val) => {
        marginArr.lg.unit = props.attr.lg.unit;
        marginArr.lg.top = props.attr.lg.top;
        marginArr.lg.right = props.attr.lg.right;
        marginArr.lg.bottom = props.attr.lg.bottom;
        marginArr.lg.left = props.attr.lg.left;
            marginArr.md.unit = props.attr.md.unit;
            marginArr.md.top = props.attr.md.top;
            marginArr.md.right = props.attr.md.right;
            marginArr.md.bottom = props.attr.md.bottom;
            marginArr.md.left = props.attr.md.left;
        marginArr.sm.unit = props.attr.sm.unit;
        marginArr.sm.top = props.attr.sm.top;
        marginArr.sm.right = props.attr.sm.right;
        marginArr.sm.bottom = props.attr.sm.bottom;
        marginArr.sm.left = props.attr.sm.left;
            marginArr.xs.unit = props.attr.xs.unit;
            marginArr.xs.top = props.attr.xs.top;
            marginArr.xs.right = props.attr.xs.right;
            marginArr.xs.bottom = props.attr.xs.bottom;
            marginArr.xs.left = props.attr.xs.left;
    
        marginArr[index1][index2] = val;

        if ( isMarginLock && !isNaN(val) ){
            if ( isMarginRes === "lg" ){
                marginArr.lg.top = val;
                marginArr.lg.right = val;
                marginArr.lg.bottom = val;
                marginArr.lg.left = val;
            }
            else if ( isMarginRes === "md" ){
                marginArr.md.top = val;
                marginArr.md.right = val;
                marginArr.md.bottom = val;
                marginArr.md.left = val;
            }
            else if ( isMarginRes === "sm" ){
                marginArr.sm.top = val;
                marginArr.sm.right = val;
                marginArr.sm.bottom = val;
                marginArr.sm.left = val;
            }
            else if ( isMarginRes === "xs" ){
                marginArr.xs.top = val;
                marginArr.xs.right = val;
                marginArr.xs.bottom = val;
                marginArr.xs.left = val;
            }
        }
    
        setAttributes( {[name]:marginArr} );
    }

    function foodsearch_cssMount() {
        var css = `
            #fds-block-` + props.block_id + ` .` + props.class + ` {
                margin: ` + props.attr.lg.top + ((props.attr.lg.top) ? props.attr.lg.unit : "0") + ` ` + props.attr.lg.right + ((props.attr.lg.right) ? props.attr.lg.unit : "0") + ` ` + props.attr.lg.bottom + ((props.attr.lg.bottom) ? props.attr.lg.unit : "0") + ` ` + props.attr.lg.left + ((props.attr.lg.left) ? props.attr.lg.unit : "0") + `;
            }
        `;
        var elem = document.getElementById('res-listing-' + props.block_id );
        elem.innerHTML = elem.innerHTML + css;
    }
    function foodsearch_html(val){
      return (
        <>
        <div className="fds-res-control">
            <ButtonGroup className="fds-res-unit">
                <Button variant="tertiary" label="Pixel" className={props.attr[val].unit == "px" ? "active" : ""} onClick={() => ( prepare_val(val, "unit", "px") )} >PX</Button>
                <Button variant="tertiary" label="EM" className={props.attr[val].unit == "em" ? "active" : ""} onClick={() => ( prepare_val(val, "unit", "em") )} >EM</Button>
                <Button variant="tertiary" label="Percent" className={props.attr[val].unit == "%" ? "active" : ""} onClick={() => ( prepare_val(val, "unit", "%") )} >%</Button>
            </ButtonGroup>
        </div>
        <div className="fds-res-control-input">
            <NumberControl label={__( 'top', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val(val, "top", newval) }} value={props.attr[val].top} />
            <NumberControl label={__( 'right', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val(val, "right", newval) }} value={props.attr[val].right} />
            <NumberControl label={__( 'bottom', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val(val, "bottom", newval) }} value={props.attr[val].bottom} />
            <NumberControl label={__( 'left', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val(val, "left", newval) }} value={props.attr[val].left} />
            <ButtonGroup>
                <Button variant="primary" className={isMarginLock ? "active" : ""} icon={isMarginLock ? "dashicons dashicons-admin-links" : "dashicons dashicons-admin-links"} onClick={() => ( setMarginLock(!isMarginLock) )} ></Button>
            </ButtonGroup>
        </div>
        </>
      )
    }

    return (
        <div className="responsive-row">
                <div className="fds-res-control">
                {__( 'margin', 'wp-foodsearch' )} 
                    {props.isRes == 1 &&
                        <ButtonGroup>
                            <Button variant="primary" label="Desktop" icon="dashicons dashicons-desktop" className={isMarginRes === "lg" ? "active" : ""} onClick={() => ( setMarginRes("lg") )} ></Button>
                            <Button variant="primary" label="Laptop" icon="dashicons dashicons-laptop" className={isMarginRes === "md" ? "active" : ""} onClick={() => ( setMarginRes("md") )} ></Button>
                            <Button variant="primary" label="Tablet" icon="dashicons dashicons-tablet" className={isMarginRes === "sm" ? "active" : ""} onClick={() => ( setMarginRes("sm") )} ></Button>
                            <Button variant="primary" label="Smartphone" icon="dashicons dashicons-smartphone" className={isMarginRes === "xs" ? "active" : ""} onClick={() => ( setMarginRes("xs") )} ></Button>
                        </ButtonGroup>
                    }
                </div>
                    {isMarginRes === "lg" && foodsearch_html("lg") }
                    {isMarginRes === "md" && foodsearch_html("md") }
                    {isMarginRes === "sm" && foodsearch_html("sm") }
                    {isMarginRes === "xs" && foodsearch_html("xs") }
            { foodsearch_cssMount() }
        </div>
)
}

export default Margin;