<?php

namespace FoodSearch;

class Icon_Picker {

    public function __construct() {
        
        add_action('wp_print_styles', array($this, 'front_icon_styles'), 9);
        add_action('admin_enqueue_scripts', [$this, 'register_script_styles'], 99);
    }

    public function register_script_styles() {
        wp_enqueue_style('foodsearch-iconpiker', foodsearch_plugin_get_url('modules/icon-picker/css/fonticonpicker.css'), array(), \FoodSearch_Plugin::get_version());
        
        require_once(ABSPATH . 'wp-admin/includes/file.php');
        WP_Filesystem();
        global $wp_filesystem;
        
        $icons_path = foodsearch_plugin_get_path('modules/icon-picker/icons');
        $icon_selection_folders = $wp_filesystem->dirlist($icons_path);
        $file_paths_arr = array();
        if (!empty($icon_selection_folders)) {
            wp_enqueue_style('foodsearch-fontawesome', foodsearch_plugin_get_url('modules/icon-picker/css/fontawesome.min.css'), array(), \FoodSearch_Plugin::get_version());
            foreach ($icon_selection_folders as $icons_foldr) {
                if (isset($icons_foldr['name'])) {
                    $file_paths_arr[] = foodsearch_plugin_get_url('modules/icon-picker/icons/' . $icons_foldr['name'] . '/selection.json');
                    wp_enqueue_style('foodsearch-icons-' . $icons_foldr['name'], foodsearch_plugin_get_url('modules/icon-picker/icons/' . $icons_foldr['name'] . '/style.css'), array(), \FoodSearch_Plugin::get_version());
                }
            }
        }
        
        wp_register_script('foodsearch-iconpiker', foodsearch_plugin_get_url('modules/icon-picker/js/fonticonpicker.min.js', __FILE__), array('jquery'), \FoodSearch_Plugin::get_version(), true);
        $script_str_arr = array(
            'selection_files' => (!empty($file_paths_arr) ? json_encode($file_paths_arr) : ''),
        );
        wp_localize_script('foodsearch-iconpiker', 'foodsearch_iconpiker_vars', $script_str_arr);
    }
    
    public static function enqueue_icons_style() {
        require_once(ABSPATH . 'wp-admin/includes/file.php');
        WP_Filesystem();
        global $wp_filesystem;
        
        $icons_path = foodsearch_plugin_get_path('modules/icon-picker/icons');
        $icon_selection_folders = $wp_filesystem->dirlist($icons_path);
        $file_paths_arr = array();
        if (!empty($icon_selection_folders)) {
            wp_enqueue_style('foodsearch-fontawesome');
            foreach ($icon_selection_folders as $icons_foldr) {
                if (isset($icons_foldr['name'])) {
                    wp_enqueue_style('foodsearch-icons-' . $icons_foldr['name']);
                }
            }
        }
    }

    public function front_icon_styles() {

        require_once(ABSPATH . 'wp-admin/includes/file.php');
        WP_Filesystem();
        global $wp_filesystem;
        
        $icons_path = foodsearch_plugin_get_path('modules/icon-picker/icons');
        $icon_selection_folders = $wp_filesystem->dirlist($icons_path);
        $file_paths_arr = array();
        if (!empty($icon_selection_folders)) {
            wp_enqueue_style('foodsearch-fontawesome', foodsearch_plugin_get_url('modules/icon-picker/css/fontawesome.min.css'), array(), \FoodSearch_Plugin::get_version());
            foreach ($icon_selection_folders as $icons_foldr) {
                if (isset($icons_foldr['name'])) {
                    $file_paths_arr[] = foodsearch_plugin_get_url('modules/icon-picker/icons/' . $icons_foldr['name'] . '/selection.json');
                    wp_enqueue_style('foodsearch-icons-' . $icons_foldr['name'], foodsearch_plugin_get_url('modules/icon-picker/icons/' . $icons_foldr['name'] . '/style.css'), array(), \FoodSearch_Plugin::get_version());
                }
            }
        }
    }

}

new Icon_Picker();
